2024-11-06  Werner Koch  <wk@gnupg.org>

	Release 1.24.0.
	+ commit 98b10fbc63b323a146e66a2ea8f7ff8f216b31d7


2024-11-05  Werner Koch  <wk@gnupg.org>

	Include the full commit id.
	+ commit 0ad30e670aecce24eb1e59854d8f639ceb4009a6
	* autogen.sh: Update to version 2024-07-04 from libgpg-error.
	* configure.ac (BUILD_COMMITID): New.  Append to VERSION file.
	* src/version.c (cright_blurb): Use BUILD_COMMITID here.

2024-10-29  Werner Koch  <wk@gnupg.org>

	core: New context flags "known-notations".
	+ commit a304ec0ede937e21df5b4a311cbaf8d89f13ef59
	* src/gpgme.c (gpgme_set_ctx_flag): Add "known-notations".
	(gpgme_get_ctx_flag): Ditto.
	(gpgme_release): Free variable.
	* src/context.h (struct gpgme_context): Add "known_notations".

	* src/engine-gpg.c (struct engine_gpg): Add "known_notations".
	(gpg_release): Free variable.
	(gpg_set_engine_flags): Set variable.
	(add_known_notations): New.
	(gpg_decrypt, gpg_verify): Call function.

	* tests/run-decrypt.c (main): Add option --known-notations.
	* tests/run-verify.c (main): Ditto.

	core: Add new helper _gpgme_strtokenize.
	+ commit c835676f7dfe39830d5b0500ad2cb809832428d1
	* src/conversion.c (spacep): New.
	(_gpgme_strtokenize): New.

2024-10-23  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Fix typo.
	+ commit e656e51d535cdce2db3e1a4848029a2410c30108
	* lang/qt/src/Makefile.am (camelcase_headers): Fix typo in header name.

	qt: Put attributes before declarations.
	+ commit 7d02ba8a9308b25140f6d1b9a5ad5c14f0b36374
	* lang/qt/src/downloadjob.h (DownloadJob::start): Move QGPGME_DEPRECATED
	before the whole function declaration.

	cpp: Put attributes before declarations.
	+ commit c4b39a77950b3b737de06eca044b35a845fc6299
	* lang/cpp/src/key.h (UserID::Signature::Notation): Move
	GPGMEPP_DEPRECATED before the whole typedef declaration.
	* lang/cpp/src/verificationresult.h (Signature::Notation): Ditto.

	cpp: Add/change some includes.
	+ commit bff4b847fc6361c6027afc1e8c78aa7580e2a27c
	* lang/cpp/src/gpgaddexistingsubkeyeditinteractor.h,
	lang/cpp/src/gpgrevokekeyeditinteractor.h: Include <string>.
	* lang/cpp/src/key.h: Include <ctime> instead of <sys/time.h>.

2024-10-21  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Add support for new flag fields beta_compliance.
	+ commit 2a0595906970505debf64e166b9a35cccbf1b424
	* lang/cpp/src/decryptionresult.cpp, lang/cpp/src/decryptionresult.h
	(class DecryptionResult): Add method isBetaCompliance.
	* lang/cpp/src/decryptionresult.cpp (operator<<): Add new flag.
	* lang/cpp/src/key.cpp, lang/cpp/src/key.h (class Key): Add method
	isBetaCompliance.
	(class Subkey): Add method isBetaCompliance.
	* lang/cpp/src/key.cpp:
	(Key::isDeVs): Remove duplicate check of is_de_vs of first subkey.
	(operator<<): Add new flag.
	* lang/cpp/src/verificationresult.cpp, lang/cpp/src/verificationresult.h
	(class Signature): Add method isBetaCompliance.
	* lang/cpp/src/verificationresult.cpp (operator<<): Add new flag.

2024-10-09  Tobias Fella  <tobias.fella@gnupg.com>

	core: fix passing --proc-all-sigs to gpgtar.
	+ commit 227c9c763b30072e9a58bbbe7f66056aa966378f
	* src/engine-gpg.c: Pass --gpg-args before passing --proc-all-sigs
	  if using gpgtar

2024-10-07  Werner Koch  <wk@gnupg.org>

	core: New flag fields beta_compliance.
	+ commit 1a7bc88ee756df127761c90a4b66d885f0c9de74
	* src/gpgme.h.in (struct _gpgme_subkey): Add field beta_compliance.
	(struct _gpgme_op_decrypt_result): Ditto.
	(struct _gpgme_signature): Ditto.
	* src/util.h (PARSE_COMPLIANCE_FLAGS): Handle the new 2023 value.
	* tests/run-decrypt.c: Append a "(beta)" to the vs-de compliance.
	* tests/run-keylist.c: Ditto.
	* tests/run-verify.c: Ditto.

2024-09-26  Werner Koch  <wk@gnupg.org>

	core: Allow GPGME_CREATE_ADSK also for gnupg 2.2.45.
	+ commit 3bf1ea97bcabac31d29f17320cdad2f75f759435
	* src/engine-gpg.c (gpg_addadsk): Extend the version check.

2024-09-20  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Report failed encryption/signing if gpgtar didn't emit SUCCESS.
	+ commit 79ca846993638de359936f86eafaa23f75c9f85d
	src/encrypt-sign.c (encrypt_sym_status_handler): Add call of
	_gpgme_encrypt_status_handler.
	(encrypt_sign_start): Call _gpgme_op_encrypt_init_result with
	success_required=1 if archive is created. Always call
	_gpgme_op_sign_init_result with success_required=0 because the encrypt
	status handler already checks for SUCCESS.
	src/encrypt.c (op_data_t): Add success_seen flag.
	(_gpgme_encrypt_status_handler): Return error if we didn't see a
	required SUCCESS on GPGME_STATUS_EOF. Set success_seen flag on
	GPGME_STATUS_SUCCESS.
	(encrypt_sym_status_handler): Add call of _gpgme_encrypt_status_handler.
	(_gpgme_op_encrypt_init_result): Add argument success_required. Set
	success_seen flag if SUCCESS is not required.
	(encrypt_start): Call _gpgme_op_encrypt_init_result with
	success_required=1 if archive is created.
	src/ops.h (_gpgme_op_sign_init_result, _gpgme_op_encrypt_init_result):
	Add argument success_required to prototypes.
	src/sign.c (op_data_t): Add success_seen flag.
	(_gpgme_sign_status_handler): Return error if we didn't see a
	required SUCCESS on GPGME_STATUS_EOF. Set success_seen flag on
	GPGME_STATUS_SUCCESS.
	(sign_init_result): Add argument success_required. Set success_seen
	flag if SUCCESS is not required.
	(_gpgme_op_sign_init_result): Add argument success_required and
	forward it to sign_init_result.
	(sign_start): Call sign_init_result with success_required=1 if archive
	is created.

2024-09-17  Ingo Klöcker  <dev@ingo-kloecker.de>

	doc,build: Look for yat2m in $prefix/bin.
	+ commit 9747f189620a4c89f88f50c5960baa511eea0a97
	* configure.ac: Look for yat2m first in $prefix/bin and then in $PATH.

	doc,build: Fix "make install" if yat2m isn't available.
	+ commit e4b04ae15363ee8b2159dbc2586fbf93792598f6
	* configure.ac: Add hint for YAT2M variable. Set HAVE_YAT2M if yat2m was
	found.
	* doc/Makefile.am (myman_pages): Set to empty string if yat2m isn't
	available

2024-09-10  Sébastien Noel  <sebastien@twolife.be>

	doc: Provide a man page for gpgme-json.
	+ commit 8e7f443045f8e77bb5c841c2b7bfe2e1e3fcceb9
	* doc/gpgme-json.texi: New.
	* configure.ac: Check for yat2m.
	* doc/Makefile.am (YAT2M_OPTIONS): New.  Also add all the other man
	page stuff similar to what is used in gnupg.

2024-09-09  Werner Koch  <wk@gnupg.org>

	core: New encryption flags GPGME_ENCRYPT_ADD_RECP and _CHG_RECP.
	+ commit cd79fc39736fda6ce38f1f79700cf658c47372f9
	* src/gpgme.h.in (GPGME_ENCRYPT_ADD_RECP, GPGME_ENCRYPT_CHG_RECP):
	New flag values.
	* src/engine-gpg.c (have_cmd_modify_recipients): New.
	(gpg_encrypt): Check availability of the feature and prepare command.

	* tests/run-encrypt.c (main): New options --add-recipients
	and --change-recipients.

2024-09-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Treat email-only user IDs with upper case letters as email address
	+ commit 2264b64b85e6d522fdc5e06d5260f5b7b5414417
	* src/key.c (_gpgme_key_append_name): Support email-only user IDs with
	upper case letters.

	* tests/gpg/t-keylist.c (struct key_info_s): Add algo, length, sec_algo,
	sec_length.
	(keys): Add expected algo and length for primary and secondary subkeys.
	(main): Factor out code for checking a key and the code for the keylist
	test. Call the factored out test function and a new test function.
	(check_key, test_keylist, key_with_email_only_user_id,
	key_info_email_only_user_id,
	test_email_only_user_id_with_upper_case_letters): New.

2024-09-02  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,python: Fix build with setuptools 72.2.0+
	+ commit ecd0c86d62351d267bdc9566286c532a394c711b
	* lang/python/setup.py.in (BuildExtFirstHack.run): Extend members of the
	extension instead of lists that were passed to the extension.

2024-08-29  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Add pkgconfig file for gpgmepp.
	+ commit 569348ee84068ade5e05902dd9d670a1a30c7ca1
	* configure.ac: Add substitutions GPGMEPP_PKGCONFIG_LIBS,
	GPGMEPP_PKGCONFIG_CFLAGS, GPGMEPP_PKGCONFIG_HOST. Apply them. Configure
	gpgmepp.pc file.
	* lang/cpp/src/Makefile.am (pkgconfigdir, pkgconfig_DATA): New.
	(EXTRA_DIST): Add gpgmepp.pc.in.
	* lang/cpp/src/gpgmepp.pc.in: New.

2024-08-28  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Go with default answer on unknown question by key edit interface.
	+ commit 7579c40124c9b287bb67e974bda46e879e1a1ab1
	* lang/cpp/src/editinteractor.cpp (edit_interactor_callback_impl):
	Send empty string to edit interface if General Error occurred.

2024-08-26  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add support for new context flag "proc-all-sigs"
	+ commit 409e314582273be36b9b6516e89f142f2e99e682
	* lang/qt/src/decryptverifyarchivejob.cpp,
	lang/qt/src/decryptverifyarchivejob.h (DecryptVerifyArchiveJob): Add
	member functions setProcessAllSignatures, processAllSignatures.
	* lang/qt/src/decryptverifyarchivejob_p.h
	(DecryptVerifyArchiveJobPrivate): Add member m_processAllSignatures.
	* lang/qt/src/decryptverifyjob.cpp, lang/qt/src/decryptverifyjob.h
	(DecryptVerifyJob): Add member functions setProcessAllSignatures,
	processAllSignatures.
	* lang/qt/src/decryptverifyjob_p.h (DecryptVerifyJobPrivate): Add member
	m_processAllSignatures.
	* lang/qt/src/qgpgmedecryptverifyarchivejob.cpp
	(decrypt_verify_from_file_name): Add argument "processAllSignatures".
	Set context flag "proc-all-sigs" if requested.
	(QGpgMEDecryptVerifyArchiveJob::start): Set context flag "proc-all-sigs"
	if requested.
	(QGpgMEDecryptVerifyArchiveJobPrivate::startIt): Pass
	m_processAllSignatures to decrypt_verify_from_file_name.
	* lang/qt/src/qgpgmedecryptverifyjob.cpp
	(decrypt_verify_from_filename): Add argument "processAllSignatures".
	Set context flag "proc-all-sigs" if requested.
	(QGpgMEDecryptVerifyJob::start, QGpgMEDecryptVerifyJob::exec): Set
	context flag "proc-all-sigs" if requested.
	(QGpgMEDecryptVerifyJobPrivate::startIt): Pass
	m_processAllSignatures to decrypt_verify_from_filename.
	* lang/qt/src/qgpgmeverifydetachedjob.cpp (verify_from_filename): Add
	argument "processAllSignatures". Set context flag "proc-all-sigs" if
	requested.
	(QGpgMEVerifyDetachedJob::start, QGpgMEVerifyDetachedJob::exec): Set
	context flag "proc-all-sigs" if requested.
	(QGpgMEVerifyDetachedJobPrivate::startIt): Pass
	m_processAllSignatures to decrypt_verify_from_filename.
	* lang/qt/src/qgpgmeverifyopaquejob.cpp (verify_from_filename): Add
	argument "processAllSignatures". Set context flag "proc-all-sigs" if
	requested.
	(QGpgMEVerifyOpaqueJob::start, QGpgMEVerifyOpaqueJob::exec): Set
	context flag "proc-all-sigs" if requested.
	(QGpgMEVerifyOpaqueJobPrivate::startIt): Pass
	m_processAllSignatures to decrypt_verify_from_filename.
	* lang/qt/src/verifydetachedjob.cpp, lang/qt/src/verifydetachedjob.h
	(VerifyDetachedJob): Add member functions setProcessAllSignatures,
	processAllSignatures.
	* lang/qt/src/verifydetachedjob_p.h (VerifyDetachedJobPrivate): Add
	member m_processAllSignatures.
	* lang/qt/src/verifyopaquejob.cpp, lang/qt/src/verifyopaquejob.h
	(VerifyOpaqueJob): Add member functions setProcessAllSignatures,
	processAllSignatures.
	* lang/qt/src/verifyopaquejob_p.h (VerifyOpaqueJobPrivate): Add
	member m_processAllSignatures.

	* lang/qt/tests/run-decryptverifyarchivejob.cpp,
	lang/qt/tests/run-decryptverifyjob.cpp,
	lang/qt/tests/run-verifydetachedjob.cpp,
	lang/qt/tests/run-verifyopaquejob.cpp (struct CommandLineOptions): Add
	member processAllSignatures.
	(parseCommandLine): Add command line option --process-all-signatures.
	(main): Pass new option to the job.

2024-08-23  Werner Koch  <wk@gnupg.org>

	New context flag "proc-all-sigs".
	+ commit 37aa9eee7c5696c7b79898a33f9c2883962c2a88
	* src/context.h (struct gpgme_context): Add proc_all_sigs.
	* src/gpgme.c (gpgme_set_ctx_flag): Add flag "proc-all-sigs".
	(gpgme_get_ctx_flag): Ditto.
	* src/engine-gpg.c (engine.gpg): Add flags.proc_all_sigs.
	(have_option_proc_all_sigs): New.
	(gpg_set_engine_flags): Set flag from context.
	(build_argv): Add --proc-all-sigs if requested and supported.

2024-08-07  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt,tests: Add make target to clean the keyring.
	+ commit 0174575c8c169cd00f65ed509d91355dea26995f
	* lang/qt/tests/Makefile.am (clean-keyring): New target.

	qt: Use --quick-set-ownertrust if available.
	+ commit a73eee3655e21c60cbc572216a8a90eff5ac6ea5
	* lang/qt/src/qgpgmechangeownertrustjob.cpp (set_owner_trust): New.
	(QGpgMEChangeOwnerTrustJob::start): Use set_owner_trust if gpg is new
	enough.

	* lang/qt/tests/t-ownertrust.cpp
	(ChangeOwnerTrustTest::testChangeOwnerTrust): Log unexpected error.

	tests,json: Remove no longer needed code.
	+ commit 668a1344c6b230c6a205f5cf56c8ffc0c1ee9287
	* tests/json/t-json.c (parse_version_number, parse_version_string,
	compare_versions, check_gpg_version): Remove.
	(main): Use have_gpg_version from t-support.h.

	qt: Support disabling and enabling of keys.
	+ commit 63822343dfaac8b638ef475d441c4379da3a9804
	* lang/qt/src/Makefile.am: Add new files.
	* lang/qt/src/job.cpp (QuickJob): Move definition of constructor and
	destructor and inclusion of the moc file to quickjob.cpp.
	* lang/qt/src/qgpgmequickjob.cpp (class QGpgMEQuickJobPrivate): New.
	(QGpgMEQuickJob::QGpgMEQuickJob): Instantiate private job class.
	(set_key_enabled): New.
	* lang/qt/src/quickjob.cpp: New.
	* lang/qt/src/quickjob.h (class QuickJob): Add member function
	startSetKeyEnabled.
	* lang/qt/src/quickjob_p.h: New.

	* lang/qt/tests/Makefile.am: Add new test for Qt 5 and Qt 6.
	* lang/qt/tests/t-disablekey.cpp: New.

2024-08-06  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Add support for setting owner trust and for disabling keys.
	+ commit d5f612e9685d18313d445799a19ff83e013f1b0a
	* lang/cpp/src/context.cpp, lang/cpp/src/context.h (class Context): Add
	member functions setOwnerTrust, startSetOwnerTrust, setKeyEnabled,
	startSetKeyEnabled.
	* lang/cpp/src/context.cpp (owner_trust_to_string): New.

	core: New function gpgme_op_setownertrust.
	+ commit d804a7a4bc871f38f6cdc2cd63af3ef004580437
	* src/Makefile.am (main_sources): Add new file.
	* src/context.h (ctx_op_data_id_t): Add OPDATA_SETOWNERTRUST.
	* src/engine.c, src/engine.h (_gpgme_engine_op_setownertrust): New.
	* src/engine-backend.h (engine_ops): Add 'setownertrust' and adjust all
	engine initializers.
	* src/engine-gpg.c (gpg_setownertrust): New.
	(_gpgme_engine_ops_gpg): Set setownertrust to gpg_setownertrust.
	* src/gpgme.h.in (gpgme_op_setownertrust_start, gpgme_op_setownertrust):
	New.
	* src/gpgme.def, src/libgpgme.vers: Add new functions.
	* src/setownertrust.c: New.

	* doc/gpgme.texi: Document new functions.

	* tests/Makefile.am (noinst_PROGRAMS): Add new test program.
	* tests/run-setownertrust.c: New.

	* tests/gpg/Makefile.am (c_tests): Add new file. (LDADD): Add
	@GPG_ERROR_LIBS@.
	* tests/gpg/t-setownertrust.c: New.
	* tests/gpg/t-support.h (have_gpg_version): New.

2024-08-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	w32: Use UTF-8 for localized error descriptions for all threads.
	+ commit 9272b0fb6ebc245a37c74e02f1de00dc1ec99723
	* src/version.c (do_subsystem_inits) [W32]: Switch gettext to UTF-8
	for current thread and all new threads.

2024-07-22  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,qt: Fix include path in CMake files.
	+ commit 5c095553e4344fba63bbf684b2468e36a7b891e8
	* lang/qt/src/Makefile.am (QGpgmeConfig.cmake, QGpgmeQt6Config.cmake):
	Use new variables includeprefix{5,6} instead of replaced variable
	includeprefix.

2024-07-18  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,qt: Don't put generated camel-case headers in tarball.
	+ commit 9ab2ce36f9b9f510d58c2dd9946cd360c963976b
	* lang/qt/src/Makefile.am: Change camelcase5include_HEADERS to
	nodist_camelcase5include_HEADERS. Change camelcase6include_HEADERS to
	nodist_camelcase6include_HEADERS.

	core: Remove obsolete source files.
	+ commit c69240c843f2b80f47cad97b8ba3b314e104b959
	* src/isascii.c, src/putc_unlocked.c: Remove.

	build,qt: Allow building Qt 5 bindings and Qt 6 bindings.
	+ commit 42e151b34ba1e8c07b1ed2e4e1f6299466e499a1
	* configure.ac: Remove "qt" from default_languages. Add "qt5 qt6" to
	default_languages. Remove "qt" from help for --enable-languages. Don't
	fail anymore if "qt5" and "qt6" are enabled. Warn that "qt" is
	deprecated if it was enabled.
	* lang/qt/src/Makefile.am (libqgpgme_la, libqgpgmeqt6_la): New.
	(lib_LTLIBRARIES): Set Qt 5 and/or Qt 6 variant of libqgpgme.
	(AM_CPPFLAGS): Replace with libqgpgme_la_CPPFLAGS for Qt 5 and
	libqgpgmeqt6_la_CPPFLAGS for Qt 6.

	build,qt: Decouple generation of moc files.
	+ commit e6830b58b6de6d4fa02f1055cd0e992c9310b51a
	* m4/qt5.m4: Export moc for Qt 5 in variable MOC5. Unset temporary MOC2.
	* m4/qt6.m4: Export moc for Qt 6 in variable MOC6.
	* lang/qt/src/Makefile.am: Generate .moc5 files from .h files. Generate
	.moc forwarding headers in moc5 subfolder. Add moc5 subfolder to include
	paths for Qt 5-based qgpgme library. Ditto for Qt 6. Clean up moc5 and
	moc6 subfolders.
	* lang/qt/tests/Makefile.am: List tests and test runners for Qt 5 and
	Qt 6. Generate .moc5 files from .cpp files of tests. Generate .moc
	forwarding headers in moc5 subfolder. Generate .hmoc file from
	t-support.h directly in moc5 subfolder. Add moc5 subfolder to include
	paths for all Qt 5-based tests and runners. Ditto for Qt 6. Specify
	sources, LDADD and CPPFLAGS for all tests and test runners for Qt 5 and
	Qt 6. Clean up moc5 and moc6 subfolders.

	build,qt: Remove include directories on uninstall.
	+ commit 899a572b335528aabb769e5832318b0a3e910d08
	* lang/qt/src/Makefile.am (uninstall-include-dirs-qt5,
	uninstall-include-dirs-qt6): New targets.
	(uninstall_include_dirs_qt5, uninstall_include_dirs_qt6): New variables.
	(uninstall-local): Replace with...
	(uninstall-hook): ...this. Add new uninstall_include_dirs_qt* variables.

	build,qt: Decouple handling of include headers.
	+ commit 69558f2c0bede869a1caec70b2046a5138043c32
	* lang/qt/src/Makefile.am (includeprefix): Replace with...
	(includeprefix5, includeprefix6): ...these.
	(qgpgmeincludedir): Replace with...
	(qgpgme5includedir, qgpgme6includedir): ...these.
	(qgpgmeinclude_HEADERS): Replace with...
	(qgpgme5include_HEADERS, qgpgme6include_HEADERS): ...these.
	(nodist_qgpgmeinclude_HEADERS): Replace with...
	(nodist_qgpgme5include_HEADERS, nodist_qgpgme6include_HEADERS): ..these.
	(camelcaseincludedir): Replace with...
	(camelcase5includedir, camelcase6includedir): ...these.
	(camelcaseinclude_HEADERS): Replace with...
	(camelcase5include_HEADERS, camelcase6include_HEADERS): ...these.

	build,qt: Decouple (un)install of CMake files.
	+ commit 576d2db9dd9b7c66686e239ff61ffca606ad9f2a
	* lang/qt/src/Makefile.am (install-cmake-files): Rename target to
	install-cmake-files-qt5 and install-cmake-files-qt6.
	(uninstall-cmake-files): Rename target to uninstall-cmake-files-qt5 and
	uninstall-cmake-files-qt6.
	(install_cmake_files_qt5, uninstall_cmake_files_qt5,
	install_cmake_files_qt6, uninstall_cmake_files_qt6): New variables.
	(install-data-local): Depend on both install-cmake-files-qt* targets.
	(uninstall-local): Depend on both uninstall-cmake-files-qt* targets.

2024-07-15  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Support all keylist modes and fix possible overrun.
	+ commit aa15a664b3cf9bf578ba6d22c1c0c327af68b1b4
	* src/gpgme-tool.c (gt_get_keylist_mode): Increase NR_KEYLIST_MODES to
	number of keylist modes. Add support for GPGME_KEYLIST_MODE_WITH_TOFU,
	GPGME_KEYLIST_MODE_WITH_KEYGRIP, GPGME_KEYLIST_MODE_WITH_V5FPR. Write
	all modes.
	(hlp_keylist_mode): List all supported keylist modes.
	(cmd_keylist_mode): Add support for GPGME_KEYLIST_MODE_WITH_TOFU,
	GPGME_KEYLIST_MODE_WITH_KEYGRIP, GPGME_KEYLIST_MODE_WITH_V5FPR.

2024-07-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,cpp: Fix include paths in forwarding headers in gpgme++ folder.
	+ commit e46748a0d18b8a6d26e6b386f64a99a5cdc6a6e3
	* lang/cpp/src/Makefile.am (build rule for copied headers): Write
	abs_srcdir instead of srcdir in the generated headers.

2024-07-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Replace usage of deprecated Error::asString.
	+ commit f6d020e24fb64cfba5e80cef7f80cad15f08cc3c
	* lang/qt/src/debug.cpp (operator<<): Use Error::asStdString instead of
	Error::asString.
	* lang/qt/src/qgpgmedecryptverifyjob.cpp (decrypt_verify),
	lang/qt/src/qgpgmenewcryptoconfig.cpp
	(QGpgMENewCryptoConfigComponent::sync),
	lang/qt/src/qgpgmewkdlookupjob.cpp (startDirmngr): Use QDebug operator
	for Error instead of Error::asString.
	* lang/qt/src/threadedjobmixin.cpp (_detail::audit_log_as_html): Use
	errorAsString instead of Error::asString.
	* lang/qt/src/util.h (errorAsString): New.

	* lang/qt/tests/run-decryptverifyarchivejob.cpp (main),
	lang/qt/tests/run-decryptverifyjob.cpp (main),
	lang/qt/tests/run-encryptarchivejob.cpp (main),
	lang/qt/tests/run-encryptjob.cpp (main),
	lang/qt/tests/run-exportjob.cpp (main),
	lang/qt/tests/run-importjob.cpp (main),
	lang/qt/tests/run-receivekeysjob.cpp (main),
	lang/qt/tests/run-refreshkeysjob.cpp (main),
	lang/qt/tests/run-signarchivejob.cpp (main),
	lang/qt/tests/run-signjob.cpp (main),
	lang/qt/tests/run-verifydetachedjob.cpp (main),
	lang/qt/tests/run-verifyopaquejob.cpp (main),
	lang/qt/tests/run-wkdrefreshjob.cpp (main),
	lang/qt/tests/t-ownertrust.cpp (testChangeOwnerTrust),
	lang/qt/tests/t-remarks.cpp (testRemarkOwnKey),
	lang/qt/tests/t-tofuinfo.cpp (testTofuPolicy): Use QDebug operator for
	Error instead of Error::asString.
	* lang/qt/tests/t-changeexpiryjob.cpp (all test functions),
	lang/qt/tests/t-trustsignatures.cpp (all test functions),
	lang/qt/tests/t-various.cpp (testSignKeyWithoutExpiration,
	testSignKeyWithExpiration): Use errorAsString instead of
	Error::asString.

	cpp: Deprecate Error::asString and update users.
	+ commit 28542b14c4df40c7a54bfcf65d7c725bd99fb3e5
	* lang/cpp/src/error.h (Error::asString): Mark as deprecated.
	* lang/cpp/src/context.cpp (operator<<),
	lang/cpp/src/editinteractor.cpp (edit_interactor_callback_impl),
	lang/cpp/tests/run-getkey.cpp (main),
	lang/cpp/tests/run-keylist.cpp (main),
	lang/cpp/tests/run-wkdlookup.cpp (main): Use Error::asStdString instead
	of Error::asString.

	cpp: Add safer member function returning text describing an error.
	+ commit 2656d3ee5b1a905d9fe4dd5c8b2d9737e775df31
	* lang/cpp/src/error.h, lang/cpp/src/context.cpp (class Error): New
	member function asStdString.

	qt: Always include C++ binding headers with gpgme++/ prefix.
	+ commit acf574af64d6ace5b090029748ecaf9d87163be7
	* lang/qt/src/Makefile.am, lang/qt/tests/Makefile.am (AM_CPPFLAGS):
	Add builddir instead of srcdir of C++ bindings as include path.
	* lang/qt/src/changeexpiryjob.cpp, lang/qt/src/changeexpiryjob.h,
	lang/qt/src/changeownertrustjob.h, lang/qt/src/dataprovider.cpp,
	lang/qt/src/dataprovider.h, lang/qt/src/debug.cpp,
	lang/qt/src/decryptverifyarchivejob.cpp,
	lang/qt/src/decryptverifyarchivejob.h,
	lang/qt/src/encryptarchivejob.cpp, lang/qt/src/encryptarchivejob.h,
	lang/qt/src/encryptjob.h, lang/qt/src/encryptjob_p.h,
	lang/qt/src/filelistdataprovider.cpp,
	lang/qt/src/filelistdataprovider.h,
	lang/qt/src/hierarchicalkeylistjob.h, lang/qt/src/importjob.cpp,
	lang/qt/src/importjob.h, lang/qt/src/importjob_p.h, lang/qt/src/job.h,
	lang/qt/src/keyformailboxjob.h, lang/qt/src/keylistjob.h,
	lang/qt/src/listallkeysjob.h, lang/qt/src/multideletejob.cpp,
	lang/qt/src/qgpgmeaddexistingsubkeyjob.cpp,
	lang/qt/src/qgpgmeadduseridjob.cpp, lang/qt/src/qgpgmebackend.cpp,
	lang/qt/src/qgpgmechangeexpiryjob.cpp,
	lang/qt/src/qgpgmechangeownertrustjob.cpp,
	lang/qt/src/qgpgmechangepasswdjob.cpp, lang/qt/src/qgpgmedecryptjob.cpp,
	lang/qt/src/qgpgmedecryptjob.h,
	lang/qt/src/qgpgmedecryptverifyarchivejob.cpp,
	lang/qt/src/qgpgmedecryptverifyarchivejob.h,
	lang/qt/src/qgpgmedecryptverifyjob.cpp,
	lang/qt/src/qgpgmedecryptverifyjob.h, lang/qt/src/qgpgmedeletejob.cpp,
	lang/qt/src/qgpgmedownloadjob.cpp,
	lang/qt/src/qgpgmeencryptarchivejob.cpp,
	lang/qt/src/qgpgmeencryptarchivejob.h, lang/qt/src/qgpgmeencryptjob.cpp,
	lang/qt/src/qgpgmeencryptjob.h, lang/qt/src/qgpgmeexportjob.cpp,
	lang/qt/src/qgpgmeimportfromkeyserverjob.cpp,
	lang/qt/src/qgpgmeimportfromkeyserverjob.h,
	lang/qt/src/qgpgmeimportjob.cpp, lang/qt/src/qgpgmeimportjob.h,
	lang/qt/src/qgpgmekeyformailboxjob.h,
	lang/qt/src/qgpgmekeygenerationjob.cpp,
	lang/qt/src/qgpgmekeygenerationjob.h, lang/qt/src/qgpgmekeylistjob.cpp,
	lang/qt/src/qgpgmekeylistjob.h, lang/qt/src/qgpgmelistallkeysjob.cpp,
	lang/qt/src/qgpgmelistallkeysjob.h,
	lang/qt/src/qgpgmenewcryptoconfig.cpp,
	lang/qt/src/qgpgmenewcryptoconfig.h, lang/qt/src/qgpgmequickjob.cpp,
	lang/qt/src/qgpgmereceivekeysjob.h,
	lang/qt/src/qgpgmerefreshsmimekeysjob.cpp,
	lang/qt/src/qgpgmerefreshsmimekeysjob.h,
	lang/qt/src/qgpgmerevokekeyjob.cpp,
	lang/qt/src/qgpgmesetprimaryuseridjob.cpp,
	lang/qt/src/qgpgmesignarchivejob.cpp,
	lang/qt/src/qgpgmesignarchivejob.h,
	lang/qt/src/qgpgmesignencryptarchivejob.cpp,
	lang/qt/src/qgpgmesignencryptarchivejob.h,
	lang/qt/src/qgpgmesignencryptjob.cpp,
	lang/qt/src/qgpgmesignencryptjob.h, lang/qt/src/qgpgmesignjob.cpp,
	lang/qt/src/qgpgmesignjob.h, lang/qt/src/qgpgmesignkeyjob.cpp,
	lang/qt/src/qgpgmetofupolicyjob.cpp,
	lang/qt/src/qgpgmeverifydetachedjob.cpp,
	lang/qt/src/qgpgmeverifydetachedjob.h,
	lang/qt/src/qgpgmeverifyopaquejob.cpp,
	lang/qt/src/qgpgmeverifyopaquejob.h, lang/qt/src/qgpgmewkdlookupjob.cpp,
	lang/qt/src/qgpgmewkdrefreshjob.cpp, lang/qt/src/qgpgmewkdrefreshjob.h,
	lang/qt/src/qgpgmewkspublishjob.cpp, lang/qt/src/quickjob.h,
	lang/qt/src/signarchivejob.cpp, lang/qt/src/signarchivejob.h,
	lang/qt/src/signencryptarchivejob.cpp,
	lang/qt/src/signencryptarchivejob.h, lang/qt/src/signencryptjob.h,
	lang/qt/src/signencryptjob_p.h, lang/qt/src/signjob.h,
	lang/qt/src/signjob_p.h, lang/qt/src/threadedjobmixin.cpp,
	lang/qt/src/threadedjobmixin.h, lang/qt/src/tofupolicyjob.h,
	lang/qt/src/util.cpp, lang/qt/src/wkdlookupresult.cpp,
	lang/qt/src/wkdlookupresult.h, lang/qt/src/wkdrefreshjob_p.h,
	lang/qt/tests/run-decryptverifyarchivejob.cpp,
	lang/qt/tests/run-decryptverifyjob.cpp,
	lang/qt/tests/run-encryptarchivejob.cpp,
	lang/qt/tests/run-encryptjob.cpp, lang/qt/tests/run-exportjob.cpp,
	lang/qt/tests/run-importjob.cpp, lang/qt/tests/run-keyformailboxjob.cpp,
	lang/qt/tests/run-receivekeysjob.cpp,
	lang/qt/tests/run-refreshkeysjob.cpp,
	lang/qt/tests/run-signarchivejob.cpp, lang/qt/tests/run-signjob.cpp,
	lang/qt/tests/run-verifydetachedjob.cpp,
	lang/qt/tests/run-verifyopaquejob.cpp,
	lang/qt/tests/run-wkdrefreshjob.cpp,
	lang/qt/tests/t-addexistingsubkey.cpp,
	lang/qt/tests/t-changeexpiryjob.cpp, lang/qt/tests/t-config.cpp,
	lang/qt/tests/t-decryptverify.cpp, lang/qt/tests/t-encrypt.cpp,
	lang/qt/tests/t-import.cpp, lang/qt/tests/t-keylist.cpp,
	lang/qt/tests/t-keylocate.cpp, lang/qt/tests/t-ownertrust.cpp,
	lang/qt/tests/t-remarks.cpp, lang/qt/tests/t-revokekey.cpp,
	lang/qt/tests/t-setprimaryuserid.cpp, lang/qt/tests/t-support.cpp,
	lang/qt/tests/t-support.h, lang/qt/tests/t-tofuinfo.cpp,
	lang/qt/tests/t-trustsignatures.cpp, lang/qt/tests/t-various.cpp,
	lang/qt/tests/t-verify.cpp, lang/qt/tests/t-wkdlookup.cpp,
	lang/qt/tests/t-wkspublish.cpp: Include GpgME++ headers with gpgme++/
	prefix.

	build,cpp: Create forwarding headers in a gpgme++ folder.
	+ commit b7435b31f6e6754480a4e6d2910d74ee15f75fc5
	* lang/cpp/src/Makefile.am (copied_headers): New.
	(build rule for all copied headers): New.
	(BUILT_SOURCES): New.
	(CLEANFILES): Add copied_headers.

2024-07-05  NIIBE Yutaka  <gniibe@fsij.org>

	Fix calling CancelSynchronousIo.
	+ commit 95bd4fa813023a56c29a43bdb9ad9777362b389b
	* src/w32-util.c (_gpgme_w32_cancel_synchronous_io): Use HANDLE.

	Fix printing size_t and off_t value for LLP64 Windows.
	+ commit de6068450094783b9ed68ec9553ea59d02a208ff
	* src/debug.h (_trace_sysres_off_t): Use 'z' length specifier.
	* src/w32-io.c (_gpgme_io_read): Likewise.
	(writer, _gpgme_io_write): Likewise.

	Remove ath.h and ath.c.
	+ commit 8b4171680c325d63952c9026aa7fa35f4b23e351
	* src/Makefile.am (system_components): We don't use ath.h any more.
	(main_sources): Remove ath.h and ath.c.

	Don't use ath_self, but get thread ID directly.
	+ commit 9c276e762a25262cd635e97f5aad4b09fa41b427
	* src/debug.c [HAVE_W32_SYSTEM or __linux] (tid_log_callback): Use
	native thread ID call for Windows and Linux, ifdef-out-ed.
	(debug_init): Only call gpgrt_log_set_pid_suffix_cb for relevant
	systems.

2024-07-01  NIIBE Yutaka  <gniibe@fsij.org>

	Use gpgrt_b64dec in libgpg-error.
	+ commit ec2c6dd8bc49e010810cb8ad403a9b8dad5d399e
	* src/b64dec.c: Remove.
	* src/Makefile.am (main_sources): Remove b64dec.c.
	* src/data-identify.c (pgp_binary_detection): Use gpgrt_b64dec in
	libgpg-error.

2024-06-28  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Remove obsolete files.
	+ commit 6ed5c9a38aedcda9e67607c7474042f28121af6e
	* lang/cpp/src/context_glib.cpp, lang/cpp/src/context_qt.cpp: Remove.

2024-06-18  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Allow appending a detached signature to an existing file.
	+ commit 7d5df0bf0d86391151911160db24441966b6d938
	* lang/qt/src/qgpgmesignjob.cpp (sign_to_filename): Add argument
	"appendSignature". Append new detached signature to an existing file if
	requested.
	* lang/qt/src/signjob.cpp, lang/qt/src/signjob.h (class SignJob): Add
	member functions setAppendSignature, appendSignatureEnabled.
	* lang/qt/src/signjob_p.h (struct SignJobPrivate): Add member
	m_appendSignature.

	* lang/qt/tests/run-signjob.cpp (struct CommandLineOptions): Add members
	signingFlags, appendSignature. Initialize armor.
	(parseCommandLine): Add command line options --detach-sign and --append.
	(main): Do not exit if output file exists and append is enabled.
	Pass new options to the job.

2024-06-17  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt,build: Install headers for Qt 5 and Qt 6 in different locations.
	+ commit 09827ffc7745e7dc4275f1c6e46531a959be1f71
	* lang/qt/src/Makefile.am (includeprefix): New.
	(qgpgmeincludedir, camelcaseincludedir): Add $(includeprefix).
	(QGpgmeConfig.cmake, QGpgmeQt6Config.cmake): Add $(includeprefix) to
	replacement for @resolved_includedir@.

2024-06-14  NIIBE Yutaka  <gniibe@fsij.org>

	Update gpg-error.m4 again for spell fix.
	+ commit 53c367629a6360719b6247d148174c6c66f52020


2024-06-13  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt,tests: Fix deprecation warnings (in Qt 6 build)
	+ commit c52e1943a72d42cc7dfbfc82b72345092d8f05c0
	* lang/qt/tests/t-tofuinfo.cpp (TofuInfoTest::signAndVerify,
	TofuInfoTest::testTofuPolicy): Use range-based for loop instead of Qt's
	deprecated foreach.

	qt: Specify import options as list of strings instead of as string.
	+ commit 60b96d149c71f7f5f928944e65732671d6b9eacc
	* lang/qt/src/importjob.cpp, lang/qt/src/importjob.h (setImportOptions):
	Change type of argument "options" to QStringList.
	(importOptions): Change return type to QStringList.
	* lang/qt/src/importjob_p.h (struct ImportJobPrivate): Change type of
	member m_importOptions to QStringList.
	* lang/qt/src/qgpgmeimportjob.cpp (import_qba): Change type of argument
	"importOptions" to QStringList. Join list of import options with ','
	when setting the "import-options" context flag.

	* lang/qt/tests/t-import.cpp (ImportTest::testImportWithImportOptions):
	Adapt to API change.

2024-06-13  NIIBE Yutaka  <gniibe@fsij.org>

	m4: Update m4 files.
	+ commit 6c90ec7be23532184f54cf59675130be6d2ae55a
	* m4/gpg-error.m4: Update libgpg-error master.
	* m4/libassuan.m4: Update libassuan master.

	gpgme.m4: Fix setting/using GPG_ERROR_CONFIG.
	+ commit 14b035034ab52c73f8d1aab2c475b3e8709600b4
	gpgm4.m4 (_AM_PATH_GPGRT_CONFIG): Don't set GPG_ERROR_CONFIG and
	gpg_error_config_version.

2024-06-12  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Allow specifying import options when importing keys.
	+ commit 2187a4de8c1731d8621a4b056baf84ee29e0ff00
	* lang/qt/src/importjob.cpp, lang/qt/src/importjob.h (class ImportJob):
	Add member functions setImportOptions and importOptions.
	* lang/qt/src/importjob_p.h (struct ImportJobPrivate): Add member
	m_importOptions.
	* lang/qt/src/qgpgmeimportjob.cpp (import_qba): Add arg importOptions
	and adjust the callers. Set import options context flag.

	* lang/qt/tests/t-import.cpp (ImportTest): Add member function
	testImportWithImportOptions.

	tests: Add --import-filter option to usage info of run-import.
	+ commit 5b73b0722a136db9fa7b9bb96bae27b8cfef5987
	* tests/run-import.c (show_usage): Add option --import-filter.

	core: Allow setting import options when importing keys.
	+ commit 3b9815bd8ad723445128ae99883be0072ae389a6
	* src/context.h (struct gpgme_context): New field import_options.
	* src/engine-backend.h (struct engine_ops): Add arg import_options to
	field 'import'.
	* src/engine-gpg.c (gpg_import): Add arg import_options and pass option
	--import-options with argument value to gpg.
	* src/engine-gpgsm.c (gpgsm_import): Add dummy arg import_options.
	* src/engine.c (_gpgme_engine_op_import): Add arg import_options and
	pass option to import function of engine.
	* src/engine.h (_gpgme_engine_op_import): Add arg import_options.
	* src/gpgme.c (gpgme_release): Free 'import_options'.
	(gpgme_set_ctx_flag, gpgme_get_ctx_flag): New flag "import-options".
	* src/import.c (_gpgme_op_import_start, _gpgme_op_import_keys_start,
	_gpgme_op_receive_keys_start): Pass import options stored in context to
	_gpgme_engine_op_import.

	* tests/run-import.c (show_usage, main): Add option --import-options.

	qt,doc: Fix typos.
	+ commit 307256d277d86fac768f09d7df09a5f62b680469
	* lang/qt/README: Fix typos.

2024-06-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Align license of some Makefiles with license of other Makefiles.
	+ commit 87319b3fc7667b271f7803132e3cbaa50f3344e4
	* lang/qt/doc/Makefile.am, lang/qt/tests/Makefile.am: Change license
	from LGPL to GPL.

	qt: Fix license headers of Makefiles.
	+ commit 29be63ae37755f1b16607864df0df71df4059549
	* lang/qt/Makefile.am, lang/qt/src/Makefile.am: Files are part of
	QGpgme. Fix wrong package name (GPGME-CL -> QGpgME). Replace references
	to LGPL with references to GPL.

	qt: Fix license headers of CMake config files.
	+ commit 09cc0c81f745ef1e9eb802a7f062f62f621e9301
	* lang/qt/src/QGpgmeConfig-w32.cmake.in.in,
	lang/qt/src/QGpgmeConfig.cmake.in.in,
	lang/qt/src/QGpgmeConfigVersion.cmake.in: Files are part of QGpgME.
	Fix copy&paste error (GPGME-CL -> QGpgME). Fix reference to license
	to check for details.
	* lang/qt/src/QGpgmeQt6Config-w32.cmake.in.in,
	lang/qt/src/QGpgmeQt6Config.cmake.in.in,
	lang/qt/src/QGpgmeQt6ConfigVersion.cmake.in: Files are part of QGpgME.
	Fix reference to license to check for details.

	qt: Fix license headers of dataprovider.*
	+ commit 967b6b726eb645e682cdb2a7b66b74307bd1c03d
	* lang/qt/src/dataprovider.cpp, lang/qt/src/dataprovider.h: Change
	license header from LGPL to GPL.

	cpp: Remove commented out and disabled code.
	+ commit 4136928f0d894e873eb0ecb0bc79931a023ba32c
	* lang/cpp/src/configuration.cpp: Remove disabled, abandoned code.
	* lang/cpp/src/context.cpp: Remove commented out, obsolete code.

2024-06-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	core,w32: Pass file names with forward slashes to gpg and gpgtar.
	+ commit 25dd284b0c42ba4ad434ce43f6ac93f24acd6498
	src/conversion.c, src/util.h (_gpgme_replace_backslashes): New.
	src/engine-gpg.c (_add_arg): Add argument file_name. On Windows, replace
	backslashes in file name arguments with forward slashes.
	(add_arg_ext, add_arg_with_locp, add_arg, add_arg_pfx, add_gpg_arg,
	add_gpg_arg_with_value, add_arg_len): Adjust call of _add_arg.
	(add_file_name_arg, add_file_name_arg_len, add_gpg_arg_with_file_name):
	New.
	(add_file_name_arg_or_data): Call add_file_name_arg for file name.
	(gpg_new): Call add_gpg_arg_with_file_name for home directory.
	(gpg_decrypt): Call add_file_name_arg for output directory and output
	file name.
	(append_args_from_recipients_string): Call add_file_name_arg_len for
	recipients file name.
	(gpg_encrypt): Call add_file_name_arg for output file name, base
	directory and input file name. Call add_gpg_arg_with_file_name to set
	file name stored in message.
	(gpg_encrypt_sign): Call add_file_name_arg for output file name, base
	directory and input file name. Call add_gpg_arg_with_file_name to set
	file name stored in message.
	(gpg_sign): Call add_file_name_arg for output file name, base directory
	and input file name. Call add_gpg_arg_with_file_name to set file name
	stored in message.
	(gpg_verify): Call add_file_name_arg for output directory and output
	file name.

2024-05-29  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,python: Fix make distcheck for Python 3.9+
	+ commit 1245b090126b8e2eeeda599b01b6b085d3607353
	* lang/python/Makefile.am (uninstall-local): Remove installed .egg
	folders.

	build,python: Remove support for Python 3.4, 3.5, 3.7.
	+ commit 09d81da665894997d654dd4add505302654a4294
	* configure.ac: Don't look for Python 3.4, 3.5, 3.7 anymore.

2024-05-29  Ben Greiner  <code@bnavigator.de>

	build,python: Build Python bindings without distutils.
	+ commit 5844d9e700239ad10a5956cd7789bd02360bb0fa
	* m4/python.m4: Add python3.12 and 3.11 as valid interpreters, remove
	EOL 3.4, 3.5, 3.7 (keep 3.6 because some distributions still ship and
	maintain it).
	* lang/python/Makefile.am (clean-local): Remove dist and gpg.egg-info
	created by Python 3.9+ on make install.
	* lang/python/setup.py.in: switch from distutils to setuptools where
	possible, remove obsolete and deprecated -py3 option of swig, add
	classifiers up to 3.12, remove 3.4, 3.5, 3.7.
	* lang/python/doc/src/gpgme-python-howto.org: replace distutils with
	setuptools
	* lang/python/examples/howto/advanced/cython/setup.py: replace distutils
	with setuptools

2024-05-24  Ingo Klöcker  <dev@ingo-kloecker.de>

	tests: Add new files to distribution.
	+ commit 986c5f0b947559b76f9997d238bb4231a79eeee1
	* tests/json/Makefile.am (EXTRA_DIST): Add files added with f2575b63.

	cpp: Fix includes in public headers.
	+ commit 6aa359b1e8d468d4f2f9145666ab6d916f453244
	* lang/cpp/src/defaultassuantransaction.h,
	lang/cpp/src/gpgadduserideditinteractor.h,
	lang/cpp/src/gpgagentgetinfoassuantransaction.h,
	lang/cpp/src/gpggencardkeyinteractor.h,
	lang/cpp/src/gpgsetexpirytimeeditinteractor.h,
	lang/cpp/src/gpgsetownertrusteditinteractor.h,
	lang/cpp/src/gpgsignkeyeditinteractor.h,
	lang/cpp/src/interfaces/assuantransaction.h,
	lang/cpp/src/interfaces/dataprovider.h,
	lang/cpp/src/interfaces/statusconsumer.h,
	lang/cpp/src/scdgetinfoassuantransaction.h,
	lang/cpp/src/statusconsumerassuantransaction.h,
	lang/cpp/src/trustitem.h: Use #include "foo.h" instead of
	#include <foo.h> for own headers.

2024-05-22  Tobias Fella  <tobias.fella@gnupg.com>

	qt,cpp: Implement adding ADSKs to existing keys.
	+ commit 15718cb2954d9df9af979f574cec859feb2ba052
	* lang/cpp/src/context.cpp: Add functions for adding ADSKs.
	* lang/cpp/src/context.h: Ditto.
	* lang/qt/src/qgpgmequickjob.cpp: Add implementation of ADSK job.
	* lang/qt/src/qgpgmequickjob.h: Ditto.
	* lang/qt/src/quickjob.h: Add job for adding ADSKs.

	core: Implement adding ADSKs through gpgme_createsubkey.
	+ commit e42b72bc2ba0b5cacfd5df625df6011b8819fbce
	* src/engine-gpg.c: Add and use function for adding ADSKs.
	* src/genkey.c: Prevent error due to no status line.
	* src/gpgme.h.in: Add flag GPGME_CREATE_ADSK
	* doc/gpgme.texi: Add documentation for ADSKs
	* tests/run-genkey.c: Add test for adding ADSKs

2024-05-21  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Add information about revocation keys to Key.
	+ commit 90eb80134b2d7720b187a6b7fd16f40f23cf1022
	* lang/cpp/src/gpgmefw.h (gpgme_revocation_key_t): New forward
	declaration.
	* lang/cpp/src/key.cpp, lang/cpp/src/key.h (class Key): New methods
	revocationKey, numRevocationKeys, revocationKeys.
	(class RevocationKey): New.
	(swap): New overload for RevocationKey.
	(operator<<): New overload for RevocationKey.
	* lang/cpp/src/key.cpp (operator<<): Add information about revocation
	keys to the output stream for Key.

	* lang/cpp/tests/run-keylist.cpp (main): Don't output Key if nextKey
	failed, e.g. at the end of the key listing.

	json: Add information about revocation keys to key list result.
	+ commit f2575b6313aeb23d867682856f7842704786349e
	* src/gpgme-json.c (revocation_key_to_json): New.
	(key_to_json): Add list of revocation keys.

	* tests/json/Makefile.am (pubring-stamp): Import new pub key.
	* tests/json/key-with-revokers.asc: New.
	* tests/json/t-json.c (tests): Add "t-keylist-revokers".
	* tests/json/t-keylist-revokers.in.json,
	tests/json/t-keylist-revokers.in.json: New.

	core: Add information about revocation keys to keys.
	+ commit adadfac997a812699049cd9a5f484cbcabff5bfd
	* src/gpgme.h.in (struct _gpgme_revocation_key,
	gpgme_revocation_key_t): New.
	(struct _gpgme_key): Add fields 'revkeys', '_last_revkey'.
	* src/key.c (_gpgme_key_add_rev_key): New.
	(gpgme_key_unref): Free revkeys.
	* src/keylist.c (keylist_colon_handler): Parse rvk lines.
	* src/ops.h (_gpgme_key_add_rev_key): New.

	* tests/run-keylist.c (main): Print revocation key info.

2024-05-21  Werner Koch  <wk@gnupg.org>

	tests: Fix segv in t-json.c.
	+ commit ac4bf86bb65a1e228550cce9314ad17239343c5d
	* tests/json/t-json.c (test_contains): Avoid calling recusivly with no
	child.

	tests: Avoid some compiler warnings.
	+ commit 55a1ae4163ecc97601c8d3d216452b65eec405af
	* tests/gpg/t-support.h (fail_with_syserr): New.
	(check_data): Use it to avoid compiler warnings.
	* tests/run-support.h (fail_with_syserr): New.

2024-05-21  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Avoid bogus stringop-overread warning.
	+ commit c933269d3a59e9a36587406ed2c130ea1b292852
	* lang/qt/src/threadedjobmixin.cpp (_detail::audit_log_as_html): Use
	QByteArray overload of QString::fromUtf8.

	qt: Fix warning about missing return.
	+ commit 333241b286e2c164640812cf39f7e8eff32914d2
	* lang/qt/src/qgpgmeexportjob.cpp (ExportJob::exec): Return a value and
	remove unused argument names.

2024-05-21  Werner Koch  <wk@gnupg.org>

	core: speedup gpgme_get_key.
	+ commit 73403a8ba00303b95c0e39fe3d2b78c913b0ca98
	* src/engine.c (_gpgme_set_engine_info): Change engine_get_version.

2024-05-17  NIIBE Yutaka  <gniibe@fsij.org>

	m4: Update libassuan.m4 from master.
	+ commit 0f5e8182e7cd6b6c4e57c503bbd7ab20f788d779
	* m4/libassuan.m4: Update.

2024-05-16  Ingo Klöcker  <dev@ingo-kloecker.de>

	Require at least libgpg-error 1.47.
	+ commit 3e3db5784ff0f3f06345fc3dbf7b0903f52b3fd5
	* configure.ac (NEED_GPG_ERROR_VERSION): Require 1.47.

2024-05-16  NIIBE Yutaka  <gniibe@fsij.org>

	gpgme.m4: Set $host correctly always.
	+ commit 87061c0260bb2a129a98bd9445cdc4220f542c15
	* src/gpgme.m4 (AM_PATH_GPGME): Add AC_CANONICAL_HOST.

2024-05-15  Ingo Klöcker  <dev@ingo-kloecker.de>

	tests: Fix test after changed behavior of gpgme_op_verify.
	+ commit a73a41109fff3b6d3f81fa29d353419ae45f6dda
	* tests/gpg/t-verify.c (main): Change assertion of test.

2024-05-14  NIIBE Yutaka  <gniibe@fsij.org>

	gpgme.m4: Update _AM_PATH_GPGRT_CONFIG macro from gpg-error.m4.
	+ commit 882ccc8ea77a8bcb7628674e9fad6541f915094b
	* src/gpgme.m4 (_AM_PATH_GPGRT_CONFIG): Update.

2024-04-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Handle smart card op failure status messages.
	+ commit e4a95746ada20d41161c3cdfb36d5167e2712098
	* lang/cpp/src/editinteractor.cpp (parse_sc_op_failure): New.
	(CallbackHelper::edit_interactor_callback_impl): Parse failure code on
	GPGME_STATUS_SC_OP_FAILURE status.
	(sc_op_failure_to_error): New.

2024-03-11  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Check STATUS_FAILURE in import operations.
	+ commit 7158397c098b8527c97c6bf350c2ebd6c0012594
	* src/import.c (op_data_t): Add failure_code.
	(_gpgme_import_status_handler): Set it. Return it on EOF.

2024-01-22  Tobias Fella  <tobias.fella@gnupg.com>

	qt: Add function for synchronously executing ExportJob.
	+ commit 47f3d92bf340f2a24b3c837a3afa5e1890b413ac
	* lang/qt/src/exportjob: Add exec function.
	* lang/qt/src/qgpgmeexportjob.cpp: Implement exec function.
	* lang/qt/src/qgpgmeexportjob.h: Override exec function.

2024-01-19  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Remove superfluous virtual overrides and member variables.
	+ commit 0011412193fdf1e91fec442d32e4b47a56276867
	* lang/qt/src/qgpgmeaddexistingsubkeyjob.cpp
	(QGpgMEAddExistingSubkeyJob::exec): Remove call of resultHook.
	* lang/qt/src/qgpgmedecryptjob.cpp (QGpgMEDecryptJob::exec): Remove
	call of resultHook.
	(QGpgMEDecryptJob::resultHook): Remove.
	* lang/qt/src/qgpgmedecryptjob.h (QGpgMEDecryptJob): Remove resultHook
	override. Remove member mResult.
	* lang/qt/src/qgpgmedecryptverifyjob.cpp (QGpgMEDecryptVerifyJob::exec):
	Remove call of resultHook.
	(QGpgMEDecryptVerifyJob::resultHook): Remove.
	* lang/qt/src/qgpgmedecryptverifyjob.h (QGpgMEDecryptVerifyJob): Remove
	resultHook override. Remove member mResult.
	* lang/qt/src/qgpgmeencryptjob.cpp (QGpgMEEncryptJob::exec): Remove
	call of resultHook.
	(QGpgMEEncryptJob::resultHook): Remove.
	* lang/qt/src/qgpgmeencryptjob.h (QGpgMEEncryptJob): Remove resultHook
	override. Remove member mResult.
	* lang/qt/src/qgpgmegpgcardjob.cpp (QGpgMEGpgCardJob::exec): Remove
	call of resultHook.
	* lang/qt/src/qgpgmeimportfromkeyserverjob.cpp
	(QGpgMEImportFromKeyserverJob::exec): Remove call of resultHook.
	(QGpgMEImportFromKeyserverJob::resultHook): Remove.
	* lang/qt/src/qgpgmeimportfromkeyserverjob.h
	(QGpgMEImportFromKeyserverJob): Remove resultHook override. Remove
	member mResult.
	* lang/qt/src/qgpgmeimportjob.cpp (QGpgMEImportJob::exec): Remove call
	of resultHook.
	(QGpgMEImportJob::resultHook): Remove.
	* lang/qt/src/qgpgmeimportjob.h (QGpgMEImportJob): Remove resultHook
	override. Remove member mResult.
	* lang/qt/src/qgpgmekeyformailboxjob.cpp (QGpgMEKeyForMailboxJob::exec):
	Remove call of resultHook.
	* lang/qt/src/qgpgmekeylistjob.cpp (QGpgMEKeyListJob::QGpgMEKeyListJob):
	Remove initialization of mResult.
	(QGpgMEKeyListJob::resultHook): Do not set (removed) mResult.
	* lang/qt/src/qgpgmekeylistjob.h (QGpgMEKeyListJob): Remove member
	mResult.
	* lang/qt/src/qgpgmelistallkeysjob.cpp
	(QGpgMEListAllKeysJob::QGpgMEListAllKeysJob): Remove initialization of
	mResult.
	(QGpgMEListAllKeysJob::exec): Remove call of resultHook.
	(QGpgMEListAllKeysJob::resultHook): Remove.
	* lang/qt/src/qgpgmelistallkeysjob.h (QGpgMEListAllKeysJob): Remove
	resultHook override. Remove member mResult.
	* lang/qt/src/qgpgmereceivekeysjob.cpp (QGpgMEReceiveKeysJob::exec):
	Remove call of resultHook.
	(QGpgMEReceiveKeysJob::resultHook): Remove.
	* lang/qt/src/qgpgmereceivekeysjob.h (QGpgMEReceiveKeysJob): Remove
	resultHook override. Remove member mResult.
	* lang/qt/src/qgpgmerevokekeyjob.cpp (QGpgMERevokeKeyJob::exec): Remove
	call of resultHook.
	* lang/qt/src/qgpgmesignencryptjob.cpp (QGpgMESignEncryptJob::exec):
	Remove call of resultHook.
	(QGpgMESignEncryptJob::resultHook): Remove.
	* lang/qt/src/qgpgmesignencryptjob.h (QGpgMESignEncryptJob): Remove
	resultHook override. Remove member mResult.
	* lang/qt/src/qgpgmesignjob.cpp (QGpgMESignJob::exec): Remove call of
	resultHook.
	(QGpgMESignJob::resultHook): Remove.
	* lang/qt/src/qgpgmesignjob.h (QGpgMESignJob): Remove resultHook
	override. Remove member mResult.
	* lang/qt/src/qgpgmeverifydetachedjob.cpp
	(QGpgMEVerifyDetachedJob::exec): Remove call of resultHook.
	(QGpgMEVerifyDetachedJob::resultHook): Remove.
	* lang/qt/src/qgpgmeverifydetachedjob.h (QGpgMEVerifyDetachedJob):
	Remove resultHook override. Remove member mResult.
	* lang/qt/src/qgpgmeverifyopaquejob.cpp (QGpgMEVerifyOpaqueJob::exec):
	Remove call of resultHook.
	(QGpgMEVerifyOpaqueJob::resultHook): Remove.
	* lang/qt/src/qgpgmeverifyopaquejob.h (QGpgMEVerifyOpaqueJob): Remove
	resultHook override. Remove member mResult.
	* lang/qt/src/qgpgmewkdlookupjob.cpp (QGpgMEWKDLookupJob::exec):
	Remove call of resultHook.

	qt: Remove left-over mentions of showErrorDialog.
	+ commit eae22d9a484f2fba0e7250450df4d2f565f10731
	* lang/qt/src/qgpgmedecryptjob.cpp,
	lang/qt/src/qgpgmeimportfromkeyserverjob.cpp,
	lang/qt/src/qgpgmeimportjob.cpp: Remove obsolete comment.
	* lang/qt/src/qgpgmekeylistjob.cpp,
	lang/qt/src/qgpgmelistallkeysjob.cpp: Remove long obsolete, #if 0'ed out
	definitions of showErrorDialog.

2024-01-16  Ingo Klöcker  <dev@ingo-kloecker.de>

	build: Re-add still needed custom changes to Python autoconf macro.
	+ commit cc1f2b5acb8484edf0a722dcccac435687576a44
	* m4/ax_python_devel.m4: Do not emit 'HAVE_PYTHON'.

	build: Update Python autoconf macro.
	+ commit e3ae88267f03b435ec7d9e80ae1e2891e1f118e6
	* configure.ac: Call AX_PYTHON_DEVEL with new "optional" argument.
	* m4/ax_python_devel.m4: Replace with current version from the autoconf
	archive.

2024-01-15  Werner Koch  <wk@gnupg.org>

	doc: Add a deprecated warning to gpgme_op_delete.
	+ commit 18388f93abb064b2bcd1010242b47eb696dabf6d


2024-01-09  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp,tests: Launch dirmngr with gpg-conf.
	+ commit 85c7a94d635d1eb134a51fb6d1ab4dc400a8fc1c
	* lang/cpp/tests/run-wkdlookup.cpp (main): Replace backslashes with
	forward slashes in homedir returned by GpgME::dirInfo. Use "gpgconf
	--launch dirmngr" to start dirmngr.

	qt: Pass home directory with forward slashes when launching dirmngr.
	+ commit 7e520213c09dc1ce4f1431e0f32054a1b7cd1368
	* lang/qt/src/qgpgmewkdlookupjob.cpp (startDirmngr): Replace backslashes
	with forward slashes in homedir returned by GpgME::dirInfo.

2024-01-08  Tobias Fella  <tobias.fella@gnupg.com>

	qt: Fix validity for (sub)keys generated using QGpgMEQuickJob.
	+ commit d60d1b7f79bd989a23f36233225abea0513ad10b
	* lang/qt/src/qgpgmequickjob.cpp: Fix expiration calculation

2024-01-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Support verification of detached signatures directly from files.
	+ commit c631622484dc9c00a05e3c25c53ef263db83b381
	* lang/qt/src/Makefile.am: Add new files.
	* lang/qt/src/job.cpp (VerifyDetachedJob): Move definition of
	constructor and destructor and inclusion of the moc file to the
	corresponding .cpp file.
	* lang/qt/src/verifydetachedjob.cpp: New.
	* lang/qt/src/verifydetachedjob.h (VerifyDetachedJob): Add member
	functions setSignatureFile, signatureFile, setSignedFile, signedFile.
	* lang/qt/src/verifydetachedjob_p.h: New.
	* lang/qt/src/qgpgmeverifydetachedjob.cpp (class
	QGpgMEVerifyDetachedJobPrivate): New.
	(QGpgMEVerifyDetachedJob::QGpgMEVerifyDetachedJob): Instantiate private
	job class.
	(verify_from_filename): New.

	* lang/qt/tests/Makefile.am: Add new test program.
	* lang/qt/tests/run-verifydetachedjob.cpp: New.

2023-12-22  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Tell gpg that we want to verify signed data.
	+ commit 1dc44b7c5b9253206af527721212d1f55532a7ee
	* src/engine-gpg.c (gpg_verify): Add "--verify" to command line.

	qt: Support verification of opaque signed data directly to/from files.
	+ commit e77a8ac0cc2ef356ef7e9da2793329432caf7406
	* lang/qt/src/Makefile.am: Add new files.
	* lang/qt/src/job.cpp (VerifyOpaqueJob): Move definition of constructor
	and destructor and inclusion of the moc file to the corresponding .cpp
	file.
	* lang/qt/src/verifyopaquejob.cpp: New.
	* lang/qt/src/verifyopaquejob.h (VerifyOpaqueJob): Add member
	functions setInputFile, inputFile, setOutputFile, outputFile.
	* lang/qt/src/verifyopaquejob_p.h: New.
	* lang/qt/src/qgpgmeverifyopaquejob.cpp (class
	QGpgMEVerifyOpaqueJobPrivate): New.
	(QGpgMEVerifyOpaqueJob::QGpgMEVerifyOpaqueJob): Instantiate private
	job class.
	(verify_from_filename): New.

	* lang/qt/tests/Makefile.am: Add new test program.
	* lang/qt/tests/run-verifyopaquejob.cpp: New.

	qt: Support decryption (with verification) directly to/from files.
	+ commit 20b32e03503f8c3187508d9cd5ba07db2b03f014
	* lang/qt/src/Makefile.am: Add new files.
	* lang/qt/src/job.cpp (DecryptVerifyJob): Move definition of constructor
	and destructor and inclusion of the moc file to the corresponding .cpp
	file.
	* lang/qt/src/decryptverifyjob.cpp: New.
	* lang/qt/src/decryptverifyjob.h (DecryptVerifyJob): Add member
	functions setInputFile, inputFile, setOutputFile, outputFile.
	* lang/qt/src/decryptverifyjob_p.h: New.
	* lang/qt/src/qgpgmedecryptverifyjob.cpp (class
	QGpgMEDecryptVerifyJobPrivate): New.
	(QGpgMEDecryptVerifyJob::QGpgMEDecryptVerifyJob): Instantiate private
	job class.
	(decrypt_verify_from_filename): New.

	* lang/qt/tests/Makefile.am: Add new test program.
	* lang/qt/tests/run-decryptverifyjob.cpp: New.

2023-12-21  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Support writing/reading signed/encrypted files directly to/from file
	+ commit a44d84772d6197dfb977b411f6eb7cb29b08471b
	* lang/qt/src/Makefile.am: Add new files.
	* lang/qt/src/job.cpp (EncryptJob, SignJob, SignEncryptJob): Move
	definition of constructor and destructor and inclusion of the moc file
	to the corresponding .cpp files.
	* lang/qt/src/encryptjob.cpp (EncryptJob): Define constructor. Define
	destructor as default. Include moc file.
	* lang/qt/src/encryptjob.cpp, lang/qt/src/encryptjob.h (EncryptJob):
	Add member functions setRecipients, recipients, setInputFile, inputFile,
	setOutputFile, outputFile, setEncryptionFlags, encryptionFlags.
	* lang/qt/src/encryptjob_p.h (EncryptJobPrivate): Add members
	m_recipients, m_inputFilePath, m_outputFilePath, m_encryptionFlags.
	* lang/qt/src/qgpgmeencryptjob.cpp (encrypt_to_filename): New.
	(QGpgMEEncryptJobPrivate::startIt): Start the job with the values
	from the member variables.
	* lang/qt/src/qgpgmesignencryptjob.cpp (sign_encrypt_to_filename): New.
	(QGpgMESignEncryptJobPrivate::startIt): Start the job with the values
	from the member variables.
	* lang/qt/src/qgpgmesignjob.cpp (class QGpgMESignJobPrivate): New.
	(QGpgMESignJob::QGpgMESignJob): Instantiate private job class.
	(sign_to_filename): New.
	* lang/qt/src/signencryptjob.cpp (SignEncryptJob): Define constructor.
	Define destructor as default. Include moc file.
	* lang/qt/src/signencryptjob.cpp, lang/qt/src/signencryptjob.h
	(SignEncryptJob): Add member functions setSigners, signers,
	setRecipients, recipients, setInputFile, inputFile, setOutputFile,
	outputFile, setEncryptionFlags, encryptionFlags.
	* lang/qt/src/signencryptjob_p.h (SignEncryptJobPrivate): Add members
	m_signers, m_recipients, m_inputFilePath, m_outputFilePath,
	m_encryptionFlags.
	* lang/qt/src/signjob.cpp: New.
	* lang/qt/src/signjob.h (SignJob): Add member functions setSigners,
	signers, setInputFile, inputFile, setOutputFile, outputFile,
	setSigningFlags, signingFlags.
	* lang/qt/src/signjob_p.h: New.
	* lang/qt/tests/Makefile.am: Add new test programs.
	* lang/qt/tests/run-encryptjob.cpp: New.
	* lang/qt/tests/run-signjob.cpp: New.

	qt: Remove dead code.
	+ commit b166958b868c551fe0b4e4ac33e6e34ddf2f7ee1
	* lang/qt/src/qgpgmeencryptjob.cpp,
	lang/qt/src/qgpgmesignencryptjob.cpp, lang/qt/src/qgpgmesignjob.cpp:
	Remove long commented out showErrorDialog member function definitions.

2023-12-19  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Support new flags for direct signing/encryption of files.
	+ commit 60c0fd7c955d6b8c1d0d7be3d3c65257c6418a26
	* lang/cpp/src/context.h (enum EncryptionFlags): Add constant
	EncryptFile.
	* lang/cpp/src/global.h (enum SignatureMode): Add constant SignFile.
	* lang/cpp/src/context.cpp (sigflags2sigflags): Handle new flag
	SignFile.
	(encryptflags2encryptflags): Handle new flag EncryptFile.
	(operator<<): Add new flags to the corresponding debug streams.
	* lang/cpp/src/signingresult.cpp (CreatedSignature::mode): Handle
	new flag SignFile (even if it cannot occur).

	core: Support writing the decrypt/verify output directly to a file.
	+ commit 5efd3486a9fa9f4b0f383aca2f2f01412e73237c
	* src/engine-gpg.c (gpg_decrypt): Pass output file name to gpg if output
	has file name set.
	(gpg_verify): Ditto.

	* tests/run-decrypt.c (show_usage): New option --output.
	(main): Parse new option. Set file name on output if --output is given.
	Do not print output if --output is given.
	* tests/run-verify.c (show_usage): New option --output.
	(main): Parse new option. Set file name on output if --output is given.

	core: Support direct signing of file with gpg.
	+ commit 963ace1f9f39f09fee522b996e05d42040b1f4b4
	* src/gpgme.h.in (GPGME_SIG_MODE_FILE): New signature mode flag.
	* src/engine-gpg.c (gpg_sign): Separate signature mode from additional
	flags. Check for incompatible flags. Explicitly set output to stdout if
	no output file is used. Pass filename instead of fd to gpg when new flag
	is set.
	* src/engine-gpgsm.c (gpgsm_sign): Return error if new flag is set.
	* src/engine-uiserver.c (uiserver_sign): Ditto.
	* src/sign.c (sign_start): Consider new flag on check for invalid flags.

	* tests/run-sign.c (show_usage): New options --detach and
	--direct-file-io.
	(main): Parse new options. Create a detached signature if --detach is
	given. Make gpg read the input file itself if --direct-file-io is given.

	core: Support direct encryption of file with gpg.
	+ commit 0221d7f28a315d305409cf2dcae853c22ad94d31
	* src/gpgme.h.in (GPGME_ENCRYPT_FILE): New encryption flag.
	* src/engine-gpg.c (gpg_encrypt, gpg_encrypt_sign): Check for
	incompatible flags. Pass filename instead of fd to gpg when new flag is
	set.
	* src/engine-gpgsm.c (gpgsm_encrypt): Return error if new flag is set.
	* src/engine-uiserver.c (uiserver_encrypt): Ditto.

	* tests/run-encrypt.c (show_usage): New option --direct-file-io.
	(main): Parse new option. Make gpg read the input file itself if the
	option is given.

2023-12-13  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Replace Q_FOREACH with range-for.
	+ commit d5dafb2ae332fb6ad463c363e6c2c527bcf66656
	* lang/qt/src/qgpgmekeyformailboxjob.cpp (do_work): Replace Q_FOREACH
	with range-for.
	* lang/qt/src/qgpgmekeylistjob.cpp (QGpgMEKeyListJob::resultHook):
	Ditto.
	* lang/qt/src/threadedjobmixin.cpp (_detail::audit_log_as_html): Ditto.
	* lang/qt/tests/t-keylist.cpp (KeyListTest::testPubkeyAlgoAsString):
	Ditto.
	* lang/qt/tests/t-keylocate.cpp (KeyLocateTest::testDaneKeyLocate,
	KeyLocateTest::testKeyLocateSingle): Ditto.
	* lang/qt/src/qgpgmesignencryptjob.cpp (sign_encrypt): Replace Q_FOREACH
	with range-for. Add braces around single statement blocks.
	* lang/qt/src/qgpgmesignjob.cpp (sign): Ditto.
	* lang/qt/src/qgpgmenewcryptoconfig.cpp
	(QGpgMENewCryptoConfig::reloadConfiguration,
	QGpgMENewCryptoConfig::sync,
	QGpgMENewCryptoConfigComponent::setComponent,
	QGpgMENewCryptoConfigEntry::urlValueList,
	QGpgMENewCryptoConfigEntry::setURLValueList): Replace Q_FOREACH with
	range-for. Fix indentation. Add braces around single statement blocks.

	qt: Replace Q_NULLPTR with nullptr.
	+ commit f7d69de030b36c1f8cb3491dc97750fb7725f258
	* lang/qt/src/defaultkeygenerationjob.h, lang/qt/src/qgpgmebackend.h,
	lang/qt/src/quickjob.h, lang/qt/src/threadedjobmixin.h: Replace all
	occurrences of Q_NULLPTR with nullptr.

2023-11-30  Andre Heinecke  <aheinecke@gnupg.org>

	core: percent decode filename.
	+ commit 6baccdc0c35d93253975e672bbf608750f97ab2a
	* src/op-support.c (_gpgme_parse_plaintext): Decode filename
	as percent string.

2023-11-28  Werner Koch  <wk@gnupg.org>

	Release 1.23.2.
	+ commit 1a26db717575068f0ab0d00a437ae870a93e1bb8


2023-11-23  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Start dirmngr with gpgconf to avoid multiple instances.
	+ commit 1bbe2d4b707843cacf020c252ce883ec45bdbc38
	* lang/qt/src/qgpgmewkdlookupjob.cpp (startDirmngr): Use "gpgconf
	--launch dirmngr" to start dirmngr.

2023-11-15  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: On Windows, use UTF-8 when logging the error text.
	+ commit 618fea9e2006475bf849da1c1837e0d788f30a80
	* lang/qt/src/debug.cpp (operator<<): On Windows, interpret the error
	text as UTF-8 instead of local 8-bit encoding.

	qt: Remove left-over partial files more persistently.
	+ commit 278f92b189ece58dee2036450ac029e3599fdb1f
	* lang/qt/src/Makefile.am: Add new files.
	* lang/qt/src/cleaner.cpp, lang/qt/src/cleaner.h: New.
	* lang/qt/src/util.cpp (PartialFileGuard::~PartialFileGuard): Call
	Cleaner::removeFile instead of removeFile.
	* lang/qt/src/util.cpp, lang/qt/src/util.h (removeFile): Remove.

2023-11-14  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Preserve more specific existing failure code.
	+ commit 77e982579ccadb20ee865337ada9579ac41164e1
	* src/decrypt.c (_gpgme_decrypt_status_handler): Ignore received failure
	code if we already have a specific failure code.
	* src/encrypt.c (_gpgme_encrypt_status_handler): Ditto.
	* src/export.c (export_status_handler): Ditto.
	* src/genkey.c (genkey_status_handler): Ditto.
	* src/keylist.c (keylist_status_handler): Ditto.
	* src/keysign.c (keysign_status_handler): Ditto.
	* src/passwd.c (passwd_status_handler): Ditto.
	* src/revsig.c (revsig_status_handler): Ditto.
	* src/setexpire.c (setexpire_status_handler): Ditto.
	* src/sign.c (_gpgme_sign_status_handler): Ditto.
	* src/tofupolicy.c (tofu_policy_status_handler): Ditto.
	* src/verify.c (_gpgme_verify_status_handler): Ditto.

2023-11-10  Werner Koch  <wk@gnupg.org>

	tests: Add option --chain to run-keylist.
	+ commit 1bfd5e92d0236d1db9782904c1a2d5dc7461dae2
	* tests/run-keylist.c (xstrdup): New.
	(main): Add option.

2023-11-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Deprecate DefaultKeyGenerationJob.
	+ commit 52d59d75cae5803ac49ddbee4aae9b862c73a075
	* lang/qt/src/defaultkeygenerationjob.h (class DefaultKeyGenerationJob):
	Deprecate.

2023-10-30  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,qt: Build Qt with -fPIC if required or requested.
	+ commit ae332749eee056f59bf902a65ffb012fcf181875
	* configure.ac: Add option to enable building the Qt 6 binding with
	-fPIC. Fix typo and mention default for --enable-no-direct-extern-access
	option.
	* m4/qt6.m4: Add -fPIC to GPGME_QT6_CFLAGS if requested or if Qt 6 was
	built with reduce_relocations.

2023-10-27  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Use temporary .part file names when creating archives.
	+ commit 46f5d5eeb3b1d0586106b33cecf600ab66170b45
	* lang/qt/src/util.h, lang/qt/src/util.cpp (class PartialFileGuard):
	New.
	* lang/qt/src/util.cpp (getRandomCharacters, createPartFileName): New.
	* lang/qt/src/qgpgmeencryptarchivejob.cpp (encrypt_to_filename): Use
	PartialFileGuard.
	* lang/qt/src/qgpgmesignarchivejob.cpp (sign_to_filename): Ditto.
	* lang/qt/src/qgpgmesignencryptarchivejob.cpp
	(sign_encrypt_to_filename): Ditto.

	qt: Refactor removal of output file on cancel or error.
	+ commit 8d8985bda1747a18b3b1378ea7c627302a61464a
	* lang/qt/src/util.h, lang/qt/src/util.cpp (removeFile): New.
	* lang/qt/src/qgpgmeencryptarchivejob.cpp (encrypt): Move removal of
	output file from here
	(encrypt_to_filename): ... to here and use new function.
	* lang/qt/src/qgpgmesignarchivejob.cpp (sign): Move removal of output
	file from here
	(sign_to_filename): ... to here and use new function.
	* lang/qt/src/qgpgmesignencryptarchivejob.cpp (sign_encrypt): Move
	removal of output file from here
	(sign_encrypt_to_filename): ... to here and use new function.

2023-10-25  Andre Heinecke  <aheinecke@gnupg.org>

	Change gpgme-w32-spawn to unicode.
	+ commit a0a4cd411c6d891e9ca784fd12b76410b0bb4673
	* src/Makefile.am (gpgme_w32spawn_CFLAGS): Add -municode.
	* src/gpgme-w32-spawn.c (build_commandline, my_spawn)
	(translate_handles): Convert to wchar_t API.
	(main): Use wmain instead.

2023-10-25  Werner Koch  <wk@gnupg.org>

	Release 1.23.0.
	+ commit aae967ec9cb365518fc8f73e6fb3ba7b55ef590d


2023-10-18  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Handle cancel in changeexpiryjob.
	+ commit ab25df8328d9248abc2816403e6051e00d5b1095
	* lang/qt/src/qgpgmechangeexpiryjob.cpp (change_expiry): Return
	cancel error.

2023-10-13  Marius P  <nmariusp1@gmail.com>

	python,examples: Add missing word "License"
	+ commit 959f976dfca65b99fd1107f1fca93a5f0c4a83ad
	* lang/python/examples/howto/add-userid.py,
	lang/python/examples/howto/clear-sign-file.py,
	lang/python/examples/howto/create-key.py,
	lang/python/examples/howto/decrypt-file.py,
	lang/python/examples/howto/detach-sign-file.py,
	lang/python/examples/howto/encrypt-file.py,
	lang/python/examples/howto/encrypt-sign-file.py,
	lang/python/examples/howto/encrypt-to-group-gullible.py,
	lang/python/examples/howto/encrypt-to-group-trustno1.py,
	lang/python/examples/howto/encrypt-to-group.py,
	lang/python/examples/howto/export-key.py,
	lang/python/examples/howto/export-minimised-key.py,
	lang/python/examples/howto/export-secret-key.py,
	lang/python/examples/howto/export-secret-keys.py,
	lang/python/examples/howto/groups.py,
	lang/python/examples/howto/import-key.py,
	lang/python/examples/howto/import-keybasekey.py,
	lang/python/examples/howto/import-keys-hkp.py,
	lang/python/examples/howto/import-keys.py,
	lang/python/examples/howto/import-mailvelope-keys.py,
	lang/python/examples/howto/keycount.py,
	lang/python/examples/howto/local-sign-group.py,
	lang/python/examples/howto/mutt-groups.py,
	lang/python/examples/howto/pmkey-import-alt.py,
	lang/python/examples/howto/pmkey-import-hkp-alt.py,
	lang/python/examples/howto/pmkey-import-hkp.py,
	lang/python/examples/howto/pmkey-import.py,
	lang/python/examples/howto/revoke-userid.py,
	lang/python/examples/howto/send-key-to-keyserver.py,
	lang/python/examples/howto/sign-file.py,
	lang/python/examples/howto/sign-key.py,
	lang/python/examples/howto/symcrypt-file.py,
	lang/python/examples/howto/temp-homedir-config.py,
	lang/python/examples/howto/verify-signatures.py,
	lang/python/examples/howto/verify-signed-file.py: Add "License" after
	"Lesser General Public"

2023-10-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Support new key capability flags.
	+ commit a9e5a25b56abb7f27812f333c287a7adae9e18e8
	* lang/cpp/src/key.cpp, lang/cpp/src/key.h (class Key): New methods
	hasCertify, hasSign, hasEncrypt, hasAuthenticate.

2023-10-05  Werner Koch  <wk@gnupg.org>

	core: Add key capability flags has_encrypt etc.
	+ commit b63d203d3ba49483b079fb118a90990c452cd232
	* src/gpgme.h.in (struct _gpgme_key): Add flags has_encrypt,
	has_certify, has_sign, and has_authenticate.
	* src/keylist.c (finish_key): Set these flags.
	* tests/run-keylist.c (main): Print them.

	core: Check STATUS_FAILURE in export operations.
	+ commit 349a69b5ea77c334c1c59b56f283bb65dc54a590
	* src/export.c (op_data_t): Add failure_code.
	(export_status_handler): Set it.
	(gpgme_op_export_ext, gpgme_op_export_keys): Also check the failure
	code.

2023-09-29  NIIBE Yutaka  <gniibe@fsij.org>

	gpgme-tool: Support use of Windows HANDLE for INPUT/OUTPUT/MESSAGE.
	+ commit 8ad22290df34c73881f42f02cdd28551ec265077
	* src/gpgme-tool.c [HAVE_W32_SYSTEM] (server_data_obj): Implement for
	Windows HANDLE.

2023-09-22  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Use UTF-8 for file names on Windows.
	+ commit d43d787e9ac153f67505fee95a975b4e8f6f928e
	* lang/qt/src/qgpgmedecryptverifyarchivejob.cpp
	(decrypt_verify_from_file_name): On Windows, convert Unicode file name
	to UTF-8.
	* lang/qt/src/qgpgmeencryptarchivejob.cpp (encrypt,
	encrypt_to_filename): On Windows, convert Unicode file name from/to
	UTF-8.
	* lang/qt/src/qgpgmesignarchivejob.cpp (sign, sign_to_filename): Ditto.
	* lang/qt/src/qgpgmesignencryptarchivejob.cpp (sign_encrypt,
	sign_encrypt_to_filename): Ditto.

2023-09-21  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,qt: Autodetect whether Qt was built with -mno-direct-extern-access
	+ commit 4e321a0f06ffba2437fa34ccb88527e9ea633703
	* m4/qt6.m4: Check the build configuration of Qt 6 for
	no_direct_extern_access.

	build,qt: Optionally build Qt 6 bindings with -mno-direct-extern-access.
	+ commit 927f129663b8bde1ecb4e2ac2b233a7baca8a568
	* configure.ac: Check if C++ compiler supports
	-mno-direct-extern-access. Add option to enable building with
	-mno-direct-extern-access.
	* m4/ax_check_compile_flag.m4: New.
	* m4/qt6.m4: Add -mno-direct-extern-access to GPGME_QT6_CFLAGS if
	supported and requested.

	build,qt: Drop broken check for -fPIC.
	+ commit 3e6485620816c9097f98cbe4fdb82a4683918a63
	* m4/qt6.m4: Remove attempt to build a Qt program with -fPIC.

2023-09-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	tests: Re-add --with-secret option.
	+ commit 8fde9cbe22885116e4779ea70e13bd0c2273d604
	* tests/run-keylist.c (main): Handle option --with-secret again.

2023-09-04  Werner Koch  <wk@gnupg.org>

	New mode to list a v5 fingerprint for v4 packets.
	+ commit e36b2d1bce4bb6281e18f53d06d7831e6d6f5a09
	* src/gpgme.h.in (GPGME_KEYLIST_MODE_WITH_V5FPR): New.
	(struct _gpgme_subkey): Add field v5fpr.
	* src/engine-gpg.c (gpg_keylist_build_options): Pass new option to
	gpg.
	* src/key.c (gpgme_key_unref): Free new field.
	* src/keylist.c (op_data_t): Parse and add "fp2" line.

	* tests/run-keylist.c (show_usage): Add option --v5fpr.

	* src/keylist.c (op_data_t): Add field failure_code.
	(keylist_status_handler): Handle special value.
	(gpgme_op_keylist_end): Return an error if a FAILURE line has been
	seen.

2023-09-01  NIIBE Yutaka  <gniibe@fsij.org>

	build: Change the default for --with-libtool-modification.
	+ commit b80d52a1f74a205b6cd708ad3b5741b051bbaaff
	* configure.ac (--with-libtool-modification): default=never.

2023-08-31  Werner Koch  <wk@gnupg.org>

	Support GPGME_ENCRYPT_ALWAYS_TRUST also for S/MIME.
	+ commit d75b2a91517397261c2508dba058611f803c0733
	* src/engine-gpgsm.c (gpgsm_encrypt): Send the always-trust options.

	* tests/run-encrypt.c: Add option --always-trust.

2023-08-23  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Allow specifying user IDs to use when refreshing keys via WKD.
	+ commit 3f297387bf401475385c458e4d1d95b3eefaf3d8
	* lang/qt/src/wkdrefreshjob.h, lang/qt/src/wkdrefreshjob.cpp
	(WKDRefreshJob::start): New overload.
	* lang/qt/src/wkdrefreshjob_p.h (WKDRefreshJobPrivate): Add field
	m_userIds.
	* lang/qt/src/qgpgmewkdrefreshjob.cpp (toEmailAddresses): New.
	(locate_external_keys): Change return type and arguments.
	(refresh_keys): Remove.
	(QGpgMEWKDRefreshJobPrivate::startIt): Get emails from keys or user IDs.
	Remove duplicates. Call locate_external_keys instead of refresh_keys.

	* lang/qt/tests/run-wkdrefreshjob.cpp (CommandLineOptions,
	parseCommandLine): New.
	(main): Support new option --all-userids.

2023-08-22  Christian Hesse  <mail@eworm.de>

	qt,tests: Fix build in source directory, part 2.
	+ commit aee18a2ab2498bc6092bef518c532796bbe5b502
	* lang/qt/tests/Makefile.am (AM_CPPFLAGS): Include Qt binding sources
	before C++ binding sources and C sources.

2023-08-21  Ingo Klöcker  <dev@ingo-kloecker.de>

	build: Suggest out-of-source build.
	+ commit 24a8c279da98fe7e586a9fc3cd91175c9e60ffef
	* autogen.rc (final_info): Suggest to run configure from a build
	subdirectory.

	qt,tests: Fix build in source directory.
	+ commit d23528cadf4284f508bc4ba05e1b5c14b46bd354
	* lang/qt/tests/Makefile.am (AM_CPPFLAGS): Include Qt binding sources
	before C++ binding sources and C sources.

	qt: Add job for refreshing OpenPGP keys via WKD.
	+ commit 2ad36f71144731f847c89b1f1e91f21c215cffa1
	* lang/qt/src/wkdrefreshjob.cpp, lang/qt/src/wkdrefreshjob.h,
	lang/qt/src/wkdrefreshjob_p.h, lang/qt/src/qgpgmewkdrefreshjob.cpp,
	lang/qt/src/qgpgmewkdrefreshjob.h: New.
	* lang/qt/src/protocol.h (class Protocol): Add pure virtual member
	function wkdRefreshJob
	* lang/qt/src/protocol_p.h (Protocol::wkdRefreshJob): ... and
	implement it.
	* lang/qt/src/Makefile.am: Update accordingly.

	* lang/qt/tests/run-wkdrefreshjob.cpp: New.
	* lang/qt/tests/Makefile.am: Add new test runner.

2023-08-21  Werner Koch  <wk@gnupg.org>

	Release 1.22.0.
	+ commit 8ea7015a230eed6239298d725adf7751c5fb84ea


2023-08-17  NIIBE Yutaka  <gniibe@fsij.org>

	build: New configure option --with-libtool-modification.
	+ commit dacbd51c3f8ae6dafe56b3d4b4d15c8d62254230
	* Makefile.am (EXTRA_DIST): Add build-aux/libtool-patch.sed.
	* build-aux/libtool-patch.sed: New.
	* configure.ac (--with-libtool-modification): New.
	* build-aux/ltmain.sh: Revert our own local modification.

2023-08-16  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Clean up after failure or cancel of sign/encrypt archive operation.
	+ commit 40ca3d58963884a876c826dcf5c32673b8ddc084
	* lang/qt/src/qgpgmeencryptarchivejob.cpp (encrypt): Remove output file
	if operation was canceled or failed.
	* lang/qt/src/qgpgmesignarchivejob.cpp (sign): Ditto.
	* lang/qt/src/qgpgmesignencryptarchivejob.cpp (sign_encrypt): Ditto.

	* lang/qt/tests/run-encryptarchivejob.cpp (CommandLineOptions): Add
	field cancelTimeout.
	(parseCommandLine): Add option --cancel-after. Parse option value.
	(main): Check for invalid cancel timeout. Start timer for canceling
	the job.
	* lang/qt/tests/run-signarchivejob.cpp (CommandLineOptions): Add
	field cancelTimeout.
	(parseCommandLine): Add option --cancel-after. Parse option value.
	(main): Check for invalid cancel timeout. Start timer for canceling
	the job.

2023-08-15  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Make toLogString helper public.
	+ commit c3171d0cf1a249618f0763fe141ab84d8a4be240
	* lang/qt/src/util.h: Move toLogString ...
	* lang/qt/src/debug.h: ... here.
	* lang/qt/tests/run-importjob.cpp (main): Use toLogString.

2023-08-14  Ingo Klöcker  <dev@ingo-kloecker.de>

	tests: Support offline mode in run-import.
	+ commit 150a2f9e4e5afe359fec2bbb017f6d0cfa7ca4a7
	* tests/run-import.c (show_usage): New option --offline.
	(main): Parse new option. Set offline mode accordingly.

	core: Use offline mode for all operations of gpgsm engine.
	+ commit bc98f01c8599f612dd1035b08f827b0657d94984
	* src/engine-backend.h (keylist, keylist_ext): Remove engine_flags.
	* src/engine-gpg.c (gpg_keylist, gpg_keylist_ext): Ditto.
	* src/engine.c, src/engine.h (_gpgme_engine_op_keylist): Ditto.
	(_gpgme_engine_op_keylist_ext): Ditto.
	* src/engine.h (GPGME_ENGINE_FLAG_OFFLINE): Remove.
	* src/engine-gpgsm.c (struct engine_gpgsm): New field flags with offline
	flag.
	(have_gpgsm_version): New.
	(gpg_set_engine_flags): Set the offline flag.
	(start): Send OPTION "offline".
	(gpgsm_keylist, gpgsm_keylist_ext): Remove engine_flags.  Remove
	sending of OPTION "offline".
	* src/keylist.c (gpgme_op_keylist_start, gpgme_op_keylist_ext_start):
	Remove setting of offline flag.

	core: Store engine's version string in gpgsm engine.
	+ commit d72811a2c09411f8fdc821eb78d16ce8fbd5a184
	* src/engine-gpgsm.c (struct engine_gpgsm): Add field 'version'.
	(gpgsm_new): Copy version string.
	(gpgsm_release): Free VERSION.

2023-08-04  Carl Schwan  <carl.schwan@gnupg.com>

	cpp: Expose gpgme_decrypt_result_t.is_mime through cpp API.
	+ commit 8701e989376dfa772f299fe41bf4a60a98f8564e
	* lang/cpp/src/descriptionresult.cpp (DescriptionResult::isMime): New.
	* lang/cpp/src/descriptionresult.h: Update accordingly.

2023-08-03  Carl Schwan  <carl.schwan@gnupg.com>

	qt: Add setInputEncoding to QGpgMe::EncryptJob.
	+ commit d91d037fc19f0bbec44210099dc0d0e358d3fd4a
	* lang/qt/src/encryptjob.cpp, lang/qt/src/encryptjob.h,
	lang/qt/src/encryptjob_p.h: Add inputEncoding/setInputEncoding
	to EncryptJob
	* lang/qt/src/qgpgmeencryptjob.cpp: Use newly added inputEncoding
	to set encoding hint of the encrypted content

2023-07-28  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Prevent wrong plaintext when verifying clearsigned signature.
	+ commit a9b28c79e92f6194ea52c7d33213f2a0dc9bd013
	* src/engine-gpg.c (gpg_verify): Use a separate pipe instead of stdout
	for reading the plaintext.

	* tests/gpg/t-support.h (PGM): Define if undefined.
	(print_data): Undefine BUF_SIZE.
	(check_data): New.
	* tests/gpg/t-verify.c (clearsigned_plus_key_block): New.
	(main): Add test.

	core: Return bad data error instead of general error on unexpected data.
	+ commit 777cf7f2d17331cfe127129c750121970fcad58f
	* src/verify.c (_gpgme_verify_status_handler): Return GPG_ERR_BAD_DATA
	instead of GPG_ERR_GENERAL.

2023-07-28  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update libassuan.m4 for libassuan version 3 in future.
	+ commit 0518ed32e254faaa1f5ae61593ab17e8485388a6
	* m4/libassuan.m4: Update from libassuan master.

2023-07-08  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Ensure that we check the correct paths.
	+ commit e3defc0adf68de74a735abae334739771838f191
	* lang/qt/src/QGpgmeConfig-w32.cmake.in.in,
	lang/qt/src/QGpgmeQt6Config-w32.cmake.in.in: Get paths to check from
	the target properties.

2023-07-08  Ingo Klöcker  <dev@ingo-kloecker.de>
	    Biswapriyo Nath  <nathbappai@gmail.com>

	qt: Fix DLL version in cmake config files.
	+ commit be0e653ce3039b1a81d23bed9dc99c0e60a7995a
	* lang/qt/src/QGpgmeConfig-w32.cmake.in.in,
	lang/qt/src/QGpgmeQt6Config-w32.cmake.in.in: Fix name and path of DLL.

2023-07-08  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Fix check for required files.
	+ commit ad34fcbbec3fc3a1a7d1232afd2e4f55119e2cb6
	* lang/qt/src/QGpgmeConfig-w32.cmake.in.in: Fix typos in variable names.

2023-07-07  Werner Koch  <wk@gnupg.org>

	Release 1.21.0.
	+ commit 5bf3e6d0754a179b316f90a885371af99bc03ea1


2023-06-23  NIIBE Yutaka  <gniibe@fsij.org>

	build: Add BUILT_SOURCE for better dependency.
	+ commit 05ac1ce09ff199c715805cf601ea6d65e26c1fff
	* Makefile.am (BUILT_SOURCE): Add conf/config.h.

2023-06-21  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Support reading signed/encrypted archives directly from a file.
	+ commit 1c2459a5927866931808141ac6c4157cd5e3a157
	* lang/qt/src/decryptverifyarchivejob.cpp,
	lang/qt/src/decryptverifyarchivejob.h (DecryptVerifyArchiveJob): Add
	member functions setInputFile, inputFile.
	* lang/qt/src/decryptverifyarchivejob_p.h
	(DecryptVerifyArchiveJobPrivate): Add member m_inputFilePath.
	* lang/qt/src/qgpgmedecryptverifyarchivejob.cpp (decrypt_verify): Move
	creation of indata to decrypt_verify_from_io_device.
	(decrypt_verify_from_io_device, decrypt_verify_from_file_name): New.
	(QGpgMEDecryptVerifyArchiveJob::start): Use
	decrypt_verify_from_io_device instead of decrypt_verify.
	(QGpgMEDecryptVerifyArchiveJobPrivate::startIt): Start the job with the
	values from member variables.

	* lang/qt/tests/run-decryptverifyarchivejob.cpp (createInput): Remove.
	(main): Remove creation of input. Make the job read the archive directly
	from the given archive name.

	core: Support reading the archive to decrypt/verify directly from a file
	+ commit 1a9f192ab450288aea7a889527e78afd2c067b59
	* src/engine-gpg.c (add_file_name_arg_or_data): New.
	(gpg_decrypt): Use add_file_name_arg_or_data instead of add_data for the
	ciphertext.
	(gpg_verify): Use add_file_name_arg_or_data instead of add_data for the
	signature and the signed text.

	* tests/run-decrypt.c (show_usage): New option --direct-file-io.
	(main): Parse new option. If option is given, then don't open input
	file, create simple data object instead of data object from stream and
	set input file name on input data.
	* tests/run-verify.c (show_usage): New option --direct-file-io.
	(main): Parse new option. If option is given, then don't open input
	files, create simple data objects instead of data objects from stream
	and set input file names on input data objects.

2023-06-19  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Support writing signed/encrypted archives directly to a file.
	+ commit e608315392cc5b7ddf51e16dce5fe7e99b83f011
	* lang/qt/src/encryptarchivejob.cpp, lang/qt/src/encryptarchivejob.h
	(EncryptArchiveJob): Add member functions setRecipients, recipients,
	setInputPaths, inputPaths, setOutputFile, outputFile,
	setEncryptionFlags, encryptionFlags.
	* lang/qt/src/encryptarchivejob_p.h (EncryptArchiveJobPrivate): Add
	members m_recipients, m_inputPaths, m_outputFilePath, m_encryptionFlags.
	* lang/qt/src/qgpgmeencryptarchivejob.cpp (encrypt): Move creation of
	outdata to encrypt_to_io_device.
	(encrypt_to_io_device, encrypt_to_filename): New.
	(QGpgMEEncryptArchiveJob::start): Use encrypt_to_io_device instead of
	encrypt.
	(QGpgMEEncryptArchiveJobPrivate::startIt): Start the job with the
	values from member variables.
	* lang/qt/src/qgpgmesignarchivejob.cpp (sign): Move creation of
	outdata to sign_to_io_device.
	(sign_to_io_device, sign_to_filename): New.
	(QGpgMESignArchiveJob::start): Use sign_to_io_device instead of sign.
	(QGpgMESignArchiveJobPrivate::startIt): Start the job with the
	values from member variables.
	* lang/qt/src/qgpgmesignencryptarchivejob.cpp (sign_encrypt): Move
	creation of outdata to sign_encrypt_to_io_device.
	(sign_encrypt_to_io_device, sign_encrypt_to_filename): New.
	(QGpgMESignEncryptArchiveJob::start): Use sign_encrypt_to_io_device
	instead of sign_encrypt.
	(QGpgMESignEncryptArchiveJobPrivate::startIt): Start the job with the
	values from member variables.
	* lang/qt/src/signarchivejob.cpp, lang/qt/src/signarchivejob.h
	(SignArchiveJob): Add member functions setSigner, signers,
	setInputPaths, inputPaths, setOutputFile, outputFile.
	* lang/qt/src/signarchivejob_p.h (SignArchiveJobPrivate): Add
	members m_signers, m_inputPaths, m_outputFilePath.
	* lang/qt/src/signencryptarchivejob.cpp,
	lang/qt/src/signencryptarchivejob.h (SignEncryptArchiveJob): Add
	member functions setSigner, signers, setRecipients, recipients,
	setInputPaths, inputPaths, setOutputFile, outputFile,
	setEncryptionFlags, encryptionFlags.
	* lang/qt/src/signencryptarchivejob_p.h (SignEncryptArchiveJobPrivate):
	Add members m_signers, m_recipients, m_inputPaths, m_outputFilePath,
	m_encryptionFlags.

	* lang/qt/tests/run-encryptarchivejob.cpp (createOutput): Remove.
	(checkOutputFilePath): New.
	(main): Create file output writing to stdout if no archive name (or "-")
	is given. Exit if file with given archive name already exists. Make
	the jobs write the created archive directly to the given archive name.
	* lang/qt/tests/run-signarchivejob.cpp (createOutput): Remove.
	(checkOutputFilePath): New.
	(main): Create file output writing to stdout if no archive name (or "-")
	is given. Exit if file with given archive name already exists. Make
	the jobs write the created archive directly to the given archive name.

	core: Support writing the sign/encrypt output directly to a file.
	+ commit c38b6200396f703917e4c66aca068f90cfbad325
	* src/engine-gpg.c (gpg_encrypt): Pass output file name to gpg if output
	has file name set.
	(gpg_encrypt_sign): Ditto.
	(gpg_sign): Ditto.

	* tests/run-encrypt.c (show_usage): New option --output.
	(main): Parse new option. Set file name on output if --output is given.
	Do not print output if --output is given.
	* tests/run-sign.c (show_usage): New option --output.
	(main): Parse new option. Set file name on output if --output is given.
	Do not print output if --output is given.

	qt: Add a generic hook to start a job.
	+ commit 8b9fabf5d55419a68c2b0fc7fd1a90517c881d78
	* lang/qt/src/job.cpp, lang/qt/src/job.h (Job::startIt): New method.
	* lang/qt/src/job_p.h (JobPrivate::startIt): New pure virtual method.
	* lang/qt/src/qgpgmechangeexpiryjob.cpp
	(QGpgMEChangeExpiryJobPrivate::startIt): New.
	* lang/qt/src/qgpgmedecryptverifyarchivejob.cpp
	(QGpgMEDecryptVerifyArchiveJobPrivate::startIt): New.
	* lang/qt/src/qgpgmeencryptarchivejob.cpp
	(QGpgMEEncryptArchiveJobPrivate::startIt): New.
	* lang/qt/src/qgpgmeencryptjob.cpp (QGpgMEEncryptJobPrivate::startIt):
	New.
	* lang/qt/src/qgpgmeimportjob.cpp (QGpgMEImportJobPrivate::startIt):
	New.
	* lang/qt/src/qgpgmelistallkeysjob.cpp
	(QGpgMEListAllKeysJobPrivate::startIt): New.
	* lang/qt/src/qgpgmesignarchivejob.cpp
	(QGpgMESignArchiveJobPrivate::startIt): New.
	* lang/qt/src/qgpgmesignencryptarchivejob.cpp
	(QGpgMESignEncryptArchiveJobPrivate::startIt): New.
	* lang/qt/src/qgpgmesignencryptjob.cpp
	(QGpgMESignEncryptJobPrivate::startIt): New.

	qt: Make the run methods of ThreadedJobMixin public.
	+ commit 23526c3ff26be11e4ebb1294b6f60202881a066c
	* lang/qt/src/threadedjobmixin.h (ThreadedJobMixin::run): Make all
	overloads public.

	qt: Rename JobPrivate::start to JobPrivate::startNow.
	+ commit 4655b2dc6b33aca3bd6737eadadfb8afcf8694bd
	* lang/qt/src/job_p.h (JobPrivate::start): Rename to startNow.
	* lang/qt/src/job.cpp (Job::startNow): Adapt function call.
	* lang/qt/src/qgpgmechangeexpiryjob.cpp
	(QGpgMEChangeExpiryJobPrivate::start): Rename to startNow.
	* lang/qt/src/qgpgmedecryptverifyarchivejob.cpp
	(QGpgMEDecryptVerifyArchiveJobPrivate::start): Rename to startNow.
	* lang/qt/src/qgpgmeencryptarchivejob.cpp
	(QGpgMEEncryptArchiveJobPrivate::start): Rename to startNow.
	* lang/qt/src/qgpgmeencryptjob.cpp (QGpgMEEncryptJobPrivate::start):
	Rename to startNow.
	* lang/qt/src/qgpgmeimportjob.cpp (QGpgMEImportJobPrivate::start):
	Rename to startNow.
	* lang/qt/src/qgpgmelistallkeysjob.cpp
	(QGpgMEListAllKeysJobPrivate::start): Rename to startNow.
	* lang/qt/src/qgpgmesignarchivejob.cpp
	(QGpgMESignArchiveJobPrivate::start): Rename to startNow.
	* lang/qt/src/qgpgmesignencryptarchivejob.cpp
	(QGpgMESignEncryptArchiveJobPrivate::start): Rename to startNow.
	* lang/qt/src/qgpgmesignencryptjob.cpp
	(QGpgMESignEncryptJobPrivate::start): Rename to startNow.

	qt: Return const pointer to JobPrivate class for const pointer to Job.
	+ commit 6f6b35df505af108669bd6ff8c351c970130eb45
	* lang/qt/src/job.cpp, lang/qt/src/job_p.h (getJobPrivate): Replace with
	two overloads for non-const pointer and const pointer to Job.
	* lang/qt/src/job_p.h (jobPrivate): Replace with two template functions
	for non-const pointer and const pointer to Job.

2023-06-16  Andre Heinecke  <aheinecke@gnupg.org>

	qt, cpp: Support larger size-hint on 32 bit builds.
	+ commit 5811d069d3b391e9fd77c1062a2d96be41645422
	* NEWS: Mention this.
	* lang/cpp/src/data.h, lang/cpp/src/data.cpp (Data::setSizeHint): New.
	* lang/qt/src/qgpgmedecryptjob.cpp,
	 lang/qt/src/qgpgmedecryptverifyarchivejob.cpp,
	 lang/qt/src/qgpgmedecryptverifyjob.cpp,
	 lang/qt/src/qgpgmeencryptjob.cpp,
	 lang/qt/src/qgpgmesignencryptjob.cpp,
	 lang/qt/src/qgpgmesignjob.cpp,
	 lang/qt/src/qgpgmeverifydetachedjob.cpp,
	 lang/qt/src/qgpgmeverifyopaquejob.cpp: Set size for input IODevice.

	cpp: Expose gpgme_data_set_flag through cpp API.
	+ commit cbcea4a09b1309a4bd822247a8dfcdcb73041f9c
	* lang/cpp/src/data.cpp (Data::setFlag): New.
	* lang/cpp/src/data.h: Update accordingly.
	* NEWS: Mention this.

2023-06-15  Werner Koch  <wk@gnupg.org>

	core: Send a input-size-hint for gpgsm.
	+ commit 91bbb1e482da783b4d1b9d5f663a1a0af77fc0a4
	* src/engine-gpgsm.c (send_input_size_hint): New.
	(gpgsm_decrypt): Send hint.
	(gpgsm_encrypt): Send hint.
	(gpgsm_sign): Send hint.
	(gpgsm_verify): Send hint.

	tests: Add option --cancel to run-encrypt.
	+ commit 8796456d235d2d7a8a1ce7337abc1d4d149bcf9a
	* tests/run-encrypt.c (cancel_after_progress): New.
	(progress_cb): Take care of it.
	(main): Add option --cancel.

	core: Use 64 bit instead of gpgme_off_t for some internal functions.
	+ commit eb68948c438814b99b81adf44b674738d0b1be34
	* src/conversion.c (_gpgme_string_to_off): Return an u64 value.
	* src/data.c (_gpgme_data_get_size_hint): Ditto.
	(gpgme_data_set_flag): Use u64 for io-buffer-size due to string_to_off
	change.
	* src/data.h (struct gpgme_data): Change size_hint to u64.
	* src/engine-gpg.c (add_input_size_hint): Replace gpgme_off_t by u64.

2023-06-13  Andre Heinecke  <aheinecke@gnupg.org>

	Fix definition of GPG_ERR_ENABLE_GETTEXT_MACROS.
	+ commit 7e6d51aa6fc97bed12486540167e9b710c9a3378
	* configure.ac: Add missing value.

2023-06-01  Ingo Klöcker  <dev@ingo-kloecker.de>

	doc,cpp: Treat GPG_ERR_FULLY_CANCELED as canceled.
	+ commit 7990f70107bc8487f954c6885436a7661e162929
	* doc/gpgme.texi (GPG_ERR_FULLY_CANCELED): New.
	* lang/cpp/src/context.cpp (Error::isCanceled): Also return true for
	GPG_ERR_FULLY_CANCELED.

2023-05-30  Biswapriyo Nath  <nathbappai@gmail.com>

	cpp,python: Respect --disable-gpg-test for tests.
	+ commit e2103be390764f62b21a4e5d4fa90a7b78326787
	lang/cpp/Makefile.am (SUBDIRS): Depend tests in RUN_GPG_TESTS.
	lang/python/Makefile.am (SUBDIRS): Ditto.

2023-05-30  Werner Koch  <wk@gnupg.org>

	core: For key signing and uid revoking allow an empty user id.
	+ commit fbc3963d6229853fe9fb1fd599ef39ed0fe2eae6
	* src/engine-gpg.c (gpg_keysign): Required USERID to be non-empty.

2023-05-23  Werner Koch  <wk@gnupg.org>

	python: Fix wrong use of write.
	+ commit 36a68bc5308c0b4a541ca6adea5d3635217e8af2
	* lang/python/helpers.c (pyPassphraseCb): Use gpgme_io_writen.
	(_gpg_interact_cb): Ditto.
	* lang/python/helpers.h (write) [W32]: Remove bad write macro.

2023-05-16  NIIBE Yutaka  <gniibe@fsij.org>

	build: Sync to libtool from libgpg-error for 64-bit Windows.
	+ commit e622e36f1f32641c66b28a0de95c75ae35f6ca05
	* build-aux/ltmain.hs: Update from libgpg-error.

2023-04-26  NIIBE Yutaka  <gniibe@fsij.org>
	    Ingo Klöcker

	doc: Fix Python example code.
	+ commit d44a473e27160a35268789e14dccd0ad55af0690
	* lang/python/doc/src/gpgme-python-howto.org: Fix chmod race.
	* lang/python/examples/howto/export-secret-key.py: Likewise.
	* lang/python/examples/howto/export-secret-keys.py: Likewise.
	* lang/python/examples/howto/temp-homedir-config.py: Likewise.

2023-04-20  Werner Koch  <wk@gnupg.org>

	Release 1.20.0.
	+ commit 451ed47434c5ffd2916adae25e5a128606b5ef98


	core: Support the new macOS Homebrew location.
	+ commit 7351ef32ce7c04d20ee32fc9b645a1931b3b0aba
	* src/posix-util.c (find_executable): Extend the path.

2023-04-19  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,qt: Simplify check for moc.
	+ commit a14155d2c1b2ddc167dbf278faf1d6b469575492
	m4/qt6.m4: Remove alternative checks for moc that were taken over from
	Qt 5 and that are obsolete for Qt 6.

	Update NEWS.
	+ commit e80bf34bf86f6f183145c31d598dda41c0496a4d
	* NEWS: Add news for recent changes

2023-04-18  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Fix Key::canSign()
	+ commit 5bd84cfd3f092703bb4b9b993be7d89ca13b36b0
	* lang/cpp/src/key.h (canReallySign): Deprecate.
	* lang/cpp/src/key.cpp (canSign): Remove workaround. Use implementation
	of canReallySign.
	(canReallySign): Use canSign().
	(operator<<): Use canSign().

2023-04-17  Werner Koch  <wk@gnupg.org>

	core: Avoid printf format warnings due to gpgme_ssize_t.
	+ commit 7d1159c1e99bb1bae0ab698c85105dcdcb95b7ea
	* src/debug.h (_trace_sysres_ssize_t): Cast arg.

	core,w32: Fix invocation of gpgtar.
	+ commit 0c29119e061cbdcb7342380938a25af91290f1a0
	* src/dirinfo.c (EXEEXT_S): New.
	(get_gpgconf_item): Append ".exe" to gpg-wks-client and gpgtar.

	* src/gpgme-w32spawn.c (mystderr): Add code to ease debugging.

2023-04-06  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update gpg-error.m4.
	+ commit 806a5d18b988449fbaa3c2e6380acf3ae4580f4a
	* m4/gpg-error.m4: Update from libgpg-error master.

2023-04-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	w32: Always use UTF-8 for localized texts.
	+ commit d256ba7cc57d9bfcfa05fb05cf66dc992efbb695
	* configure.ac: Define GPG_ERR_ENABLE_GETTEXT_MACROS.
	* src/version.c (do_subsystem_inits) [W32]: Switch gettext to UTF-8.

2023-03-27  Werner Koch  <wk@gnupg.org>

	core: Minor code cleanup.
	+ commit 34cc7daba12a2a6baa3cfa337762656c210686fa
	* src/engine-gpg.c (build_argv): Remove superfluous tes.

2023-03-27  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Initialize error variable.
	+ commit b608c084b9220d8ed288eb916e88a236abac0707
	* src/engine-gpg.c (build_argv): Initialize err.

2023-03-21  Werner Koch  <wk@gnupg.org>

	core,cpp: Add new key flags to gpgme_subkey_t.
	+ commit 6d21256c9220df05bf92a695a787dde13fe44ca7
	* src/gpgme.h.in (struct _gpgme_subkey): Add bit flags can_renc,
	can_timestamp, adn is_group_owned. Reduce size of _unused.
	* src/keylist.c (set_subkey_capability): Set them.
	* tests/run-keylist.c (main): Print them.

	* lang/cpp/src/key.h (Subkey::canRenc): New.
	(Subkey::canTimestamp): New.
	(Subkey::isGroupOwned): New.
	* lang/cpp/src/key.cpp: Implement new methods.
	(Subkey::isQualified): Print them.
	(std::ostream &operator<<): Print them.

2023-03-17  Werner Koch  <wk@gnupg.org>

	Release 1.19.0.
	+ commit 96a30fdf30626a7cefd9c9e620a60817ef44fde2


2023-03-17  Ben Greiner (bnavigator)  <unknown@dev.gnupg.org>

	python: Update python.m4 configure script.
	+ commit d086653cc346d5634bc742d5586e927fc9ee57cf
	* configure.ac: Unset PYTHON_LIBS.  Support python 3.10.
	* m4/python.m4: Find correct version string for python >= 3.10.

2023-03-17  Ingo Klöcker  <dev@ingo-kloecker.de>

	tests: Package the ownertrust file.
	+ commit e50724e1bbe55678dfcd2a1ea75157f6514fc58a
	tests/gpg/Makefile.am (EXTRA_DIST): Add ownertrust.txt.

2023-03-08  Werner Koch  <wk@gnupg.org>

	core: Also detect legacy X.509 v0 certificates.
	+ commit c1f6535f144dedfbf5507f850d4da5b61fd5ec74
	* src/data-identify.c (basic_detection): Loose the detection of X.509
	certs.

	tests: Add option --binary to run-verify.
	+ commit 76351c4877d60799a35afccd87037d5dd0871262
	* tests/run-verify.c (main): Set encoding.

2023-02-14  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add signals for file-based and data-based progress.
	+ commit 73e46b34658c0130de5ab9e3f4ce1ac4ee35c5e2
	* lang/qt/src/decryptverifyarchivejob.h (DecryptVerifyArchiveJob): Add
	signals fileProgress and dataProgress.
	* lang/qt/src/encryptarchivejob.h (EncryptArchiveJob): Ditto.
	* lang/qt/src/signarchivejob.h (SignArchiveJob): Ditto.
	* lang/qt/src/signencryptarchivejob.h (SignEncryptArchiveJob): Ditto.
	* lang/qt/src/job_p.h (emitArchiveProgressSignals): New.
	* lang/qt/src/qgpgmedecryptverifyarchivejob.cpp
	(QGpgMEDecryptVerifyArchiveJob::QGpgMEDecryptVerifyArchiveJob): Emit
	appropriate signal when receiving Job::rawProgress signal.
	* lang/qt/src/qgpgmeencryptarchivejob.cpp
	(QGpgMEEncryptArchiveJob::QGpgMEEncryptArchiveJob): Ditto.
	* lang/qt/src/qgpgmesignarchivejob.cpp
	(QGpgMESignArchiveJob::QGpgMESignArchiveJob): Ditto.
	* lang/qt/src/qgpgmesignencryptarchivejob.cpp
	(QGpgMESignEncryptArchiveJob::QGpgMESignEncryptArchiveJob): Ditto.

	qt: Add simple and extended progress signals replacing old signal.
	+ commit ea6f15ed602eeb9fa87766ba88acc78361a14b38
	* lang/qt/src/job.h (Job): Add signals jobProgress and rawProgress.
	Deprecate signal progress.
	* lang/qt/src/multideletejob.cpp (MultiDeleteJob::slotResult): Emit
	new progress signals.
	* lang/qt/src/qgpgmerefreshsmimekeysjob.cpp
	(QGpgMERefreshSMIMEKeysJob::slotStatus): Ditto.
	* lang/qt/src/threadedjobmixin.h (ThreadedJobMixin::showProgress): Use
	modern overload of QMetaObject::invokeMethod to forward the progress
	signal and add the value of what. Add forwarding of progress to the new
	signals.

	* lang/qt/tests/t-encrypt.cpp (EncryptionTest::testProgress): Test
	the new signals instead of the deprecated one.

2023-02-10  Werner Koch  <wk@gnupg.org>

	core: Switch to logging via gpgrt.
	+ commit 9c5506fde701f637381614dcfe22e3f9dc82955d
	* src/debug.c (errfp): Remove.
	(debug_init): Factor some code out to ...
	(safe_to_use_debug_file): new.
	(tid_log_callback): New.
	(debug_init): Rewrite to make use of gpgrt logging.
	(_gpgme_debug): Ditto.
	(_gpgme_debug_end): Remove extra LF testing code.
	* src/dirinfo.c (get_gpgconf_item): Remove now unneeded LFs.  Realign
	output.

2023-02-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	tests: Fix cleaning up at the end of the test.
	+ commit 21283dfd1be1e56bc174cf5f12461888af7ab8b5
	* tests/gpg/t-import.c (main): Unref key and release context.

	core: Allow finalization of signature verification of unencrypted data.
	+ commit 41dc3bd22a3e0001abec8f2bea79b40ee5ad00be
	* src/decrypt-verify.c (decrypt_verify_status_handler): Call
	_gpgme_verify_status_handler on EOF even if
	_gpgme_decrypt_status_handler returned NO DATA error.

	* tests/gpg/t-decrypt-verify.c (normal_signed_message): New.
	(main): Add test with signed, but not encrypted data.

2023-02-09  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Improve debug output of some enums.
	+ commit 3aaed9cfbfd6821b2e812fbdd24448953d6ca279
	* lang/cpp/src/verificationresult.cpp (operator<<): Fix output of
	Signature::PKAStatus which doesn't represent flags. Print corresponding
	name of enum value if Signature::Summary or Notation::Flags are 0.

	tests: Stop daemons after setting up test environment.
	+ commit 7098c14b231113055535abb14b4cde0c845f8728
	* lang/python/tests/Makefile.am, lang/qt/tests/Makefile.am,
	tests/gpg/Makefile.am, tests/json/Makefile.am (pubring-stamp): Call
	`gpgconf --kill all` after importing test keys.

2023-02-08  Ingo Klöcker  <dev@ingo-kloecker.de>

	tests: Extend tests with an ultimately trusted key.
	+ commit fcefc78f749a8f39cc587636647b24f8fa48efad
	* tests/gpg/Makefile.am (gpg-sample.stamp, pubring-stamp): Unify usage
	of tabs.
	(pubring-stamp): Import owner trust values.
	* tests/gpg/ownertrust.txt: New.
	* tests/gpg/t-decrypt-verify.c, tests/gpg/t-verify.c: Update expected
	values for signature summary and validity.
	* tests/gpg/t-keylist-secret-sig.c, tests/gpg/t-keylist-sig.c,
	tests/gpg/t-keylist.c: Update expected values of owner trust and uid
	validity.

	tests: Make t-edit-sign idempotent.
	+ commit 844e6cd3b923834727f042b92d6a9a2db86b3fed
	* tests/gpg/t-edit-sign.c (test_key, test_key_fpr, import_key,
	delete_key): New.
	(main): Remove key_fpr. Import test key to sign. Delete test key after
	test.

2023-02-02  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt,tests: Add test for the previous commit.
	+ commit 52fd0bcde47a676ee1021c870b50e2add78d6973
	* lang/qt/tests/t-decryptverify.cpp: New.
	* lang/qt/tests/Makefile.am: Add new test.

	cpp: Return successful verification for signed but not encrypted data.
	+ commit 1698eec2ae3ec1a97c739e892d9cf288c0ec4ccd
	* lang/cpp/src/context.cpp (Context::decrypt): Use decryptionResult().
	(Context::verifyDetachedSignature, Context::verifyOpaqueSignature):
	Use verificationResult().
	(Context::verificationResult): Ignore "no data" error for signed but
	not encrypted data.
	(Context::decryptAndVerify): Use decryptionResult() and
	verificationResult().

	qt: Add job for extracting encrypted and signed archives.
	+ commit c407728064ca0c9b2f365437c6a7f2acc40e6d84
	* lang/qt/src/decryptverifyarchivejob.cpp,
	lang/qt/src/decryptverifyarchivejob.h,
	lang/qt/src/decryptverifyarchivejob_p.h,
	lang/qt/src/qgpgmedecryptverifyarchivejob.cpp,
	lang/qt/src/qgpgmedecryptverifyarchivejob.h: New.
	* lang/qt/src/protocol.h (class Protocol): Add pure virtual member
	function decryptVerifyArchiveJob
	* lang/qt/src/protocol_p.h (Protocol::decryptVerifyArchiveJob): ... and
	implement it.
	* lang/qt/src/Makefile.am: Update accordingly.

	* lang/qt/tests/run-decryptverifyarchivejob.cpp: New.
	* lang/qt/tests/Makefile.am: Add new test runner.

	core: Make usage of input size hint compatible with gpgtar.
	+ commit 7ad717f6ba00046a26a99d015d701a178ca30630
	* src/engine-gpg.c (add_input_size_hint): Use add_gpg_arg_with_value
	to add the --input-size-hint option.

	cpp: Update decryption flags.
	+ commit b3bdf14b37a313c21de61168e5e7545ab08fea13
	* lang/cpp/src/context.h (DecryptArchive): New flag.

	qt: Allow checking if the sign/encrypt archive jobs are supported.
	+ commit 55c948866fb8bf4adbf0c8f53edf51a4075b753e
	* lang/qt/src/encryptarchivejob.cpp, lang/qt/src/encryptarchivejob.h
	(isSupported): New.
	* lang/qt/src/signarchivejob.cpp, lang/qt/src/signarchivejob.h
	(isSupported): New.
	* lang/qt/src/signencryptarchivejob.cpp,
	lang/qt/src/signencryptarchivejob.h (isSupported): New.

	* lang/qt/tests/run-encryptarchivejob.cpp (main),
	lang/qt/tests/run-signarchivejob.cpp (main): Check if jobs are
	supported.

	cpp: Add const-overloads of version comparison operators.
	+ commit 84780646910cdd91555a368650e3d92cf52b86bd
	* lang/cpp/src/engineinfo.h (EngineInfo::Version): Add const-overloads
	of all comparison operators.

	core: Allow usage of gpgtar also for new enough gpg 2.2.
	+ commit 7f541547fc1783bb9ea119695fb76e2000bdfcf8
	* src/engine-gpg.c (have_usable_gpgtar): New.
	(start): Always pass --status-fd to the called process.
	(gpg_decrypt, gpg_encrypt, gpg_encrypt_sign, gpg_sign, gpg_verify):
	Use have_usable_gpgtar() to check for suitable gpg.

2023-02-01  Werner Koch  <wk@gnupg.org>

	core,w32: More robust detection of GnuPG Desktop dir layout.
	+ commit 5ab9c234d6b507f568fe1d2a2cbc82250a7828ee
	* src/w32-util.c (INST_TYPE_GPG4WIN, INST_TYPE_GPGDESK): New to
	replace the numeric constants.
	(find_version_file): New.
	(_gpgme_get_gpgconf_path): Guess a default for inst_type.

2023-01-31  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Fix build without installed gpgme++ headers.
	+ commit 343fb33bf02bea74caf4e615483f1a00dc06f7b8
	* lang/qt/src/filelistdataprovider.cpp: Include error.h without
	folder prefix.

	qt: Remove unused and commented-out code.
	+ commit d3a8c2c8b68b290a642c83c53a5989ee7fdc6331
	* lang/qt/src/qgpgmeencryptarchivejob.cpp,
	lang/qt/src/qgpgmeencryptarchivejob.h (QGpgMEEncryptArchiveJob):
	Remove member function resultHook and member mResult.
	* lang/qt/src/qgpgmesignarchivejob.cpp,
	lang/qt/src/qgpgmesignarchivejob.h (QGpgMESignArchiveJob):
	Remove member function resultHook and member mResult.

	cpp: Fix debug output of SignatureMode.
	+ commit 41a30f6d9f59b08213ab2c307036be9bc9b6f876
	* lang/cpp/src/context.cpp (operator<<): Treat signature mode as
	combination of a 2-bit flag and a 1-bit flag.

	qt: Add job for creating encrypted signed archives.
	+ commit 8c4436e73af369f79f125f56d020d01b184cafc6
	* lang/qt/src/signencryptarchivejob.cpp,
	lang/qt/src/signencryptarchivejob.h,
	lang/qt/src/signencryptarchivejob_p.h,
	lang/qt/src/qgpgmesignencryptarchivejob.cpp,
	lang/qt/src/qgpgmesignencryptarchivejob.h: New.
	* lang/qt/src/protocol.h (class Protocol): Add pure virtual member
	function signEncryptArchiveJob
	* lang/qt/src/protocol_p.h (Protocol::signEncryptArchiveJob): ... and
	implement it.
	* lang/qt/src/Makefile.am: Update accordingly.

	* lang/qt/tests/run-encryptarchivejob.cpp (displayName): Remove.
	(CommandLineOptions): Initialize member armor. Add member sign.
	(parseCommandLine): Update application description. Add and parse option
	-s/--sign.
	(main): Use SignEncryptArchiveJob if sign option is set.

	qt,tests: Avoid leaking Context.
	+ commit 2b98585c89c1654aa736777eeb92ff79d5fdd72b
	* lang/qt/tests/t-import.cpp: Wrap Context*s in unique_ptr.

2023-01-31  Werner Koch  <wk@gnupg.org>

	json: New operation "identify" and convenience option --identify.
	+ commit 359378c5b3f3aaf274dfc33861978c3cf6ec60ca
	* src/gpgme-json.c (data_type_to_string): New.
	(op_identify): New.
	(process_request): Add to command list.
	(cmd_identify): New.
	(main): Add option --identify.

2023-01-30  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add job for creating signed archives.
	+ commit 8d672b3b7e5c5d487f20fb742a29fbee21236885
	* lang/qt/src/signarchivejob.cpp, lang/qt/src/signarchivejob.h,
	lang/qt/src/signarchivejob_p.h,
	lang/qt/src/qgpgmesignarchivejob.cpp,
	lang/qt/src/qgpgmesignarchivejob.h: New.
	* lang/qt/src/protocol.h (class Protocol): Add pure virtual member
	function signArchiveJob
	* lang/qt/src/protocol_p.h (Protocol::signArchiveJob): ... and
	implement it.
	* lang/qt/src/Makefile.am: Update accordingly.

	* lang/qt/tests/run-signarchivejob.cpp: New.
	* lang/qt/tests/Makefile.am: Add new test runner.

	cpp: Support new archive signing flag.
	+ commit 2faa031af24959d5093da430d5f10fe30d77a75d
	* lang/cpp/src/global.h (enum SignatureMode): Add constant SignArchive.
	* lang/cpp/src/context.cpp (sigmode2sigmode): Rename to
	sigflags2sigflags
	(sigflags2sigflags): ... and rename argument mode to flags and treat
	it as flags. Adjust the callers.
	(operator<<): Change local CHECK macro to handle flags. Add new flag
	to debug stream.
	* lang/cpp/src/signingresult.cpp (CreatedSignature::mode): Handle
	new flags (even if it cannot occur currently).

	core: Use signature modes as flags.
	+ commit 48b11f576260286bddef3833e25d0059638fe0bb
	* src/engine-backend.h (engine_ops.sign): Rename argument mode to
	flags.
	* src/engine-gpg.c (gpg_sign): Rename argument mode to flags. Check
	for invalid combination of flags.
	* src/engine-gpgsm.c (gpgsm_sign): Rename argument mode to flags.
	Check for unsupported flags.
	* src/engine-uiserver.c (gpgsm_sign): Rename argument mode to flags.
	Check for unsupported flags.
	* src/engine.c, src/engine.h (_gpgme_engine_op_sign): Rename argument
	mode to flags.
	* src/gpgme.h.in (GPGME_SIG_MODE_ARCHIVE): Change value to 4.
	(gpgme_op_sign_start, gpgme_op_sign): Rename argument mode to flags.
	* src/sign.c (sign_start): Rename argument mode to flags. Adjust
	check for invalid flags.
	(gpgme_op_sign_start, gpgme_op_sign): Rename argument mode to flags.

2023-01-27  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add job for creating encrypted archives.
	+ commit 7afd135ccec73585e06272f98b4a0895e3ee6579
	* lang/qt/src/encryptarchivejob.cpp, lang/qt/src/encryptarchivejob.h,
	lang/qt/src/encryptarchivejob_p.h,
	lang/qt/src/qgpgmeencryptarchivejob.cpp,
	lang/qt/src/qgpgmeencryptarchivejob.h: New.
	* lang/qt/src/protocol.h (class Protocol): Add pure virtual member
	function encryptArchiveJob
	* lang/qt/src/protocol_p.h (Protocol::encryptArchiveJob): ... and
	implement it.
	* lang/qt/src/Makefile.am: Update accordingly.

	* lang/qt/tests/run-encryptarchivejob.cpp: New.
	* lang/qt/tests/Makefile.am: Add new test runner.

	qt: Add data provider for list of file names.
	+ commit 275a3a2c16d27e5bc87f7d80af2ee703a92b6758
	* lang/qt/src/Makefile.am: Add new files and corresponding camel-case
	header.
	* lang/qt/src/dataprovider.h: Include interface from gpgme++ when
	not building.
	* lang/qt/src/filelistdataprovider.cpp,
	lang/qt/src/filelistdataprovider.h: New.

	cpp: Support new archive encryption flag.
	+ commit d28ea8c6b3db008150e2bae99a33e30b55c4bc10
	* lang/cpp/src/context.h (EncryptArchive): New flag.
	* lang/cpp/src/context.cpp (encryptflags2encryptflags): Convert
	EncryptArchive to corresponding gpgme encrypt flags.
	(operator<<): Add new flag to debug stream.

	cpp: Add convenience overload to set file name.
	+ commit 261245a2e0e76568607c79a0c80372cb6f46444e
	* lang/cpp/src/data.h, lang/cpp/src/data.cpp (setFileName): Add
	overload.

2023-01-26  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Support all encryption flags.
	+ commit 3e31f648e513bed0029b09104d416d25fca08868
	* lang/cpp/src/context.h (WantAddress): New flag.
	* lang/cpp/src/context.cpp (encryptflags2encryptflags): Convert
	WantAddress to corresponding gpgme encrypt flags.
	(operator<<): Add new flag to debug stream.

	cpp: Pass ThrowKeyIds and EncryptWrap flags to GpgME.
	+ commit 70aaf05a6a3eafd1ba96df71d03334337b1d071d
	* lang/cpp/src/context.cpp (encryptflags2encryptflags): Convert
	ThrowKeyIds and EncryptWrap to corresponding gpgme encrypt flags.
	(operator<<): Add flags to debug stream.

	core: Update required GnuPG version for new archive features.
	+ commit 3580bb139b2e41f6c2397e506ee66f4892ceec62
	* src/engine-gpg.c (gpg_decrypt, gpg_encrypt, gpg_encrypt_sign,
	gpg_sign, gpg_verify): Require gpg 2.4.1.

2023-01-25  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Support usage of gpgtar for verifying a signed archive.
	+ commit 5b79b323971cb0794c45791851d85f8a66f0a441
	* src/gpgme.h.in (gpgme_verify_flags_t): New enum.
	(GPGME_VERIFY_ARCHIVE): New const.
	(gpgme_op_verify_ext_start): New func.
	(gpgme_op_verify_ext): New func.
	* src/gpgme.def, src/libgpgme.vers: Add new functions.
	* src/verify.c (gpgme_op_verify_ext_start): New.
	(gpgme_op_verify_ext): New.
	(verify_start): Add arg FLAGS.  Pass the flags to
	_gpgme_engine_op_verify.
	(gpgme_op_verify_start): Call gpgme_op_verify_ext_start with 0 for
	FLAGS.
	(gpgme_op_verify): Call gpgme_op_verify_ext with 0 for FLAGS.
	* src/engine.c, src/engine.h (_gpgme_engine_op_verify): Add arg FLAGS.
	* src/engine-backend.h (struct engine_ops): Add FLAGS to 'verify'.
	* src/engine-gpg.c (gpg_verify): Add arg FLAGS. Set use_gpgtar engine
	flag if GPGME_VERIFY_ARCHIVE flag is set. Check for new enough gpg. Use
	add_gpg_arg for gpg-only options without a value. Set extra options for
	gpgtar and pass input data to stdin when using gpgtar.
	* src/engine-gpgsm.c (gpgsm_verify): Add arg FLAGS. Return error if
	GPGME_VERIFY_ARCHIVE flag is set.
	* src/engine-uiserver.c (uiserver_verify): Ditto.

	* tests/run-verify.c (show_usage): New options --archive, --directory,
	and --diagnostics.
	(main): Parse new options. Verify and extract with gpgtar if --archive
	is given. Set file name of output data to value of --directory option.
	Print stderr of gpg/gpgtar if --diagnostics is given.

2023-01-24  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Support usage of gpgtar for decrypting an encrypted archive.
	+ commit 95ea3bf831aeac201108876e73750692aa1ba3f5
	* src/gpgme.h.in (GPGME_DECRYPT_ARCHIVE): New decryption flag.
	* src/engine-gpg.c (gpg_decrypt): Set use_gpgtar engine flag if
	GPGME_DECRYPT_ARCHIVE flag is set. Check for new enough gpg and
	incompatible flags. Use add_gpg_arg_with_value for gpg-only options
	with a value and add_gpg_arg for gpg-only options without a value.
	Set extra options for gpgtar and pass input data to stdin when using
	gpgtar.

	* tests/run-decrypt.c (show_usage): New options --archive and
	--directory.
	(main): Parse new options. Decrypt with gpgtar if --archive is given.
	Set file name of output data to value of --directory option.

2023-01-23  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Allow setting the base directory when creating an archive.
	+ commit 419adf41afa40e5b34f646f2cb16d8aebda20048
	* src/engine-gpg.c (gpg_encrypt, gpg_encrypt_sign, gpg_sign): Pass
	file name set in data with --directory option to gpgtar.

	* tests/run-encrypt.c (show_usage): New option --directory.
	(main): Parse new option. Set file name of input data to option value.
	* tests/run-sign.c (show_usage): New option --directory.
	(main): Parse new option. Set file name of input data to option value.

2023-01-19  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Support usage of gpgtar for creating an encrypted signed archive.
	+ commit 29cfcd316d1bfc98ca663369a9503cc169dd3447
	* src/engine-gpg.c (gpg_encrypt_sign): Set use_gpgtar engine flag if
	GPGME_ENCRYPT_ARCHIVE mode is set. Check for new enough gpg. Use
	add_gpg_arg_with_value for gpg-only options with a value and
	add_gpg_arg for gpg-only options without a value. Set extra options for
	gpgtar and pass input data to stdin when using gpgtar.

	* tests/run-encrypt.c (print_result): Rename to print_encrypt_result.
	Print header.
	(print_sign_result): New.
	(show_usage): New option --sign.
	(main): Parse new option. Sign and encrypt --sign is given.
	Print results of signing additionally to results of encryption.

	core: Support usage of gpgtar for creating a signed archive.
	+ commit 0ca45e48b45af1978027e6fe26c7e406fd5ec74b
	* src/gpgme.h.in (GPGME_SIG_MODE_ARCHIVE): New signature mode.
	* src/engine-gpg.c (append_args_from_sender,
	append_args_from_sig_notations): Use add_gpg_arg_with_value
	for gpg-only options with a value.
	(gpg_sign): Set use_gpgtar engine flag if GPGME_SIG_MODE_ARCHIVE mode
	is set. Check for new enough gpg. Use add_gpg_arg_with_value for
	gpg-only options with a value and add_gpg_arg for gpg-only options
	without a value. Set extra options for gpgtar and pass input data to
	stdin when using gpgtar.
	* src/sign.c (sign_start): Add GPGME_SIG_MODE_ARCHIVE as valid mode.

	* tests/run-sign.c (show_usage): New options --archive and
	--diagnostics.
	(main): Parse new options. Sign with gpgtar if --archive is given.
	Print stderr of gpg/gpgtar if --diagnostics is given.

	core: Fix --set-filename argument.
	+ commit aa201b0bb63d703a3794826fac2e2013fb0c34e7
	* src/engine-gpg.c (gpg_encrypt): Append equal sign to argument name.

2023-01-18  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Support usage of gpgtar for encryption.
	+ commit 5d8316da1d3dd0ab73743898e76c51932d0f13e2
	* src/gpgme.h.in (GPGME_ENCRYPT_ARCHIVE): New encryption flag.
	* src/engine-gpg.c (arg_and_data_s): New field gpg_arg.
	(engine_gpg): New flag use_gpgtar.
	(_add_arg): Add argument gpg_arg and set it.
	(add_arg_ext, add_arg_with_locp, add_arg, add_arg_pfx, add_arg_len):
	Adjust call of _add_arg.
	(add_arg_with_locp): Add argument front.
	(add_gpg_arg, add_gpg_arg_with_value): New.
	(gpg_new): Use add_gpg_arg_with_value for gpg-only options with a value
	and add_gpg_arg for gpg-only options without.
	(build_argv): Consider usage of gpgtar when counting arguments to pass
	to gpg/gpgtar. Prepend "--gpg-args" to all gpg-only arguments if gpgtar
	is used.
	(start): Set program to use. Read diagnostics output from stderr when
	using gpgtar. Do not pass --status-fd to gpgtar for gpg < 2.4.1. Use
	add_gpg_arg_with_value for --lc-ctype and --lc-messages.
	(gpg_encrypt): Set use_gpgtar engine flag if GPGME_ENCRYPT_ARCHIVE flag
	is set. Check for new enough gpg and incompatible flags. Use
	add_gpg_arg_with_value for gpg-only options with a value and
	add_gpg_arg for gpg-only options without a value. Set extra options
	for gpgtar and pass input data to stdin when using gpgtar.
	* src/engine-gpgsm.c (gpgsm_encrypt): Return error if new flag is set.
	* src/engine-uiserver.c (uiserver_encrypt): Ditto.

	* tests/run-encrypt.c (show_usage): New options --archive and
	--diagnostics.
	(main): Parse new options. Encrypt with gpgtar if --archive is given.
	Print stderr of gpg/gpgtar if --diagnostics is given.

	core: Defer adding --status-fd and --logger-fd to argument list.
	+ commit d56b3bc1cfa128d0246cfac59411adaad2579bc4
	* src/engine-gpg.c (_append_to_arglist, _prepend_to_arglist): New.
	(_add_arg): Use _append_to_arglist and _prepend_to_arglist.
	(add_data_ext): New. Extends add_data.
	(add_data): Uses add_data_ext.
	(gpg_new): Do not add --status-fd and --logger-fd to argument list.
	(start): Prepend --logger-fd and --status-fd to the argument list.

	core: Extend gpgme_get_dirinfo to return the gpgtar name.
	+ commit 12e490d97f2e7064bc9b5bea0d197790d10db106
	* src/dirinfo.c (WANT_GPGTAR_NAME): New.
	(dirinfo): Add field gpgtar_name.
	(get_gpgconf_item): Build gpgtar_name on demand and return it.
	(_gpgme_get_default_gpgtar_name) : New.
	(gpgme_get_dirinfo): New value "gpgtar-name" for WHAT.
	* src/util.h (_gpgme_get_default_gpgtar_name): New.

	* tests/t-engine-info.c (main): Add gpgtar-name to the output.

2023-01-17  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Use "goto leave" pattern to clean up resources.
	+ commit fbce7deb3b68af900f692591d5d05fa5c1a83f5f
	* src/engine-gpg.c (build_argv): Initialize fd_data_map and argv. Goto
	leave on error. Free fd_data_map and argv on error.

2023-01-16  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Do not add obsolete --no-sk-comments to command line.
	+ commit 984ff7e3a2a9a261a0732cbdaf3b2f22d325b433
	* src/engine-gpg.c (build_argv): Don't add "--no-sk-comments" to argv.

2023-01-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Fix comparisons of integer expressions of different signedness.
	+ commit 64da77620a451653e9b8c41bb0c9e58e22967123
	* lang/qt/tests/t-import.cpp (ImportTest::testImportWithImportFilter):
	Make integer literal unsigned.

	cpp: Fix comparisons of integer expressions of different signedness.
	+ commit 2e9d72a0be8579d6f1d3c74c64873a9c2f844272
	* lang/cpp/src/gpgrevokekeyeditinteractor.cpp
	(GpgRevokeKeyEditInteractor::Private::nextState): Cast signed nextLine
	value to std::size_t.

	cpp: Expliticly declare compiler generated copy constructors.
	+ commit dc9cc9aa0754d834388acabb5a68677f6512b960
	* lang/cpp/src/configuration.h (Component, Option),
	lang/cpp/src/data.h (Data),
	lang/cpp/src/decryptionresult.h (DecryptionResult,
	DecryptionResult::Recipient),
	lang/cpp/src/encryptionresult.h (EncryptionResult, InvalidRecipient),
	lang/cpp/src/engineinfo.h (EngineInfo),
	lang/cpp/src/importresult.h (ImportResult, Import),
	lang/cpp/src/key.h (Key, Subkey, UserID, UserID::Signature),
	lang/cpp/src/keygenerationresult.h (KeyGenerationResult),
	lang/cpp/src/keylistresult.h (KeyListResult),
	lang/cpp/src/notation.h (Notation),
	lang/cpp/src/signingresult.h (SigningResult, InvalidSigningKey,
	CreatedSignature),
	lang/cpp/src/swdbresult.h (SwdbResult),
	lang/cpp/src/tofuinfo.h (TofuInfo),
	lang/cpp/src/verificationresult.h (VerificationResult, Signature),
	lang/cpp/src/vfsmountresult.h (VfsMountResult): Explitily declare
	compiler generated copy constructor.

	qt: Replace Q_DECL_OVERRIDE with override.
	+ commit e16c368758e54b99d88529d3a10cecf36ed995b8
	* lang/qt/src/defaultkeygenerationjob.h,
	lang/qt/src/hierarchicalkeylistjob.h, lang/qt/src/multideletejob.h,
	lang/qt/src/protocol_p.h, lang/qt/src/qgpgmeadduseridjob.h,
	lang/qt/src/qgpgmechangeexpiryjob.h,
	lang/qt/src/qgpgmechangeownertrustjob.h,
	lang/qt/src/qgpgmechangepasswdjob.h, lang/qt/src/qgpgmedecryptjob.h,
	lang/qt/src/qgpgmedecryptverifyjob.h, lang/qt/src/qgpgmedeletejob.h,
	lang/qt/src/qgpgmedownloadjob.h, lang/qt/src/qgpgmeencryptjob.h,
	lang/qt/src/qgpgmeexportjob.h, lang/qt/src/qgpgmegpgcardjob.h,
	lang/qt/src/qgpgmeimportfromkeyserverjob.h,
	lang/qt/src/qgpgmeimportjob.h, lang/qt/src/qgpgmekeyformailboxjob.h,
	lang/qt/src/qgpgmekeygenerationjob.h, lang/qt/src/qgpgmekeylistjob.h,
	lang/qt/src/qgpgmelistallkeysjob.h, lang/qt/src/qgpgmenewcryptoconfig.h,
	lang/qt/src/qgpgmequickjob.h, lang/qt/src/qgpgmerefreshsmimekeysjob.h,
	lang/qt/src/qgpgmesignencryptjob.h, lang/qt/src/qgpgmesignjob.h,
	lang/qt/src/qgpgmesignkeyjob.h, lang/qt/src/qgpgmetofupolicyjob.h,
	lang/qt/src/qgpgmeverifydetachedjob.h,
	lang/qt/src/qgpgmeverifyopaquejob.h, lang/qt/src/qgpgmewkdlookupjob.h,
	lang/qt/src/qgpgmewkspublishjob.h, lang/qt/src/threadedjobmixin.h,
	lang/qt/tests/t-support.h: Replace Q_DECL_OVERRIDE with override

	qt: Allow deferred start of import job.
	+ commit 398375a0ab3b819694435c2e46b759d56b3735e0
	* lang/qt/src/importjob.h (ImportJob::startLater): New pure virtual
	method.
	* lang/qt/src/qgpgmeimportjob.cpp, lang/qt/src/qgpgmeimportjob.h
	(QGpgMEImportJob::startLater): New method.

	* lang/qt/tests/t-import.cpp (ImportTest::testDeferredStart): New.

2023-01-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Support deferred start of jobs.
	+ commit 18c2c0b2509069951829bb0bdd9b39dc467f5e6e
	* lang/qt/src/job.cpp, lang/qt/src/job.h (Job::startNow): New method.
	* lang/qt/src/job_p.h (JobPrivate::start): New pure virtual method.
	* lang/qt/src/qgpgmechangeexpiryjob.cpp
	(QGpgMEChangeExpiryJobPrivate::start): New.
	* lang/qt/src/qgpgmeencryptjob.cpp (QGpgMEEncryptJobPrivate::start):
	New.
	* lang/qt/src/qgpgmeimportjob.cpp (QGpgMEImportJobPrivate::start): New.
	* lang/qt/src/qgpgmelistallkeysjob.cpp
	(QGpgMEListAllKeysJobPrivate::start): New.
	* lang/qt/src/qgpgmesignencryptjob.cpp
	(QGpgMESignEncryptJobPrivate::start): New.
	* lang/qt/src/threadedjobmixin.h (Thread::hasFunction): New method.
	(ThreadedJobMixin::run, ThreadedJobMixin::setWorkerFunction): New
	methods.

	qt: Explicitly instantiate private job classes.
	+ commit 270d7523001a57a59ea0be617d8e71d4363e0d50
	* lang/qt/src/Makefile.am: Add new files.
	* lang/qt/src/changeexpiryjob_p.h, lang/qt/src/encryptjob_p.h,
	lang/qt/src/importjob_p.h, lang/qt/src/listallkeysjob_p.h,
	lang/qt/src/signencryptjob_p.h: New.
	* lang/qt/src/changeexpiryjob.cpp, lang/qt/src/encryptjob.cpp,
	lang/qt/src/importjob.cpp, lang/qt/src/listallkeysjob.cpp,
	lang/qt/src/signencryptjob.cpp: Move JobPrivate subclasses to the new
	private header files.
	* lang/qt/src/job_p.h (jobPrivate): Remove lazy instantiation of private
	job classes.
	* lang/qt/src/qgpgmechangeexpiryjob.cpp (class
	QGpgMEChangeExpiryJobPrivate): New.
	(QGpgMEChangeExpiryJob::QGpgMEChangeExpiryJob): Instantiate private job
	class.
	* lang/qt/src/qgpgmeencryptjob.cpp (class
	QGpgMEEncryptJobPrivate): New.
	(QGpgMEEncryptJob::QGpgMEEncryptJob): Instantiate private job
	class.
	* lang/qt/src/qgpgmeimportjob.cpp (class
	QGpgMEImportJobPrivate): New.
	(QGpgMEImportJob::QGpgMEImportJob): Instantiate private job
	class.
	* lang/qt/src/qgpgmelistallkeysjob.cpp (class
	QGpgMEListAllKeysJobPrivate): New.
	(QGpgMEListAllKeysJob::QGpgMEListAllKeysJob): Instantiate private job
	class.
	* lang/qt/src/qgpgmesignencryptjob.cpp (class
	QGpgMESignEncryptJobPrivate): New.
	(QGpgMESignEncryptJob::QGpgMESignEncryptJob): Instantiate private job
	class.

2022-12-08  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Handle status errors in the base edit interactor.
	+ commit e7953dcf1376631719c73d9fa34bcb96752d3794
	* lang/cpp/src/editinteractor.cpp (edit_interactor_callback_impl):
	Handle status errors.
	* lang/cpp/src/gpgrevokekeyeditinteractor.cpp
	(GpgRevokeKeyEditInteractor::Private::nextState): Remove handling of
	status errors.

	cpp: Handle statuses that need no response in the base edit interactor.
	+ commit c419376b85ff4a489f3bf7ad97ed656495792523
	* lang/cpp/src/editinteractor.cpp (edit_interactor_callback_impl): Do
	not call nextState() if status needs no response.
	* lang/cpp/src/gpgaddexistingsubkeyeditinteractor.cpp
	(GpgAddExistingSubkeyEditInteractor::Private::nextState),
	lang/cpp/src/gpgadduserideditinteractor.cpp
	(GpgAddUserIDEditInteractor::nextState),
	lang/cpp/src/gpggencardkeyinteractor.cpp
	(GpgGenCardKeyInteractor::nextState),
	lang/cpp/src/gpgrevokekeyeditinteractor.cpp
	(GpgRevokeKeyEditInteractor::Private::nextState),
	lang/cpp/src/gpgsetexpirytimeeditinteractor.cpp
	(GpgSetExpiryTimeEditInteractor::nextState),
	lang/cpp/src/gpgsetownertrusteditinteractor.cpp
	(GpgSetOwnerTrustEditInteractor::nextState),
	lang/cpp/src/gpgsignkeyeditinteractor.cpp
	(GpgSignKeyEditInteractor::nextState): Remove handling of statuses that
	need no response.

2022-12-06  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Write path values with Unix directory separators.
	+ commit d04d7b174fb7f27b7434cade22eafdd85b2d424e
	* lang/qt/src/qgpgmenewcryptoconfig.cpp
	(QGpgMENewCryptoConfigEntry::setURLValue): Remove conversion to native
	directory separators.

2022-11-25  NIIBE Yutaka  <gniibe@fsij.org>

	gpgme.m4: Fix AM_PATH_GPGME_PTHREAD.
	+ commit f9cbf2c8a839d2c3df20157cfe65b67a4b0bcb5a
	* src/gpgme.m4 (AM_PATH_GPGME_PTHREAD): It's deprecated, since gpgme
	supports threads and GNU C library has integrated pthread features.

2022-11-15  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Allow nullptr for key on card-edit.
	+ commit 5903fa454a47d788432192a7860b90b57efd6a10
	* src/edit.c (interact_start, edit_start): Return error if key is null
	on edit-key.

2022-11-15  NIIBE Yutaka  <gniibe@fsij.org>

	gpgme.m4: Include _AM_PATH_GPGRT_CONFIG implementation.
	+ commit abd51848bdc8a5ea5929f9cfb819a408dc53d463
	* src/gpgme.m4 (_AM_PATH_GPGRT_CONFIG): New.
	(_AM_PATH_GPGME_CONFIG): Require _AM_PATH_GPGRT_CONFIG.

	m4: Update gpg-error.m4.
	+ commit 2b7fcbf2f280ca88d76f8398138580155213552a
	* m4/gpg-error.m4: Update from libgpg-error master.

2022-11-11  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Check for nullptr.
	+ commit 6bcfbb3498f02dc86370cd4f2e3ccc5f9163d51a
	* src/edit.c (interact_start, edit_start): Return error if key is null.

2022-11-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Allow disabling automatic trust database check on key listing.
	+ commit b6593bda1f7bfaf6cf3b869b8379cbb2b619e00a
	* lang/qt/src/Makefile.am (qgpgme_sources): Add listallkeysjob.cpp.
	* lang/qt/src/listallkeysjob.cpp: New.
	* lang/qt/src/listallkeysjob.h (enum ListAllKeysJob::Option,
	typedef ListAllKeysJob::Options, ListAllKeysJob::setOptions,
	ListAllKeysJob::options): New.
	* lang/qt/src/qgpgmelistallkeysjob.cpp (list_keys): Set context flag
	"no-auto-check-trustdb" if requested.
	(QGpgMEListAllKeysJob::start, QGpgMEListAllKeysJob::exec): Add options
	to call of list_keys.

	core: New context flag "no-auto-check-trustdb"
	+ commit 4f874ea431ba68ba70cf569741488502b1f61e66
	* src/context.h (gpgme_context): Add field no_auto_check_trustdb.
	* src/gpgme.c (gpgme_set_ctx_flag, gpgme_get_ctx_flag): Add flag
	"no-auto-check-trustdb".
	* src/engine-gpg.c (engine_gpg): Add flags.no_auto_check_trustdb.
	(gpg_set_engine_flags): Set the flag.
	(build_argv): Pass option to gpg.

	* tests/run-keylist.c (show_usage, main): Add option --no-trust-check.

2022-11-02  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update libassuan.m4.
	+ commit 9f5e11729260b814c4903e2fbccfb3855073abd2
	* m4/libassuan.m4: Update from libassuan master.

	build: Prefer gpgrt-config when available.
	+ commit 9f55dceca0cf2926d14cb4a70bd0cdc454d89f03
	* src/gpgme.m4: Overriding the decision by --with-gpgme-prefix,
	use gpgrt-config gpgme when gpgrt-config is available.

2022-10-26  Werner Koch  <wk@gnupg.org>

	core: New global flags "inst-type".
	+ commit 1c9694f8d50b1236d2e4f2acbe23f972da36e437
	* src/gpgme.c (gpgme_set_global_flag): Add flag "inst-type".
	* src/w32-util.c (_gpgme_set_get_inst_type): New.
	(INST_TYPE_GPG4WIN_DIR): New.
	(INST_TYPE_GPGDESK_DIR): New.
	(_gpgme_get_gpgconf_path): Implement this flag.  Replace fixed strings
	by the macros.
	* src/posix-util.c (_gpgme_set_get_inst_type): New dummy.

2022-10-26  NIIBE Yutaka  <gniibe@fsij.org>

	python: Fix configure generating setup.py.
	+ commit f1802682c3c8794edaca37966405bd1f070f5e01
	* lang/python/setup.py.in: Handle the case, when substitutions
	may be empty.

2022-10-24  Werner Koch  <wk@gnupg.org>

	core: Protect against a theoretical integer overflow in parsetlv.c.
	+ commit 830e017e5d5f51d956d1188860302655f3e727e9
	* src/parsetlv.c (_gpgme_parse_tlv): Detect integer overflow.

2022-10-24  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Allow setting the curve to use when generating ECC keys.
	+ commit d9ac1385950217893be6f0d6fdb3324b8647d16b
	lang/cpp/src/gpggencardkeyinteractor.h (class GpgGenCardKeyInteractor):
	Add enum Curve. Add member function setCurve.
	lang/cpp/src/gpggencardkeyinteractor.cpp
	(class GpgGenCardKeyInteractor::Private): Initialize simple members
	in-class. Add member curve.
	(GpgGenCardKeyInteractor::~GpgGenCardKeyInteractor): Use default d'tor.
	(GpgGenCardKeyInteractor::setCurve): New.
	(GpgGenCardKeyInteractor::action): Return curve defaulting to
	Curve25519.

2022-10-24  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update gpg-error.m4.
	+ commit d36905bb80c43987f2ca6980d3973d2111f89991
	* m4/gpg-error.m4: Update from libgpg-error 1.46.

2022-10-14  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,qt: Check whether building with -fPIC is needed.
	+ commit 2ff09f474fb908dff83cce79c9d84b4fa21f5d7b
	m4/qt6.m4: Use build test to check whether -fPIC is needed for building
	a Qt application.

	build,qt: Fail check for Qt if moc wasn't found.
	+ commit 1792db58346cb39fd99332478d56dc190bae7836
	* m4/qt5.m4, m4/qt6.m4: Perform build test only if moc was found.

	build,qt: Always compile the Qt 6 test application with -fpic.
	+ commit f7a46714283bb8c107c68d0f1227abfe223b2365
	* m4/qt6.m4: Do not add -fpic to GPGME_QT6_CFLAGS. Add -fpic to CPPFLAGS
	used for build test of simple Qt 6 application.

2022-10-11  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,qt: Clean up all generated files.
	+ commit e6a1b241b4e6a0a677ed8f0e4e287a5cc82d7fbb
	* lang/qt/src/Makefile.am (CLEANFILES): Add QGpgmeConfig-w32.cmake.in
	and QGpgmeQt6Config-w32.cmake.in.

	qt,tests: Port test to QRegularExpression.
	+ commit b2fb26baeada7b39331f71a30c654bfb8b53cb30
	* lang/qt/tests/t-trustsignatures.cpp: Use QRegularExpression instead of
	QRegExp.

	qt: Remove obsolete code.
	+ commit 4938c24a466bf05e707d3e6cbf759705adc7e8d6
	* lang/qt/src/qgpgmenewcryptoconfig.cpp (struct Select1St): Remove.

	build,qt: Allow building QGpgME for Qt 6.
	+ commit 8d019bbb8d40de2cbed7ad6d3367c6a46a561fab
	* configure.ac: Look for Qt 5 and/or Qt 6. Require C++17 if Qt 6 binding
	is built. Build cmake files QGpgmeConfig* for Qt 5 and QGpgmeQt6Config*
	for Qt 6.
	(available_languages): Add "qt5" and "qt6".
	(WANT_QT5, WANT_QT6): New conditionals.
	* lang/qt/src/Makefile.am: Keep building libqgpgme for Qt 5. Build
	libqgpgmeqt6 for Qt 6.
	* lang/qt/tests/Makefile.am: Build tests for Qt 5 or Qt 6.
	* lang/qt/src/QGpgmeQt6Config-w32.cmake.in.in,
	lang/qt/src/QGpgmeQt6Config.cmake.in.in,
	lang/qt/src/QGpgmeQt6ConfigVersion.cmake.in, m4/qt6.m4: New.

2022-10-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	build,qt: Explicitly namespace a few Qt variables for Qt5.
	+ commit 8e908029ffa03d21662030d3111dcf556b722e1a
	m4/qt.m4: Rename to
	m4/qt5.m4: this.
	(FIND_QT): Rename to FIND_QT5.
	(GPGME_QT): Change variable prefix to GPGME_QT5.
	(GPGME_QTTEST: Change variable prefix to GPGME_QT5TEST.
	configure.ac, lang/qt/src/Makefile.am, lang/qt/tests/Makefile.am:
	Adjust accordingly.

2022-09-29  Werner Koch  <wk@gnupg.org>

	core: Fix SIG_CREATED status parsing for 0x1F sigs.
	+ commit b1e5f3b183104a58d71821b7dbe44244d1c3f87f
	* src/sign.c (parse_sig_created): Special case the rfc4880 "1F" status.

2022-09-15  NIIBE Yutaka  <gniibe@fsij.org>

	build:python: Don't use gpg-error-config/gpgme-config.
	+ commit ae9258fbf3b9d434495ef11fc184a91fe7c4ca57
	* lang/python/setup.py.in: Use @prefix@, @GPGME_CONFIG_LIBS@,
	@GPGME_CONFIG_CFLAGS@, and @GPG_ERROR_CFLAGS@ of configure.

	Fix for modern compiler.
	+ commit fbd94076461ec55603d741121fa2ff6a861ea803
	* src/argparse.c (show_version): It's no args.

2022-09-14  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Reject signing expired keys.
	+ commit eedaaf70167f5dd7d8438235139b57527d3a961b
	* lang/cpp/src/gpgsignkeyeditinteractor.cpp (enum SignKeyState): Add
	new state REJECT_SIGN_EXPIRED.
	(makeTable): Add entries for new state to transition map.
	(GpgSignKeyEditInteractor::action): Handle new state.

2022-09-07  NIIBE Yutaka  <gniibe@fsij.org>

	Fix parsing import status for invalid fingerprint.
	+ commit 80670f60ba971145dd6792e00d31c08c10cc8159
	* src/import.c (parse_import): Handle invalid fingerprint case.

2022-08-22  Ingo Klöcker  <dev@ingo-kloecker.de>

	build: Omit -I... and -L... for standard paths in pkgconfig file.
	+ commit 1522813888257aafb6d108b49fb7b24005d2693a
	* configure.ac (GPGME_CONFIG_CFLAGS): Prefix with -I${includedir} for
	non-standard include paths.
	(GPGME_CONFIG_LIBS): Prefix with -L${libdir} for non-standard library
	paths.
	* src/gpgme.pc.in (Cflags): Remove hard-coded -I${includedir}.
	(Libs): Remove hard-coded -L${libdir}.

	build: Update ax_cxx_compile_stdcxx macro.
	+ commit 73e96bfaa8176cf7b18bfa9edacaaf8d26989998
	* m4/ax_cxx_compile_stdcxx.m4: Replace with current version from the
	autoconf archive.

	qt: Fix building with C++11.
	+ commit 83176ad7d3e57ad7804d3c885e1b4fcd1d4d96f9
	* lang/qt/src/qgpgmerefreshsmimekeysjob.cpp
	(QGpgMERefreshSMIMEKeysJob::start): Replace 'auto' in lambda with the
	actual type.
	* lang/qt/src/qgpgmesignkeyjob.cpp (class TrustSignatureProperties): Add
	default c'tor and c'tor initializing all members.
	* lang/qt/src/util.cpp (toFingerprints): Replace 'auto' in lambda with
	the actual type.
	* lang/qt/tests/run-exportjob.cpp (createExportJob): Replace 'auto'
	return type with actual type.

	qt: Fix building with Qt6.
	+ commit 05661806848b8a6ef9005e4a420d8613ddc868f1
	* lang/qt/src/util.cpp, lang/qt/src/util.h: Replace forward declaration
	with include.

2022-08-19  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Fix building with C++11.
	+ commit f02c20cc9c5756690b07abfd02a43533547ba2ef
	* lang/cpp/src/importresult.cpp (ImportResult::mergeWith): Replace
	'auto' in lambdas with the actual type.

2022-08-18  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt,tests: Make test pass on 32-bit systems.
	+ commit 2e7a61b898fccc1c20000b79dee83cd980901fa9
	* lang/qt/tests/t-addexistingsubkey.cpp
	(AddExistingSubkeyJobTest::testAddExistingSubkeyWithExpiration): Handle
	negative expiration date.

	cpp: Fix handling of "no key" or "invalid time" situations.
	+ commit 2fa5c80aeba4528b3bdf41ec5740e7db5d4b6d2b
	* lang/cpp/src/gpgaddexistingsubkeyeditinteractor.cpp
	(GpgAddExistingSubkeyEditInteractor::Private::nextState): Fix inverted
	logic of string comparisons.

2022-08-17  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt,tests: Make sure expiration time is interpreted as unsigned number.
	+ commit f2b48de26b8f8c48c293423eda712831544924f6
	* lang/qt/tests/t-addexistingsubkey.cpp,
	lang/qt/tests/t-changeexpiryjob.cpp: Convert expiration time to
	uint_least32_t.

	qt,tests: Log the actual error code if the assertion fails.
	+ commit 81d4b7f2d7077297d76af5728949d8f2bdff8cd5
	* lang/qt/tests/t-addexistingsubkey.cpp (
	AddExistingSubkeyJobTest::testAddExistingSubkeyAsync,
	AddExistingSubkeyJobTest::testAddExistingSubkeySync,
	AddExistingSubkeyJobTest::testAddExistingSubkeyWithExpiration): Use
	QCOMPARE instead of QVERIFY for asserting equality.

	qt: Make sure expiration time is interpreted as unsigned number.
	+ commit c977424a1d39751fc5055131ad3f7819d421dcc8
	* lang/qt/src/qgpgmeaddexistingsubkeyjob.cpp (add_subkey): Convert
	expiration time to uint_least32_t.

2022-08-12  Andre Heinecke  <aheinecke@gnupg.org>

	w32: Add another fallback to look for gpgconf.exe.
	+ commit 5f51a9b4589200486b2833124cbd93455f6ce208
	* src/w32-util.c (_gpgme_get_gpgconf_path): Add fallback for
	GnuPG VS-Desktop install scheme.

2022-08-11  Andre Heinecke  <aheinecke@gnupg.org>

	Qt: Fix working with no gpgconf in CryptoConfig.
	+ commit 586846209b08ce5e9545f53f21de884eb4079115
	* lang/qt/src/cryptoconfig.cpp (CryptoConfig::entry): Add nullptr
	  checks.

2022-08-10  Werner Koch  <wk@gnupg.org>

	Release 1.18.0.
	+ commit 26ff163bd6912fa7e8cb522d0799e17095ac1efb


	tests: Make t-edit-sign more robust.
	+ commit 9ee74b68e688b474881768a5ae59d857397c8fbf
	* tests/gpg/t-edit-sign.c (interact_fnc): Provide the default answer.

2022-08-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add missing include.
	+ commit 5d91182c955d128c8ff7cdd29189fc3ae06201d9
	* lang/qt/tests/t-revokekey.cpp: Include QDebug.

2022-08-09  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add job to set the primary user ID of OpenPGP keys.
	+ commit db7d79063f57c6e0ccf382fdf1cf47d514e12f6e
	* lang/qt/src/qgpgmesetprimaryuseridjob.cpp,
	lang/qt/src/qgpgmesetprimaryuseridjob.h,
	lang/qt/src/setprimaryuseridjob.h: New.
	* lang/qt/src/protocol.h (class Protocol): Add pure virtual member
	function setPrimaryUserIDJob.
	* lang/qt/src/protocol_p.h (Protocol::setPrimaryUserIDJob): New.
	* lang/qt/src/job.cpp, lang/qt/src/Makefile.am: Update accordingly.

	* lang/qt/tests/t-setprimaryuserid.cpp: New.
	* lang/qt/tests/Makefile.am: Add new test.

	cpp: Add support for gpgme_op_set_uid_flag.
	+ commit 125867f268f2a49ff060a7adc859500500b77025
	* lang/cpp/src/context.cpp, lang/cpp/src/context.h
	(Context::setPrimaryUid, Context::startSetPrimaryUid): New.

2022-08-09  NIIBE Yutaka  <gniibe@fsij.org>

	python: Don't call __del__ from __exit__ method.
	+ commit f8d99bb9e4a7f6229c19c4fbd951ccad6fa97bde
	* lang/python/src/core.py (Context, Data): Don't call __del__
	from __exit__ method, as the object may be still in use.
	* lang/python/tests/t-idiomatic.py: Fix the test.

2022-08-05  NIIBE Yutaka  <gniibe@fsij.org>

	python: Don't access gpgme with wrapped=None.
	+ commit 180899c7c313335128606bfff738da00dce4f5c9
	* lang/python/src/core.py (GpgmeWrapper, Context): Check self.wrapped
	is valid.

2022-08-05  Jasper Spaans  <jasper@startmail.com>

	python: Reset passphrase callback correctly.
	+ commit b2f224a471fecce566443bf0f0e554de6f567f4e
	* lang/python/src/core.py (Context(GpgmeWrapper)): Reset passphrase
	callback correctly, for encrypt, decrypt, create_key, and
	create_subkey methods.

2022-08-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Remove job for refreshing OpenPGP keys.
	+ commit c3b183831db5a2a490ba49bf4804730679eb59d0
	* lang/qt/src/qgpgmerefreshopenpgpkeysjob.cpp,
	lang/qt/src/qgpgmerefreshopenpgpkeysjob.h,
	lang/qt/src/refreshopenpgpkeysjob.h: Remove.
	* lang/qt/src/Makefile.am, lang/qt/src/job.cpp: Update accordingly.
	* lang/qt/src/protocol.h (class Protocol): Remove pure virtual member
	function refreshOpenPGPKeysJob.
	* lang/qt/src/protocol_p.h (Protocol::refreshOpenPGPKeysJob): Remove.

	* lang/qt/tests/run-refreshkeysjob.cpp (main): Use ReceiveKeysJob for
	OpenPGP keys.

2022-07-21  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update config.guess and config.sub.
	+ commit cc37447b625b45efb5c94c40461084460f03f24a
	* build-aux/config.guess: Update from upstream.
	* build-aux/config.sub: Ditto.

	build: Fix for modern Autoconf.
	+ commit 16020c5fd96427961734c4a8f5b2b5e901b1bb60
	* m4/glib-2.0.m4: Use AC_RUN_IFELSE and AC_LINK_IFELSE.

2022-07-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Allow setting the file name of signed and encrypted data.
	+ commit 5436b309fe67dd3c4531f751d99c98128ca66e4d
	* lang/qt/src/Makefile.am (qgpgme_sources): Add signencryptjob.cpp.
	* lang/qt/src/signencryptjob.cpp: New.
	* lang/qt/src/signencryptjob.h (class SignEncryptJob): Add member
	functions setFileName, fileName.
	* lang/qt/src/qgpgmesignencryptjob.cpp (sign_encrypt): Set file name of
	input.
	(sign_encrypt_qba, QGpgMESignEncryptJob::exec,
	QGpgMESignEncryptJob::start): Pass file name to sign_encrypt resp.
	sign_encrypt_qba.

	qt: Allow setting the file name of encrypted data.
	+ commit bc10169724d2806b38f91beff39ef637b5e52b8d
	* lang/qt/src/Makefile.am (qgpgme_sources): Add encryptjob.cpp.
	* lang/qt/src/encryptjob.cpp: New.
	* lang/qt/src/encryptjob.h (class EncryptJob): Add member functions
	setFileName, fileName.
	* lang/qt/src/qgpgmeencryptjob.cpp (encrypt): Set file name of input.
	(encrypt_qba, QGpgMEEncryptJob::exec, QGpgMEEncryptJob::start): Pass
	file name to encrypt resp. encrypt_qba.

2022-07-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Fix filename of cmake config files for w32.
	+ commit 31423945d214292f24dd1f700cd8ab53722dd1eb
	* lang/qt/src/Makefile.am (EXTRA_DIST): Add
	QGpgmeConfig-w32.cmake.in.in.

2022-07-04  Laurent Montel  <montel@kde.org>

	qt: Add #include <QStringList> needed for building against qt6.
	+ commit d42323f90213157a5e847bfa89bee55a29ee8df0
	* lang/qt/src/downloadjob.h, lang/qt/src/exportjob.h,
	lang/qt/src/keylistjob.h lang/qt/src/refreshkeysjob.h: in qt6 we need
	to use #include <QStringList>

2022-06-30  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Remove obsolete compatibility with KF5 variants.
	+ commit 6e45da30ae787dd45836e55d34f7aa4e001b641c
	* lang/cpp/src/GpgmeppConfig-w32.cmake.in.in,
	lang/cpp/src/GpgmeppConfig.cmake.in.in: Remove find_package() call.

2022-06-28  NIIBE Yutaka  <gniibe@fsij.org>

	build: When no gpg-error-config, not install gpgme-config.
	+ commit 02a2f350359013bf33c3957e95c98726273ced8c
	* configure.ac (USE_GPGRT_CONFIG): New.
	* src/Makefile.am [USE_GPGRT_CONFIG]: Conditionalize the install
	of gpgme-config.

	build: Update gpg-error.m4.
	+ commit aa94b4cee5aabfa9097abd4560fdf002516db82a
	* m4/gpg-error.m4: Update from libgpg-error.

2022-06-14  Ingo Klöcker  <dev@ingo-kloecker.de>

	tests: Add support for clear text signatures to test runner.
	+ commit d59cf1725755f24e79a0ce12ddc59fedc97292c6
	* tests/run-sign.c (show_usage): Add new argument "--clear".
	(main): Handle new argument "--clear".

2022-06-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt,tests: Allow 1-day-offset for expiration date.
	+ commit fd813f5c3938423137db1fcb02c3c527bd9f58c6
	* lang/qt/tests/t-various.cpp (TestVarious::testSignKeyWithExpiration):
	Assert that the expiration date is either 2106-02-05 or 2106-02-04.

	qt: Prevent u32 overflow when calculating expiration date.
	+ commit 7870fdbfeff47755138136dbd6648b18f6b4fc76
	* lang/qt/src/qgpgmesignkeyjob.cpp (sign_key): Change maxAllowedDate to
	2106-02-05. Change log-level from warning to debug.
	* lang/qt/tests/t-various.cpp (TestVarious::testSignKeyWithExpiration):
	Remove check for warning. Adapt assertion.

2022-06-09  Ingo Klöcker  <dev@ingo-kloecker.de>

	Revert "tests: Avoid problems with local time across a day boundary."
	+ commit 918afc809d40e057266ced6dfc98a5b3e5b4d3ee
	This reverts commit 5ba0e454a37c9b0d3badddfc2dad8bcc7c7af874.

	core: Handle import status lines during keylist operation.
	+ commit 5d19eb4ad5ad9e93c34bf9b03ed6f583c6bf8491
	* src/keylist.c (gpgme_op_keylist_from_data_start): Call
	_gpgme_op_import_init_result.

2022-05-12  Andre Heinecke  <aheinecke@gnupg.org>

	cpp: Export KeyListModeSaver.
	+ commit f3011b5a1918dbe9d2b1316707a2c1034c847507
	* lang/cpp/src/context.h (Context::KeyListModeSaver): Add Export.

2022-05-06  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Set SECRET flag of subkeys stored on smart cards.
	+ commit f72cf726ca749a138a8950b02c51e7b3a50c6a83
	* src/keylist.c (parse_sec_field15): Set SECRET flag.

2022-05-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Output more properties of a subkey.
	+ commit 306fd9c915cbccddbd146f37ba9bd826f10d2535
	* lang/cpp/src/key.cpp (ostream operator<< for Subkey): Fix wrong output
	of isInvalid and isDisabled flags. Add output of key grip, card serial
	number and the flags isSecret, isQualified, isDeVs, and isCardKey.

	cpp,tests: Actually parse the --with-secret option.
	+ commit e029fd27350fcbda1b4689bc557e996d749d78ac
	* lang/cpp/tests/run-keylist.cpp (main): Handle --with-secret option.
	Print error for unknown option.

	qt: Revert change of result signal of RefreshKeysJob.
	+ commit 9e8c8e448ec83c454fb310f80ce0bf9f828a7145
	* lang/qt/src/refreshkeysjob.h (RefreshKeysJob::result): Remove optional
	parameters auditLogAsHtml and auditLogError.
	* lang/qt/tests/run-refreshkeysjob.cpp (main): Update accordingly.

	qt: Use lambda instead of std::bind.
	+ commit 15a4940aa73019bce002302b14aaa73312da3df4
	* lang/qt/src/qgpgmerefreshopenpgpkeysjob.cpp
	(QGpgMERefreshOpenPGPKeysJob::start): Replace std::bind call with a
	lambda.

2022-05-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Emit import result when refreshing OpenPGP keys.
	+ commit c64a8daf507a2216611861a12f312466b0bae8b2
	* lang/qt/src/refreshopenpgpkeysjob.h: New.
	* lang/qt/src/Makefile.am, lang/qt/src/job.cpp: Update accordingly.
	* lang/qt/src/qgpgmerefreshopenpgpkeysjob.h (class
	QGpgMERefreshOpenPGPKeysJob): Derive from RefreshOpenPGPKeysJob with
	result ImportResult. Remove unused start overload.
	* lang/qt/src/qgpgmerefreshopenpgpkeysjob.cpp (locate_external_keys):
	Ignore result of KeyListJob. Return import result.
	(receive_keys): Return import result.
	(refresh_keys): Merge the two import results and return the result.
	* lang/qt/src/protocol.h (class Protocol): Add pure virtual member
	function refreshOpenPGPKeysJob.
	* lang/qt/src/protocol_p.h (Protocol::refreshKeysJob): Return nullptr
	for OpenPGP protocol.
	(Protocol::refreshOpenPGPKeysJob): New.

	* lang/qt/tests/run-refreshkeysjob.cpp (main): Use appropriate job
	for the protocol of the key to refresh.

	cpp: Allow retrieving import result of key listing with locate mode.
	+ commit 3519d6117332f25b601c9c0636878baf4e8cf55b
	* lang/cpp/src/context_p.h (enum Context::Private::Operation): Add
	value KeyListWithImport.
	* lang/cpp/src/context.cpp (Context::startKeyListing, Context::nextKey):
	Set lastop to KeyListWithImport if keylist mode includes Locate.

	core: Handle import status lines during keylist operation.
	+ commit f3ca57dfd7af19f9b2fd01616a81dc889707a4d3
	* src/import.c (import_status_handler): Rename to ...
	(_gpgme_import_status_handler): this. Make non-static.
	(_gpgme_op_import_init_result): New.
	(_gpgme_op_import_start, _gpgme_op_import_keys_start,
	_gpgme_op_receive_keys_start): Call _gpgme_op_import_init_result.
	* src/keylist.c (keylist_status_handler): Call
	_gpgme_import_status_handler to handle import status lines.
	(gpgme_op_keylist_start, gpgme_op_keylist_ext_start): Call
	_gpgme_op_import_init_result.
	* src/ops.h (_gpgme_op_import_init_result,
	_gpgme_import_status_handler): New prototypes.

	cpp: Allow merging the results of two imports.
	+ commit d911a1536488a5645f257a48b4d9cf221c0ed6b6
	* lang/cpp/src/importresult.h, lang/cpp/src/importresult.cpp (class
	ImportResult): Add member function mergeWith.

2022-05-02  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Apply compiler hint.
	+ commit f1a354fd57d6cc9e34ff33ea60aa4ef0aca382a3
	* lang/qt/tests/t-verify.cpp (VerifyTest::testSignatureKey): Use
	reference type to prevent copying.

	qt: Use GpgME::Locate alias.
	+ commit 540e7bf3d457a78497b6b7ac33b486b3c5b50857
	* lang/qt/src/protocol_p.h (Protocol::locateKeysJob): Use Locate alias
	instead of Extern|Local.
	* lang/qt/src/qgpgmekeyformailboxjob.cpp (do_work): Ditto.

	qt: Add job for refreshing OpenPGP keys.
	+ commit e12861f18c6b431b40bfa78eb6f1d149690a5fcd
	* lang/qt/src/qgpgmerefreshopenpgpkeysjob.h,
	lang/qt/src/qgpgmerefreshopenpgpkeysjob.cpp: New.
	* lang/qt/src/Makefile.am: Add new files.
	* lang/qt/src/protocol_p.h (Protocol::refreshKeysJob): Add support for
	OpenPGP protocol.

	cpp: Add RAII class for saving/restoring the key list mode.
	+ commit 34786132fed0a776d4cd314c44ed62e29ff75328
	* lang/cpp/src/context.h, lang/cpp/src/context.cpp (class Context):
	Add nested class KeyListModeSaver.

	qt: Add debug helper for Result classes with output stream operator.
	+ commit 99fd565889f3d22459ff82296b206fa228a4c468
	* lang/qt/src/util.h (toLogString): New.

	qt: Factor out helper for getting the fingerprints of some keys.
	+ commit 0c304beeaab54dc25a8572270704fd5fa90cf836
	* lang/qt/src/util.h, lang/qt/src/util.cpp (toFingerprints): New.
	* lang/qt/src/qgpgmerefreshsmimekeysjob.cpp: Use the helper.

2022-04-29  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Fix connection to readyReadStandardOutput signal.
	+ commit 54c4fd16d1832fcce05aa9e471a4acebff0e3269
	* lang/qt/src/qgpgmerefreshsmimekeysjob.h,
	lang/qt/src/qgpgmerefreshsmimekeysjob.cpp
	(QGpgMERefreshSMIMEKeysJob::slotStderr): Remove.
	* lang/qt/src/qgpgmerefreshsmimekeysjob.cpp
	(QGpgMERefreshSMIMEKeysJob::startAProcess): Handle
	readyReadStandardOutput and readyReadStandardError signals with lambdas.

	qt: Add test runner for refresh job.
	+ commit 9686258bd16707a5e1eb292262a6c28faa581c34
	* lang/qt/tests/run-refreshkeysjob.cpp: New.
	* lang/qt/tests/Makefile.am (run_refreshkeysjob_SOURCES): New.
	(noinst_PROGRAMS): Add new build artifact.

	qt: Make RefreshKeysJob result compatible with standard job result.
	+ commit f4c35609257156d0e32b8dd7315011b484919f05
	* lang/qt/src/refreshkeysjob.h (RefreshKeysJob::result): Add optional
	parameters auditLogAsHtml and auditLogError.

	qt: Allow refreshing a list of keys.
	+ commit fd97cbaa44b8e7914089319afac1e776c9a64283
	* lang/qt/src/refreshkeysjob.h (class RefreshKeysJob): Add pure virtual
	member function start taking a list of keys.
	* lang/qt/src/qgpgmerefreshsmimekeysjob.h,
	lang/qt/src/qgpgmerefreshsmimekeysjob.cpp (class
	QGpgMERefreshSMIMEKeysJob): Implement new member function.

	qt: Minor refactoring.
	+ commit 62e770971786f272ecc079b78b11e798ec699d77
	* lang/qt/src/qgpgmerefreshsmimekeysjob.cpp: Use namespace QGpgME.

	qt: Rename QGpgMERefreshKeysJob to QGpgMERefreshSMIMEKeysJob.
	+ commit f47bc992ae6ca6a9043d4de5bfc10179e4676256
	* lang/qt/src/qgpgmerefreshkeysjob.h,
	lang/qt/src/qgpgmerefreshkeysjob.cpp: Change name to
	* lang/qt/src/qgpgmerefreshsmimekeysjob.h,
	lang/qt/src/qgpgmerefreshsmimekeysjob.cpp: ... this, and adapt the
	include guard.
	(class QGpgMERefreshKeysJob): Rename to QGpgMERefreshSMIMEKeysJob.
	* lang/qt/src/Makefile.am: Adapt mentioned file names accordingly.
	* lang/qt/src/protocol_p.h (Protocol::refreshKeysJob): Use renamed
	class.

2022-04-28  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp,tests: Verify that requested keylist mode is used.
	+ commit 359906c8bcde7e351540708777e3678fee0cc2c1
	* lang/cpp/tests/run-getkey.cpp, lang/cpp/tests/run-keylist.cpp (main):
	Check used keylist mode.

2022-04-27  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Support new keylist modes.
	+ commit dea872f21ff77cd58bafe0966d89d6331c8d2e07
	* lang/cpp/src/global.h (ForceExtern, LocateExternal, KeyListModeMask):
	New.
	* lang/cpp/src/context.cpp (operator<<): Add check.
	* lang/cpp/src/util.h (gpgme_keylist_mode_t,
	convert_from_gpgme_keylist_mode_t): Handle ForceExtern.
	* lang/cpp/tests/run-getkey.cpp (show_usage, main): Add arguments
	--force-extern and --locate-external.
	* lang/cpp/tests/run-keylist.cpp (show_usage, main): Ditto.

	core: Support --locate-external-keys command of gpg.
	+ commit aff9aaac68450e76f84d0f9a3feabffe9e82dd7e
	* src/gpgme.h.in (GPGME_KEYLIST_MODE_FORCE_EXTERN): New.
	(GPGME_KEYLIST_MODE_LOCATE_EXTERNAL): New.
	* src/gpgme.c (gpgme_set_keylist_mode): Check for invalid mode.
	* src/engine-gpg.c (gpg_keylist_build_options): Use
	"--locate-external-keys" instead of "--locate-keys" if flag is set.
	* src/gpgme-json.c (op_keylist): New flag "force-extern".
	* src/gpgme-tool.c (gt_get_keylist_mode, cmd_keylist_mode): Handle
	new mode.

2022-04-25  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Rely on the bad passphrase error reported by gpg.
	+ commit 512f11b458d82bb8a42b5764f11e11978173f896
	* lang/qt/src/qgpgmedecryptverifyjob.cpp (patch_decryption_result):
	Removed.
	(decrypt_verify): Remove usage of patch_decryption_result.

	core: Return BAD_PASSPHRASE error code on symmetric decryption.
	+ commit e21c3b559dfb59c61f789572071e72e31bb089bf
	* src/decrypt.c (op_data_t): Add field symdecrypt_failed.
	(parse_status_error): Handle BAD_PASSPHRASE error code.
	(_gpgme_decrypt_status_handler): Consult new field.

2022-04-22  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Report better error if decryption failed because of bad passphrase.
	+ commit d8e5871dca9425811873058150677a158235613d
	* lang/qt/src/qgpgmedecryptverifyjob.cpp (patch_decryption_result): New.
	(decrypt_verify): Call patch_decryption_result.

	cpp: Allow changing the error of a result.
	+ commit 321c8a0254f4729ff1ffe56956fb049555272321
	* lang/cpp/src/result.h (class Result): Add member function setError.

2022-04-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Handle canceling of an edit operation.
	+ commit 28cdbfdccb347e1ef15f794d4afd36f9275f073c
	* lang/cpp/src/editinteractor.cpp
	(CallbackHelper::edit_interactor_callback_impl): Check for error _or_
	canceled state.

	cpp: Return actual error if revocation fails.
	+ commit db532eca8ebd64536985e7a40af22e803e3b3df9
	* lang/cpp/src/editinteractor.cpp, lang/cpp/src/editinteractor.h
	(EditInteractor::parseStatusError): New.
	* lang/cpp/src/gpgrevokekeyeditinteractor.cpp
	(GpgRevokeKeyEditInteractor::Private::nextState): Handle status
	error.

	cpp: Add internal utility function for splitting strings.
	+ commit c965b45bcd915ce92943fd4d436b5bd790f0442f
	* lang/cpp/src/util.h (split): New.

	cpp: Do not export symbols of the Private class.
	+ commit 4beb6f419954b0df475d88bef7fc8b8065848b75
	* lang/cpp/src/gpgrevokekeyeditinteractor.h (class
	GpgRevokeKeyEditInteractor): Mark nested class Private as hidden.

2022-04-05  NIIBE Yutaka  <gniibe@fsij.org>

	core: Don't use internal __assuan functions.
	+ commit a36d71a8e33e817b1cc2fde5d0fd476ddc6ac560
	* configure.ac (nanosleep): Detect.
	* src/assuan-support.c: Don't use __assuan_usleep.
	(my_socketpair): Don't use __assuan_socketpair.

	core: Don't keep using deprecated ath_ API.
	+ commit 110a375401878b72984241c0dd84cb7fdeaae795
	* src/posix-io.c: Don't include ath.h.
	(_gpgme_io_read): Call read directly.
	(_gpgme_io_write): Call write directly.
	(_gpgme_io_waitpid): Call waitpid directly.
	(_gpgme_io_select_select): Call select directly.
	(_gpgme_io_recvmsg): Call recvmsg directly.
	(_gpgme_io_sendmsg): Call sendmsg directly.
	(_gpgme_io_connect): Call connect directly.
	* src/assuan-support.c: Don't include ath.h.
	(my_waitpid): Call waitpid directly.

2022-03-31  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Check arguments passed to the revoke key job.
	+ commit 7f089165e3ae42274e75e0e6fa1c45ca641f4023
	* lang/qt/src/qgpgmerevokekeyjob.cpp (check_arguments): New.
	(QGpgMERevokeKeyJob::start, QGpgMERevokeKeyJob::exec): Call
	check_arguments.
	* lang/qt/tests/t-revokekey.cpp (RevokeKeyJobTest): Add member functions
	testErrorHandling_nullKey, testErrorHandling_invalidReason,
	testErrorHandling_invalidDescription.

2022-03-30  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt,tests: Verify reason code and description of revocation.
	+ commit 3856ae8621bb28873123578a64eb81a4a591758e
	* lang/qt/tests/t-revokekey.cpp (RevokeKeyJobTest::testRevokeKeyAsync,
	RevokeKeyJobTest::testRevokeKeySync_noReasonDescription,
	RevokeKeyJobTest::testRevokeKeySync_oneLineReasonDescription,
	RevokeKeyJobTest::testRevokeKeySync_twoLinesReasonDescription): Call
	verifyReason.
	(class RevokeKeyJobTest): Add private member function verifyReason.

	qt: Add job to revoke own OpenPGP keys.
	+ commit 41297520da32081d0a34ac2799812f210b7a9335
	* lang/qt/src/revokekeyjob.h, lang/qt/src/qgpgmerevokekeyjob.h,
	lang/qt/src/qgpgmerevokekeyjob.cpp: New.
	* lang/qt/src/protocol.h (class Protocol): Add pure virtual member
	function revokeKeyJob.
	* lang/qt/src/protocol_p.h (Protocol::revokeKeyJob): New.
	* lang/qt/src/job.cpp, lang/qt/src/Makefile.am: Update accordingly.

	* lang/qt/tests/Makefile.am (the_tests, moc_files, noinst_PROGRAMS):
	Add new test.
	(t_revokekey_SOURCES): New.
	* lang/qt/tests/t-revokekey.cpp: New.

	cpp: Add interactor to revoke a key.
	+ commit d96e8a7a6bfcaad4587dd2bb648aa764b0d4e1ba
	* lang/cpp/src/global.h (enum class RevocationReason): New.
	* lang/cpp/src/gpgrevokekeyeditinteractor.cpp,
	lang/cpp/src/gpgrevokekeyeditinteractor.h: New.
	* lang/cpp/src/Makefile.am: Add new files.

2022-03-28  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Set default visibility of all symbols to hidden.
	+ commit 3b3b36a60749ea5c3b166bb1c8f3f6dda8ce6fcd
	* configure.ac: Add -fvisibility=hidden to GPGME_QT_CFLAGS if gcc
	supports the flag.

	cpp: Set default visibility of all symbols to hidden.
	+ commit fe588fef0963987b5624dc8c4bc73202ac2c9298
	* configure.ac: Add -fvisibility=hidden to GPGME_CPP_CFLAGS if gcc
	supports the flag.
	* lang/cpp/src/Makefile.am (AM_CPPFLAGS): Add GPGME_CPP_CFLAGS.
	* m4/ax_gcc_func_attribute.m4: New.

	cpp: Put local helper function into unnamed namespace.
	+ commit 92139e7b6b5fe84015d44d9516f3e1df7a3fc3bc
	lang/cpp/src/context.cpp (to_auditlog_flags): Wrap in unnamed namespace.

2022-03-16  NIIBE Yutaka  <gniibe@fsij.org>

	core: Support keylist mode for op_keylist_from_data.
	+ commit b2a2158384a9f048ff61ee0cebef8346055f0454
	* src/engine-backend.h (keylist_data): Add MODE argument.
	* src/engine-gpg.c (gpg_keylist_data): Add MODE argument.
	* src/engine.c (_gpgme_engine_op_keylist_data): Likewise.
	* src/engine.h (_gpgme_engine_op_keylist_data): Declaration.
	* src/keylist.c (gpgme_op_keylist_from_data_start): Call
	_gpgme_engine_op_keylist_data with ctx->keylist_mode.

2022-03-07  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add missing include of config.h.
	+ commit 55861ba9ccc6b1087cb81acd93bed81fc0787208
	* lang/qt/src/util.cpp: Include config.h.

2022-03-06  Werner Koch  <wk@gnupg.org>

	Post release updates.
	+ commit f61a14f189d33ca320f6c4ee6323f1e48c46e4ea


	Release 1.17.1.
	+ commit ee50a38823daaa16b151a549a7dafef34bbd1e81
	* configure.ac: Bump QT LT version to C15/A0/R0.

2022-02-17  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Fix ABI compatibility with 1.16.0.
	+ commit ad3aabdd8a64156c7e3a75d695ae1ab2c4bec841
	* lang/qt/src/protocol.h (class Protocol): Move new virtual methods to
	the end of the class.

2022-02-07  Werner Koch  <wk@gnupg.org>

	Release 1.17.0.
	+ commit 72bb46b34f5191f672a5356e2f152e6ad9440554


	qt: Fix build for older Qt versions.
	+ commit 451a42f0d21c5a402d455c78d63eeaaa139e56cc
	* lang/qt/src/util.cpp: Include <functional>.

2022-02-03  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add job to import keys given by key ids.
	+ commit ca1c30b6fa29a7a1f18ecda14375b47893a0c1a3
	* lang/qt/src/receivekeysjob.h, lang/qt/src/qgpgmereceivekeysjob.h,
	lang/qt/src/qgpgmereceivekeysjob.cpp: New.
	* lang/qt/src/protocol.h (class Protocol): Add pure virtual member
	function receiveKeysJob.
	* lang/qt/src/protocol_p.h (Protocol::receiveKeysJob): Implement it.
	* lang/qt/src/job.cpp, lang/qt/src/Makefile.am: Update accordingly.

	* lang/qt/tests/run-receivekeysjob.cpp: New.
	* lang/qt/tests/Makefile.am: Add new test runner.

	qt: Add helper for converting QStringList to vector of strings.
	+ commit ec8d1ee13fce21a1f52b084212827914dfcd0db6
	* lang/qt/src/util.h, lang/qt/src/util.cpp: New.
	* lang/qt/src/Makefile.am (qgpgme_sources, private_qgpgme_headers):
	Add new files.

	cpp: Allow import of keys given by key ids.
	+ commit bbaeeb5b9d5cca99c332cb88c7ae5f14e8745427
	* lang/cpp/src/context.h (class Context): Add overloads of member
	functions importKeys and startKeyImport
	* lang/cpp/src/context.cpp (class Context): ... and implement them.

	cpp: Add internal adapter for passing a vector of strings to gpgme.
	+ commit 3d7810e8d940229435feb8f9811607ee831abf4b
	* lang/cpp/src/util.h (class StringsToCStrings): New.
	* lang/cpp/src/util.cpp: New.
	* lang/cpp/src/Makefile.am: Add new file.

	core: New function gpgme_op_receive_keys.
	+ commit 3c2cff74b535422532e1256ee8177fa9c03eaf18
	* src/gpgme.h.in (gpgme_op_receive_keys_start, gpgme_op_receive_keys):
	New.
	* src/gpgme.def, src/libgpgme.vers: Add them.
	* src/engine-backend.h (struct engine_ops): Add arg keyids to field
	'import'.
	* src/engine.h, src/engine.c (_gpgme_engine_op_import): Add arg keyids.
	* src/engine.c (_gpgme_engine_op_import): Forward new arg keyids.
	* src/import.c: (_gpgme_op_import_start, _gpgme_op_import_keys_start):
	Pass NULL to new arg of _gpgme_op_import_start.
	(_gpgme_op_receive_keys_start, gpgme_op_receive_keys_start,
	gpgme_op_receive_keys): New.
	* src/engine-gpg.c (gpg_import): Add arg keyids. Extend check for
	valid arguments. Build command line if keyids are given.
	* src/engine-gpgsm.c (gpgsm_import): Add arg keyids. Return error if
	keyids is not NULL.

	tests/run-receive-keys.c: New.
	tests/Makefile.am (noinst_PROGRAMS): Add new test runner.

2022-01-17  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Remove superfluous include.
	+ commit ec71eb1d7d9f1156cc48d1c9959b07981ecd16e5
	* lang/qt/src/importjob.h: Remove include of QByteArray.

	qt: Fix build without installed GpgME++ headers.
	+ commit 9c03bde06be97403a8c392a3befc6c203bcdce6d
	* lang/qt/src/importjob.h, lang/qt/src/wkdlookupresult.h: Include
	headers of GpgME++ without "gpgme++/" prefix when building QGpgme.
	* lang/qt/src/qgpgmeimportjob.cpp, lang/qt/src/qgpgmewkdlookupjob.cpp,
	lang/qt/src/wkdlookupresult.cpp, lang/qt/tests/t-import.cpp: Include
	headers of GpgME++ without "gpgme++/" prefix.

2022-01-13  Ingo Klöcker  <dev@ingo-kloecker.de>

	tests: Fix generation of keys without expiration.
	+ commit e16729edcbdf2c35e3729b6d54c21b9b27250326
	* tests/run-genkey.c (parse_expire_string): Support default expiration
	and no expiration. Set flag for no expiration.
	(main): Allow update of flags when generating new key.

	tests: Remove unsupported option --status from usage help.
	+ commit e4625885a851112a15636727388f11146be17f15
	* tests/run-swdb.c (show_usage): Remove option --status.

	qt: Add job to add existing subkeys to other keys.
	+ commit 4d913a8aa5dad1327bed5987dada89e9d7c5d292
	* lang/qt/src/addexistingsubkeyjob.h,
	lang/qt/src/qgpgmeaddexistingsubkeyjob.cpp,
	lang/qt/src/qgpgmeaddexistingsubkeyjob.h: New.
	* lang/qt/src/protocol.h (class Protocol): Add pure virtual member
	function addExistingSubkeyJob.
	* lang/qt/src/protocol_p.h (Protocol::addExistingSubkeyJob): Implement.
	* lang/qt/src/job.cpp, lang/qt/src/Makefile.am: Update accordingly.

	* lang/qt/tests/Makefile.am (the_tests, moc_files, noinst_PROGRAMS):
	Add new test.
	(t_addexistingsubkey_SOURCES): New.
	* lang/qt/tests/t-addexistingsubkey.cpp: New.
	* lang/qt/tests/t-support.h (VERIFY_OR_RETURN_VALUE,
	COMPARE_OR_RETURN_VALUE, VERIFY_OR_OBJECT, COMPARE_OR_OBJECT,
	VERIFY_OR_FALSE, COMPARE_OR_FALSE): New.
	* lang/qt/tests/t-support.h, lang/qt/tests/t-support.cpp
	(class QQGpgMETest): New member function importSecretKeys.

	qt,tests: Add helper to hook up the test passphrase provider.
	+ commit d308910cdfb31accae7cf790a956eb2f3cc6ae71
	* lang/qt/tests/t-support.h, lang/qt/tests/t-support.cpp
	(class QGpgMETest): Add member function hookUpPassphraseProvider.
	Add member mPassphraseProvider.
	* lang/qt/tests/t-changeexpiryjob.cpp,
	lang/qt/tests/t-encrypt.cpp,
	lang/qt/tests/t-remarks.cpp,
	lang/qt/tests/t-tofuinfo.cpp,
	lang/qt/tests/t-trustsignatures.cpp,
	lang/qt/tests/t-various.cpp: Use new helper.

	qt,tests: Add asyncDone signal to base class of all tests.
	+ commit a54402fc2d1c1364843d3c88b5b07dbb7fc007d1
	* lang/qt/tests/t-support.h (class QGpgMETest): Add signal asyncDone.
	* lang/qt/tests/t-changeexpiryjob.cpp,
	lang/qt/tests/t-encrypt.cpp,
	lang/qt/tests/t-import.cpp,
	lang/qt/tests/t-keylist.cpp,
	lang/qt/tests/t-keylocate.cpp,
	lang/qt/tests/t-ownertrust.cpp,
	lang/qt/tests/t-remarks.cpp,
	lang/qt/tests/t-tofuinfo.cpp,
	lang/qt/tests/t-trustsignatures.cpp,
	lang/qt/tests/t-various.cpp,
	lang/qt/tests/t-wkdlookup.cpp,
	lang/qt/tests/t-wkspublish.cpp: Remove signal asyncDone from the test
	classes.

2022-01-12  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Add interactor to add existing subkeys to other keys.
	+ commit a4dcb17486bb42890ffe6453eeb2c6f301dc1fae
	* lang/cpp/src/gpgaddexistingsubkeyeditinteractor.cpp,
	lang/cpp/src/gpgaddexistingsubkeyeditinteractor.h: New.
	* lang/cpp/src/Makefile.am: Add new files.

2022-01-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Return an error for secret key export operations.
	+ commit a527bd7cf58563d07c89bec458c8967ab1b3e60f
	src/export.c (export_status_handler): Handle "export_keys.secret".

2022-01-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add factory function for secret subkey export job.
	+ commit 04723a6e96be77dbc43bf71c54e268424a1823ba
	* lang/qt/src/protocol.h (class Protocol): Add member function
	secretSubkeyExportJob.
	* lang/qt/src/protocol_p.h (Protocol::secretSubkeyExportJob): Implement.

	* lang/qt/tests/run-exportjob.cpp (showUsageAndExitWithCode): Print
	new option.
	(createExportJob): Create secret subkey export job if requested.
	(main): New option --secret-subkey.

	cpp: Allow export of secret subkeys.
	+ commit e5c7fc3e022841be8f68fad8b9b64dd601b89ba7
	* lang/cpp/src/context.h (enum Context::ExportMode): Add value
	ExportSecretSubkey.
	(class Context): Add member functions exportSecretSubkeys and
	startSecretSubkeyExport.
	* lang/cpp/src/context.cpp (Context::exportPublicKeys,
	Context::startPublicKeyExport): Return error if ExportSecretSubkey
	mode flag is set.
	(Context::exportSecretSubkeys, Context::startSecretSubkeyExport):
	Implement.

	qt: Remove obsolete QGpgMESecretKeyExportJob.
	+ commit 88ad37ea96e4645a9e23aac9eae0d8da747559b8
	* lang/qt/src/Makefile.am: Remove all occurrences of
	qgpgmesecretkeyexportjob.*.
	* lang/qt/src/qgpgmesecretkeyexportjob.cpp,
	lang/qt/src/qgpgmesecretkeyexportjob.h: Remove.

	qt: Use QGpgMEExportJob also for export of secret keys.
	+ commit 4e80563fabfdf1d1c136d65252e5353fdd1e9092
	* lang/qt/src/protocol.h (Protocol::secretKeyExportJob): Document
	charset argument as ignored.
	* lang/qt/src/protocol_p.h (Protocol::secretKeyExportJob): Use
	QGpgMEExportJob instead of QGpgMESecretKeyExportJob.
	* lang/qt/src/qgpgmeexportjob.h (class QGpgMEExportJob): Add c'tor
	taking an export mode. Add member m_exportMode. Rename member m_flags to
	m_additionalExportModeFlags.
	(QGpgMEExportJob::~QGpgMEExportJob): Mark as override.
	* lang/qt/src/qgpgmeexportjob.cpp (QGpgMEExportJob::QGpgMEExportJob):
	Delegate to new c'tor. Implement new c'tor.
	(QGpgMEExportJob::~QGpgMEExportJob): Use default.
	(export_qba): Rename argument flags to mode.
	(QGpgMEExportJob::start): Pass combination of export mode and additional
	mode flags to export_qba.
	(QGpgMEExportJob::setExportFlags): Adapt to renaming of member.

	* lang/qt/tests/run-exportjob.cpp: New.

	cpp: Allow export of secret keys.
	+ commit 3da06d1096ee29d70656f07edcabc3bc4351104e
	* lang/cpp/src/context.h (class Context): New member functions
	exportSecretKeys, startSecretKeyExport, exportKeys, startKeyExport.
	(Context::exportPublicKeys, Context::startPublicKeyExport): Rename
	argument flags/export_mode to mode.
	* lang/cpp/src/context.cpp (Context::exportPublicKeys): Return error if
	ExportSecret mode flag is set. Call exportKeys().
	(Context::startPublicKeyExport): Return error if
	ExportSecret mode flag is set. Call startKeyExport().
	(Context::exportSecretKeys, Context::startSecretKeyExport,
	Context::exportKeys, Context::startKeyExport): Implement.

	cpp: Mark ExportNoUID flag as obsolete.
	+ commit 4888191014c24d5954685814e06c9ff0ee38739f
	* lang/cpp/src/context.h (enum Context::ExportMode): Mark value
	ExportNoUID as obsolete

	core: Add new option --secret-subkey to help texts.
	+ commit 2752e81f892568a9725fdd8d6a997a1cc80d2f88
	* src/gpgme-tool.c (hlp_export): Add new option.
	* tests/run-export.c (show_usage): Print new option.

	cpp: Remove obsolete workaround.
	+ commit fa5f1b57cc12f9305d112f11c2c2d95751ed1a25
	* lang/cpp/src/context.cpp (Context::startKeyListing,
	Context::exportPublicKeys, Context::startPublicKeyExport): Remove
	workaround.

	core: New export mode to export secret subkeys.
	+ commit 0e19c4879193ed7fa61ad5d488f237b2b5b5d1d7
	* src/gpgme.h.in (GPGME_EXPORT_MODE_SECRET_SUBKEY): New.
	* src/export.c (check_mode): Allow new mode and check for invalid
	combinations.
	(export_keys_start): Return error if new mode flag is set.
	* src/engine-gpg.c (export_common): Implement.
	* src/gpgme-tool.c (cmd_export): New option --secret-subkey.
	* tests/run-export.c (main): New option --secret-subkey.

	doc: Remove documentation of obsolete export mode flag.
	+ commit 414bbdd53c380018621a2a5800e9a9c46869a56e
	* doc/gpgme.texi: Remove GPGME_EXPORT_MODE_NOUID.

	core: Check for unsupported export mode flags.
	+ commit c710af223cc2476d5f4d46c00d8e0521f6c13211
	src/engine-gpgsm.c (gpgsm_export, gpgsm_export_ext): Return error if an
	unsupported mode flag is set.

	core: Check for combination of ssh mode with other mode flags.
	+ commit c0581adabe7f5f63c0b96dac449790aa6ac4c291
	* src/export.c (check_mode): Return error if ssh mode is combined with
	another mode flag.

	core: Factor out the check for valid export mode flags.
	+ commit 326857511587fa7878757d3884f91bf7eb86771c
	* src/export.c (check_mode): New.
	(export_start, export_ext_start): Call check_mode.

2021-12-22  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Detect an import error caused by a wrong password.
	+ commit 82f43455e9412d8b4792b35371e0b6704a619d07
	* lang/qt/src/qgpgmeimportjob.cpp (import_qba): Check import statuses of
	import result for bad passphrase errors.

	qt,tests: Add test runner for testing the import job.
	+ commit f99451e20fd2f84ac653aa6021a475026a9d4dc9
	* lang/qt/tests/Makefile.am (run_importjob_SOURCES): New.
	(noinst_PROGRAMS): Add run-importjob.
	* lang/qt/tests/run-importjob.cpp: New.

	cpp: Check fpr of import status for NULL.
	+ commit 300776f39165da068757864e9cb3029f06f3be5b
	* lang/cpp/src/importresult.cpp (GpgME::ImportResult::Private): Check
	fpr for NULL.

	core: Detect bad passphrase error on certificate import.
	+ commit 305d8668ca724982c50fe4e05315c48a20cc33e5
	* src/import.c (gpgme_op_import_result): Check fpr for NULL.
	(parse_error): New.
	(import_status_handler): Handle error status line.

	* doc/gpgme.texi (gpgme_import_status_t): Mention that fpr can be NULL.

	* tests/gpg/t-import.c (check_result): Check fpr for NULL.
	* tests/run-threaded.c (delete_impres): Check fpr for NULL.

2021-12-22  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update for newer autoconf.
	+ commit 0636e229d7edfcb0a357ffcce62079488be32495
	* configure.ac (AC_PREREQ): Require >= 2.69.
	(AC_CONFIG_HEADERS): Use it instead of AC_CONFIG_HEADER.

2021-12-15  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Allow specifying an import filter when importing keys.
	+ commit 619579bb172579d766956b5d1690d18934fd5986
	* lang/qt/src/importjob.cpp (struct ImportJobPrivate): Add member
	m_importFilter.
	* lang/qt/src/importjob.cpp, lang/qt/src/importjob.h (class ImportJob):
	Add member functions setImportFilter and importFilter.
	* lang/qt/src/qgpgmeimportjob.cpp (import_qba): Add arg importFilter
	and adjust the callers. Set import filter context flag.

	* lang/qt/tests/t-import.cpp (ImportTest): Add member function
	testImportWithImportFilter.

	qt: Avoid test failure when test is run multiple times.
	+ commit 3e81a4a336e093d075f83afe3e1bd26493e64cac
	* lang/qt/tests/t-import.cpp (ImportTest): Add member tempGpgHome and
	member function initTestCase.
	(keyFpr, keyData): Move to ImportTest::testImportWithKeyOrigin.

	qt: Fix erroneous reuse of JobPrivate objects.
	+ commit 3c770013d7233cb0a803251af54c0a2c1fb61e35
	* lang/qt/src/job.cpp (Job::~Job): Destroy JobPrivate object belonging
	to destroyed job.

2021-12-14  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Allow setting import filters when importing keys.
	+ commit d35d44efaf72f90ee4f92af8382c4bcb9982da3f
	* src/context.h (struct gpgme_context): New field import_filter.
	* src/engine-backend.h (struct engine_ops): Add arg import_filter to
	field 'import'.
	* src/engine-gpg.c (gpg_import): Add arg import_filter and pass option
	--import-filter with argument value to gpg. Adjust all callers.
	* src/engine-gpgsm.c (gpgsm_import): Add dummy arg import_filter.
	* src/gpgme.c (gpgme_release): Free 'import_filter'.
	(gpgme_set_ctx_flag, gpgme_get_ctx_flag): New flag "import-filter".

	* tests/run-import.c (main): Add option --import-filter.

	qt: Add pattern used for WKD lookup to result.
	+ commit af820811ec7d0818f988cd728d745cede88ab45f
	* lang/qt/src/qgpgmewkdlookupjob.cpp (run_wkd_get): Change type of
	arg email.
	(lookup_keys): Add pattern to result.
	* lang/qt/src/wkdlookupresult.h (class WKDLookupResult): Add arg
	pattern to c'tors. Add member function pattern.
	* lang/qt/src/wkdlookupresult.cpp (class WKDLookupResult::Private):
	Add field pattern.
	(WKDLookupResult::WKDLookupResult): Pass pattern to pimpl.
	(WKDLookupResult::pattern): New.

	* lang/qt/tests/t-wkdlookup.cpp (testWKDLookupAsync, testWKDLookupSync,
	testLookupWithNoResultAsync): Check pattern.

	core: Set --key-origin option only if supported by gpg.
	+ commit fd680254dae58a6bf6fb83688bf7c849257688a4
	* src/engine-gpg.c (gpg_import): Do not pass --key-origin option to
	gpg if gpg is too old.

	qt: Allow setting key origin when importing keys.
	+ commit fd6bec617d8fb6ddcbc622a5d8cf94594a7d5520
	* lang/qt/src/Makefile.am (qgpgme_sources): Add importjob.cpp.
	* lang/qt/src/importjob.cpp: New.
	* lang/qt/src/importjob.h (class ImportJob): Add member functions
	setKeyOrigin, keyOrigin, keyOriginUrl.
	* lang/qt/src/qgpgmeimportjob.cpp (originToString): New.
	(import_qba): Set key origin context flag.
	(QGpgMEImportJob::start, QGpgMEImportJob::exec): Add options to call
	of import_qba.

	* lang/qt/tests/Makefile.am (the_tests, moc_files, noinst_PROGRAMS):
	Add new test.
	(t_import_SOURCES): New.
	* lang/qt/tests/t-import.cpp: New.

	qt,tests: Skip WKD lookup tests by default.
	+ commit 3a43d9dc67970db323c3e49eb964d52c4eb3ac6c
	* lang/qt/tests/t-support.cpp, lang/qt/tests/t-support.h
	(class QGpgMETest): Add member function doOnlineTests.
	* lang/qt/tests/t-wkdlookup.cpp (testWKDLookupAsync, testWKDLookupSync,
	testLookupWithNoResultAsync): Skip tests if online tests are not
	enabled.

2021-12-13  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Allow specifiying a key origin when importing keys.
	+ commit 60880adafa93e1a1e8e9fecf03c14d56bbd55345
	* src/context.h (struct gpgme_context): New field key_origin.
	* src/engine-backend.h (struct engine_ops): Add arg key_origin to
	field 'import'.
	* src/engine-gpg.c (gpg_import): Add arg key_origin and pass option
	--key-origin with argument value to gpg. Adjust all callers.
	* src/engine-gpgsm.c (gpgsm_import): Add dummy arg key_origin.
	* src/gpgme.c (gpgme_release): Free 'key_origin'.
	(gpgme_set_ctx_flag, gpgme_get_ctx_flag): New flag "key-origin".

	* tests/run-import.c (main): Add option --key-origin.
	* tests/gpg/t-import.c (main): Set and verify key origin.

	qt: Support WKD lookup without implicit import.
	+ commit ed7e7df2e14feb443e84d87e518ff61b1f7aa6d8
	* lang/qt/src/Makefile.am (qgpgme_sources): Add qgpgmewkdlookupjob.cpp,
	wkdlookupresult.cpp.
	(qgpgme_headers): Add wkdlookupjob.h, wkdlookupresult.h.
	(camelcase_headers): Add WKDLookupJob, WKDLookupResult.
	(private_qgpgme_headers): Add qgpgmewkdlookupjob.h.
	(qgpgme_moc_sources): Add qgpgmewkdlookupjob.moc, wkdlookupjob.moc.
	* lang/qt/src/job.cpp: Define c'tor and d'tor of WKDLookupJob.
	* lang/qt/src/protocol.h (Protocol::wkdLookupJob): New.
	* lang/qt/src/protocol_p.h (Protocol::wkdLookupJob): New.
	* lang/qt/src/qgpgmewkdlookupjob.cpp, lang/qt/src/qgpgmewkdlookupjob.h,
	lang/qt/src/wkdlookupjob.h, lang/qt/src/wkdlookupresult.cpp,
	lang/qt/src/wkdlookupresult.h: New.

	* lang/qt/tests/Makefile.am (EXTRA_DIST): Add final.test.
	(the_tests): New.
	(TESTS): Remove all t-*. Add $(the_tests) and final.test.
	(moc_files): Add t-wkdlookup.moc.
	(t_wkdlookup_SOURCES): New.
	(noinst_PROGRAMS): Add t-wkdlookup.
	* lang/qt/tests/final.test: New.
	* lang/qt/tests/t-support.h (QTest::toString): New template
	specialization for std::string.
	* lang/qt/tests/t-wkdlookup.cpp: New.

	qt: Fix example for using the asynchronous job API.
	+ commit 0e70a2313afbbaaec6859a1edb478587ff82a6b5
	* lang/qt/src/protocol.h (class Protocol): Fix API documentation.

2021-12-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp,tests: Add test runner for doing a WKD lookup without import.
	+ commit f3177d3ee0a1d30e15f33ff226b5e4c96b7610db
	* lang/cpp/tests/Makefile.am (run_wkdlookup_SOURCES, programs_unix):
	New.
	(noinst_PROGRAMS): Add $(programs_unix).
	* lang/cpp/tests/run-wkdlookup.cpp: New.

	cpp: Add new supported components to API docs of dirInfo()
	+ commit 5f1ba40116199cd77987c3c2797d600f6df018c2
	lang/cpp/src/global.h: Update API doc of dirInfo().

	core: Support all components with dirinfo()
	+ commit 0ac3679a74505b782388402b3743ee65c271340f
	* src/dirinfo.c (WANT_KEYBOXD_NAME, WANT_AGENT_NAME, WANT_SCDAEMON_NAME,
	WANT_DIRMNGR_NAME, WANT_PINENTRY_NAME): New.
	(dirinfo): Add fields keyboxd_name, agent_name, scdaemon_name,
	dirmngr_name, pinentry_name.
	(parse_output): Support "keyboxd", "gpg-agent", "scdaemon", "dirmngr",
	"pinentry".
	(get_gpgconf_item): Return new components.

	tests/t-engine-info.c (main): Add new components to the output.

2021-12-07  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Return engine info for engine used by the context.
	+ commit 0eddc867c31dd7239a1a9c4196bf8dc1372ea4b1
	lang/cpp/src/context.cpp (Context::engineInfo()): Return engine info
	for protocol of context.

	cpp: Factor out common code of GpgME::engineInfo() overloads.
	+ commit 1a1e9145877a60632346ae3ab68b1ae9d722a867
	* lang/cpp/src/context.cpp (get_engine_info, get_static_engine_info):
	New.
	(GpgME::engineInfo(GpgME::Protocol), GpgME::engineInfo(GpgME::Engine)):
	Use get_static_engine_info().

2021-11-25  Werner Koch  <wk@gnupg.org>

	core: Make the gpgconf option parsing of string types more robust.
	+ commit b8b49c11e95fd978a8a2eed23f191d087ab056da
	* src/engine-gpgconf.c (gpgconf_parse_option): Skip the string
	indicator if it is not the empty string.

	tests: Silence libtool warning on Windows.
	+ commit 43de18a292b29436783127bd6c275817f0cd86b7
	* tests/Makefile.am (AM_LDFLAGS): Use --no-fast-install on Windows.

	core: Support dirinfo("socketdir")
	+ commit eb37d6469e722ae5ff187962c216474b5ec476de
	* src/dirinfo.c (WANT_SOCKETDIR): New.
	(dirinfo): Add field socketdir.
	(parse_output): Support "socketdir".
	(get_gpgconf_item): Return socketdir.

	* tests/t-engine-info.c (main): Add socketdir to the output.

	* src/w32-util.c (_gpgme_create_process_utf8): Fix indentation.

2021-11-25  NIIBE Yutaka  <gniibe@fsij.org>

	posix: Use poll instead, when available, removing use of select.
	+ commit 8148237cb4ae20755c06a44d71761c7030973c3d
	* configure.ac (HAVE_POLL_H): Add the check.
	* src/ath.c [!HAVE_POLL_H] (ath_select): Enable conditionally.
	* src/posix-io.c [HAVE_POLL_H] (_gpgme_io_select_poll): Use poll.
	* tests/gpg/t-cancel.c [HAVE_POLL_H] (do_select): Use poll.
	* tests/gpg/t-eventloop.c [HAVE_POLL_H] (do_select): Use poll.

2021-11-12  NIIBE Yutaka  <gniibe@fsij.org>

	gpgme.pc: Fix library dependency and use of includedir, libdir.
	+ commit 4583ab77e5af3f0da5b307a169d07b58dddf652f
	* src/gpgme.pc.in (Require): Move gpg-error, libassuan to...
	(Requires.private): ... here.
	(Cflags): Add -I${includedir}.
	(Libs): Add -L${libdir}.

2021-11-12  NIIBE Yutaka  <gniibe@fsij.org>
	    Ben Kibbey  <bjk@luxsci.net>

	tests: Build using GPG_ERROR_MT_LIBS for thread use.
	+ commit 1cedac2bba246ff411843aaef10ca8ea0a0756cf
	* tests/gpg/Makefile.am (WITH_THREAD_CPPFLAGS): New.
	(WITH_THREAD_LDADD): New.
	(t_thread1_CPPFLAGS, t_thread_keylist_CPPFLAGS)
	(t_thread_keylist_verify_CPPFLAGS)
	(t_cancel_CPPFLAGS): Use WITH_THREAD_CPPFLAGS.
	(t_thread1_LDADD, t_thread_keylist_LDADD)
	(t_thread_keylist_verify_LDADD)
	(t_cancel_LDADD): Use WITH_THREAD_LDADD.

2021-11-11  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Use GPG_ERROR_MT_LIBS for a test with threads.
	+ commit 8cd2fe7b3de4abd2331bcb637b7e2c26ce4faa29
	* tests/Makefile.am (run_threaded_CPPFLAGS): New.
	(run_threaded_LDADD): Replace GPG_ERROR_LIBS to GPG_ERROR_MT_LIBS.

2021-11-10  NIIBE Yutaka  <gniibe@fsij.org>

	libtool: Link without -flat_namespace for macOS.
	+ commit 50daf3d75d666d34fecc0dbecc31c51a7989eda3
	* m4/libtool.m4: Not setting 10.0 to MACOSX_DEPLOYMENT_TARGET when not
	defined.  Only specify -flat_namespace to linker for specific
	(older) versions and hosts.

2021-09-13  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Fix build against Qt 5.9.
	+ commit ab9bca09eb869b2013c85fee232f1e62aed925f6
	* lang/qt/tests/t-keylist.cpp (KeyListTest::testListAllKeysSync):
	Ensure same type for both arguments of QCOMPARE.
	* lang/qt/tests/t-various.cpp (TestVarious::testSetExpire):
	Ensure same type for both arguments of QCOMPARE.

2021-08-27  Werner Koch  <wk@gnupg.org>

	build: Fix make distcheck problem.
	+ commit aaf448b1e81e7421e539ac2deb9dc9d3d1459016
	* tests/start-stop-agent: Use -f with rm.  Also use cat instead of cp.

2021-08-27  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Expect UTF-8 on stderr on Windows.
	+ commit 8fe15462829b5049137b3f631564b72c4f63c5e2
	* lang/qt/src/threadedjobmixin.cpp (stringFromGpgOutput): Expect
	UTF-8.

	Add missing files for distribution.
	+ commit bc774104bbf461805f875c2bfd2d02aa6dd0945d
	* lang/qt/src/Makefile.am (private_qgpgme_headers): Add job_p.h
	* tests/gpg/Makefile.am (EXTRA_DIST): Add gpg.conf.in

2021-08-13  NIIBE Yutaka  <gniibe@fsij.org>

	core: Use flexible array member if compiler has support.
	+ commit 3c1c98a43413e429459ca7d3615659f8149534b8
	* configure.ac (AC_C_FLEXIBLE_ARRAY_MEMBER): Add.
	* src/engine-gpg.c (struct arg_and_data_s): Use FLEXIBLE_ARRAY_MEMBER.
	(_add_arg): Use offsetof instead of sizeof.
	(add_data): Likewise.

2021-08-03  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Fix results returned by gpgme_data_* functions.
	+ commit 7cfc93193d535ec5037e48b86544e1b4dbf949f6
	src/debug.h (TRACE_SYSRES_OFF_T, _trace_sysres_off_t,
	TRACE_SYSRES_SSIZE_T, _trace_sysres_ssize_t): New.
	src/data.c (gpgme_data_read, gpgme_data_write, gpgme_data_seek): Use
	appropriate new tracing macros instead of casting the results to int.

2021-07-27  Jiri Kucera  <sanczes@gmail.com>

	core: Support closefrom also for glibc.
	+ commit 4b64774b6d13ffa4f59dddf947a97d61bcfa2f2e
	* src/posix-io.c (_gpgme_io_spawn): Use glibc's closefrom.

2021-07-08  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Ensure gpg.conf for tests is recreated if necessary.
	+ commit a5662a801fc11a533fb3b1a69a17e119064972a3
	* tests/gpg/gpg.conf.in: New.
	* tests/gpg/Makefile.am (gpg.conf): Copy gpg.conf.in instead of using
	echo to fill gpg.conf.

	Make sure expiration time is interpreted as unsigned number.
	+ commit 6a79e90dedc19877ae1c520fed875b57089a5425
	* lang/qt/tests/t-various.cpp (testSignKeyWithExpiration): Convert
	expiration time to uint_least32_t.

2021-06-29  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Allow retrieving the default value of a config entry.
	+ commit 12006a782900687a7f0158a3f931528cfc5ff451
	* lang/qt/src/cryptoconfig.cpp, lang/qt/src/cryptoconfig.h
	(CryptoConfigEntry::defaultValue): New.
	* lang/qt/src/qgpgmenewcryptoconfig.cpp,
	lang/qt/src/qgpgmenewcryptoconfig.h
	(QGpgMENewCryptoConfigEntry::defaultValue): New.
	* lang/qt/tests/t-config.cpp (CryptoConfigTest::testDefault()):
	Add test of CryptoConfigEntry::defaultValue(). Port away from deprecated
	CryptoConfig::entry overload.

2021-06-28  Ingo Klöcker  <dev@ingo-kloecker.de>

	Update NEWS.
	+ commit d8638ed0aa5bf7f970787155a35d37a4f5d320f8
	* NEWS: Add changes of ChangeExpiryJob.

	qt: Fix filenames in copyright headers.
	+ commit 9d2b876093c25f604d9efe2775143c8f0361916d
	* lang/qt/src/qgpgmechangeownertrustjob.h,
	lang/qt/tests/t-trustsignatures.cpp: Use correct filenames.

	qt: Add test for ChangeExpiryJob.
	+ commit 801acd89b234fcd7226f3fb39ec01634460cfa50
	* lang/qt/tests/Makefile.am (TESTS, moc_files, noinst_PROGRAMS): Add
	new test.
	(t_changeexpiryjob_SOURCES): New.
	* lang/qt/tests/t-changeexpiryjob.cpp: New.

	qt: Allow changing expiration date of primary key and all subkeys.
	+ commit 144d580607dd0b70bb20542e2f457153b9cc4ecb
	* lang/qt/src/Makefile.am (qgpgme_sources): Add changeexpiryjob.cpp.
	* lang/qt/src/changeexpiryjob.cpp: New.
	* lang/qt/src/changeexpiryjob.h (enum ChangeExpiryJob::Option,
	typedef ChangeExpiryJob::Options, ChangeExpiryJob::setOptions,
	ChangeExpiryJob::options): New.
	* lang/qt/src/qgpgmechangeexpiryjob.cpp (change_expiry): Update the
	expiration date of primary key and/or some/all subkeys.
	(QGpgMEChangeExpiryJob::start): Add options to call of change_expiry.
	(ChangeExpiryJob::start): Moved implementation to changeexpiryjob.cpp.

	qt: Add mechanism for missing d-pointer in Job.
	+ commit 3503816570a19352e4b8a81d1cd0f3a9337b8c55
	* lang/qt/src/job_p.h: New.
	* lang/qt/src/job.cpp (typedef JobPrivateHash, d_func, setJobPrivate,
	getJobPrivate): New.

2021-06-26  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Remove superfluous trailing ';'
	+ commit ade95b25ce473a3c9ebcb77b7bd76a2fa6ed2805
	lang/qt/src/signkeyjob.h (class SignKeyJob): Remove trailing ';' from
	inline implemented member functions

	core: Fix use-after-free issue in test.
	+ commit 81a33ea5e1b86d586b956e893a5b25c4cd41c969
	* tests/gpg/t-edit-sign.c (sign_key, verify_key_signature): New.
	(main): Factored out signing and verifying the result.

2021-06-24  Werner Koch  <wk@gnupg.org>

	Release 1.16.0.
	+ commit 1021c8645555502d914afffaa3707609809c9459


2021-06-22  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Extend SignKeyJob to create signatures with expiration date.
	+ commit ac4536990a4fed4a45a0851260c029e69d0cadf6
	* lang/qt/src/signkeyjob.h (SignKeyJob::setExpirationDate): New.
	* lang/qt/src/qgpgmesignkeyjob.h, lang/qt/src/qgpgmesignkeyjob.cpp
	(QGpgMESignKeyJob::setExpirationDate): New.
	* lang/qt/src/qgpgmesignkeyjob.cpp (QGpgMESignKeyJob::Private): Add
	member m_expiration.
	(sign_key): Handle expiration date.
	(QGpgMESignKeyJob::start): Pass expiration date to sign_key.

	* lang/qt/tests/t-various.cpp
	(TestVarious::testSignKeyWithoutExpiration,
	TestVarious::testSignKeyWithExpiration): New.
	(TestVarious::initTestCase): Add "allow-weak-key-signatures" to
	gpg.conf.

	core: Allow specifying an expiration date for key signatures.
	+ commit 34d9defc42bacfaf2bb1ce70b2c3f0fdf0a106c3
	* src/context.h (struct gpgme_context): Add 'cert_expire'.
	* src/engine-gpg.c (append_args_from_cert_expire): New.
	(gpg_edit): Set option according to the new flag.
	* src/gpgme.c (gpgme_release): Free 'cert_expire'.
	(gpgme_set_ctx_flag, gpgme_get_ctx_flag): Add "cert-expire".

	* tests/gpg/Makefile.am (c_tests): Add new test.
	(gpg.conf): Write "allow-weak-key-signatures" to gpg.conf.
	* tests/gpg/t-edit-sign.c: New.

2021-06-21  Ingo Klöcker  <dev@ingo-kloecker.de>

	Update NEWS.
	+ commit ab1d4ef580794a86da754d516db35091f6997e2c
	* NEWS: Add news for recent changes

2021-06-18  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add missing }
	+ commit 5340bb7ccfa7086054823fac48d178e6206d66c0
	* lang/qt/src/qgpgmenewcryptoconfig.cpp (parseURL): Add missing }.

2021-06-17  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add some error logging.
	+ commit 72de06417e32bd6573acd0b73a72fcf98232fe81
	* lang/qt/src/qgpgmenewcryptoconfig.cpp (setURLValueList): Log error
	if setting config value failed.

	qt: Do not set empty base DN as query of keyserver URL.
	+ commit 1dca8c2b3c6d6aa3dfd4215c911207f08a3bf9f1
	* lang/qt/src/qgpgmenewcryptoconfig.cpp (parseURL): Only set non-empty
	base DN as URL query.

	qt: Fix API documentation.
	+ commit 0d03f31e07e683efbdb206cc3407bf222d71d8fe
	* lang/qt/src/signkeyjob.h (SignKeyJob::start,
	SignKeyJob::setUserIDsToSign, SignKeyJob::setCheckLevel): Fix
	documentation of parameters.

2021-06-14  Werner Koch  <wk@gnupg.org>

	core: New data flags "io-buffer-size" and "sensitive".
	+ commit fde20940b5ca6986dc12215209e8858601bb0c2e
	* src/data.c (_gpgme_data_release): Free buffers.
	(gpgme_data_seek): Adjust from renamed fields.
	(gpgme_data_set_flag): Implement new flags.
	(_gpgme_data_inbound_handler): Allow the use of a malloced buffer.
	(_gpgme_data_outbound_handler): Ditto.
	* src/data.h (BUFFER_SIZE): Move out of the struct definition.
	(struct gpgme_data): Remove pending filed and introduce inbound and
	outbound fields.

	* src/conversion.c (_gpgme_wipememory): New.  Taken from GnuPG.
	* src/cJSON.c (wipememory): Use this here too.

	* tests/run-decrypt.c (main): Add options "--large-buffers" and
	"--sensitive".

	core: Also detect AuthEnvelopedData (AEAD for CMS)
	+ commit ea290108e4df9f93eda79789d9cde5441d6bdd55
	* src/data-identify.c (basic_detection): Add OID.

2021-06-10  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Flush output after write for QProcess output.
	+ commit b3b75c37e2d3ef313031ceba8063feeccb0583ec
	* lang/qt/src/dataprovider.cpp (QIODeviceDataProvider::write): Call
	waitForBytesWritten.

	core,w32: Increase BUFFER_SIZE to 4096.
	+ commit ceb8387460b05de5c8cec6e02950176b09c4f38b
	* src/data.h (BUFFER_SIZE): Increase to 4096 for Windows.

2021-06-09  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Explicitly link libgpg-error.
	+ commit e6095e54718fe2463fb54adf5879d55e2fba4fef
	* lang/qt/src/Makefile.am (libqgpgme_la_LIBADD): Explicitly link
	gpg-error.

	core: Explicitly add GPG_ERROR_CFLAGS.
	+ commit 4041e2c62a10a149776a78e9221de6732693dad9
	* src/Makefile.am (AM_CFLAGS): Add GPG_ERROR_CFLAGS

2021-06-02  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add separate logging category for result of config loading.
	+ commit 5bc4e23a57f149c2a7008c1b88ab3d398ce75e9b
	* lang/qt/src/qgpgme_debug.h: Make include guard match file name.
	* lang/qt/src/qgpgme_debug.h, lang/qt/src/qgpgme_debug.cpp
	(QGPGME_CONFIG_LOADING_LOG): New.
	* lang/qt/src/qgpgmenewcryptoconfig.cpp
	(QGpgMENewCryptoConfig::reloadConfiguration): Use new logging category.

	core: Fix a few checks for number of fields in keylist result parser.
	+ commit 5512133de4e9bca2defb744e2b42e55b5487d72c
	* src/keylist.c (keylist_colon_handler): Check for correct number of
	fields.

2021-06-01  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add support for flags in LDAP server options.
	+ commit 27aa7c4a0fc8f7cef6219443cee0d040c2774746
	* lang/qt/src/qgpgmenewcryptoconfig.cpp (parseURL): Handle extended
	LDAP server option syntax.
	(portToString): New.
	(splitURL): Append flags to LDAP server option.

2021-05-28  Werner Koch  <wk@gnupg.org>

	tests: Improve the output of the run-keylist helper.
	+ commit 31eb45f01620d3e8811fe18460c281837bb3359f
	* tests/run-keylist.c (main): Print all infos from the primary key.

2021-05-27  NIIBE Yutaka  <gniibe@fsij.org>

	build: _DARWIN_C_SOURCE should be 1.
	+ commit 367b9e7488601cdf2cbec4d593a235c89f9a4281
	* configure.ac (*-apple-darwin*): Set _DARWIN_C_SOURCE 1.

	build: Update gpg-error.m4.
	+ commit 792a7e7f04ead7643561439b773e740549340b99
	* m4/gpg-error.m4: Update from libgpg-error.

2021-05-12  Werner Koch  <wk@gnupg.org>

	core: Allow for older compilers.
	+ commit aa98081356b5f7c9ef2422021e05aed01a7e4d46
	* tests/run-verify.c (main): Remove C99-only syntax.
	* tests/run-threaded.c (start_keylistings): Ditto.

	core: Make sure to stay ABI compatible.
	+ commit 88db69e1a964c9a36989e36fe5d972548432fb5c
	* src/gpgme.h.in (struct _gpgme_key_sig): Move trust_scope to the end
	of the struct.

2021-05-06  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Do not close stdout/stderr when destroying EditInteractor.
	+ commit 58a217b108e4c4c92306542bf9f2995254809ffb
	* lang/cpp/src/editinteractor.cpp (EditInteractor::Private): Initialize
	members 'state' and 'debug' in-class. Add member 'debugNeedsClosing'.
	(EditInteractor::Private::Private): Remove members initializers.
	Remember if 'debug' needs to be closed.
	(EditInteractor::Private::~Private): Only close 'debug' if it needs to
	be closed.

2021-05-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Extend SignKeyJob to create trust signatures.
	+ commit f0858e45b0be260730e742643e741547123d4287
	* lang/qt/src/signkeyjob.h (SignKeyJob::setTrustSignature): New.
	* lang/qt/src/qgpgmesignkeyjob.h, lang/qt/src/qgpgmesignkeyjob.cpp
	(QGpgMESignKeyJob::setTrustSignature): New.
	* lang/qt/src/qgpgmesignkeyjob.cpp (sign_key): Handle trust signatures.
	(QGpgMESignKeyJob::start): Pass trust signature attributes to sign_key.
	(QGpgMESignKeyJob::setTrustSignature): New.

	qt: Pimpl QGpgMESignKeyJob.
	+ commit dae01f8185e0f1bc9c65d93078c7ccda0b79611f
	* lang/qt/src/qgpgmesignkeyjob.h: Remove unneeded includes. Include
	<memory>.
	(QGpgMESignKeyJob): Remove all member variables. Add pimpl pointer.
	* lang/qt/src/qgpgmesignkeyjob.cpp: Include <QString>. Don't include
	<memory>.
	(QGpgMESignKeyJob::Private): New.
	(QGpgMESignKeyJob::QGpgMESignKeyJob): Remove initialization of removed
	members. Initialize d.
	(QGpgMESignKeyJob::start, QGpgMESignKeyJob::setUserIDsToSign,
	QGpgMESignKeyJob::setCheckLevel, QGpgMESignKeyJob::setExportable,
	QGpgMESignKeyJob::setSigningKey, QGpgMESignKeyJob::setNonRevocable,
	QGpgMESignKeyJob::setRemark, QGpgMESignKeyJob::setDupeOk): Adapt to move
	of member variables to pimpl.

	cpp: Add support for trust signatures to sign key edit interactor.
	+ commit a8d7b9d16796efd6f21abaeb43ccaeb2388eb6e4
	* lang/cpp/src/gpgsignkeyeditinteractor.h,
	lang/cpp/src/gpgsignkeyeditinteractor.cpp
	(GpgSignKeyEditInteractor::setTrustSignatureTrust): New.
	(GpgSignKeyEditInteractor::setTrustSignatureDepth): New.
	(GpgSignKeyEditInteractor::setTrustSignatureScope): New.
	* lang/cpp/src/gpgsignkeyeditinteractor.cpp
	(GpgSignKeyEditInteractor::Private::Private): Initialize new member.
	(makeTable): Add new transition. Fix typos in existing transitions.
	(GpgSignKeyEditInteractor::action): Handle SET_TRUST_VALUE,
	SET_TRUST_DEPTH, and SET_TRUST_REGEXP.

	cpp: Add getters for the attributes of a trust signature.
	+ commit e391a08c6f96cd2d93c49b888459ee3f42058118
	* lang/cpp/src/key.h (TrustSignatureTrust): New enum.
	* lang/cpp/src/key.h, lang/cpp/src/key.cpp
	(UserID::Signature::isTrustSignature): New.
	(UserID::Signature::trustValue): New.
	(UserID::Signature::trustDepth): New.
	(UserID::Signature::trustScope): New.

	core: Extend gpgme_key_sig_t with trust signature members.
	+ commit 276187f6b62a73e92b1c20f589510f80ab9e88d2
	* src/gpgme.h.in (struct _gpgme_key_sig): Add fields 'trust_depth',
	'trust_value', and 'trust_scope'.
	* src/key.c (gpgme_key_unref): Free trust_scope.
	* src/keylist.c (keylist_colon_handler): Set the fields.
	* tests/run-keylist.c (main): Print the fields.

2021-03-11  Werner Koch  <wk@gnupg.org>

	doc: Add MIT license notice.
	+ commit 3ffd7bd4039d90cd15fbf76f8c116814bffdab7c
	* LICENSES: New.

	core: New flag GPGME_KEYSIGN_FORCE.
	+ commit 0821e2b1495e8944a5a1b5ba20ad5f403dde0dd0
	* src/gpgme.h.in (GPGME_KEYSIGN_FORCE): New.
	* src/engine-gpg.c (gpg_keysign): Implement.

	* tests/run-keysign.c (show_usage): Add option --force

2021-03-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add method for getting config entries for components by entry name.
	+ commit fe900a41bf809b263f05d5df21b6ed7fbfb2bbbc
	* lang/qt/src/cryptoconfig.h, lang/qt/src/cryptoconfig.cpp
	(CryptoConfig::entry): Move implementation to cpp. Add overload not
	requiring a group name.

2021-02-01  Werner Koch  <wk@gnupg.org>

	core: Remove experimental feature GPGME_EXPORT_MODE_NOUID.
	+ commit c8fd8870b3bf089f99156448b7d1e59c1150f994
	* src/export.c (export_start): Remove GPGME_EXPORT_MODE_NOUID check.
	* src/engine-gpg.c (export_common): Ditto.

2021-01-08  Werner Koch  <wk@gnupg.org>

	Release 1.15.1.
	+ commit bb9880778fb16cdb6de83905e45bf6c965770013


	Make distcheck make target a bit more reliable.
	+ commit 133050b3fa28122a4b60dbbde698fb14379ccf95
	* Makefile.am (release): Do not pass --parallel

2021-01-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Make listing of signatures work if only secret keys are listed.
	+ commit 5137d7fc214d0d9dcb947ccdc32fa87979f9a6d0
	* src/engine-gpg.c (gpg_keylist_build_options): Add "--with-sig-check"
	argument if signatures shall be listed.
	* tests/gpg/t-keylist-secret-sig.c: New.
	* tests/gpg/Makefile.am (c_tests): Add new test.

2021-01-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Add const-overload of UserID::Signature::operator<
	+ commit a6220adf3081c9c848f6d0a6fc3774cb168ccf9c
	lang/cpp/src/key.h, lang/cpp/src/key.cpp (UserID::Signature::operator<):
	Add const-overload. Deprecate non-const overload.

2021-01-04  Andre Heinecke  <aheinecke@gnupg.org>

	Qt: Undeprecate QByteArray based start functs.
	+ commit 543e2106386f00ebecf7653e7896fa12a6e828ff
	* lang/qt/src/encryptjob.h, lang/qt/src/signjob.h (start):
	Undeprecate QByteArray based functions.

2020-12-03  NIIBE Yutaka  <gniibe@fsij.org>

	python: Fix key_export*.
	+ commit 7a4fe82a017b751ad756c93d2b9e31d7be045275
	* lang/python/src/core.py (key_export): Just raise an error.
	(key_export_minimal, key_export_secret): Ditto.

2020-11-24  NIIBE Yutaka  <gniibe@fsij.org>

	core: Call _gpgme_passphrase_status_handler when exporting keys.
	+ commit 53ac732bae46e1f883998e987fc84d4cababde12
	* src/export.c (export_status_handler): Call the handler.

2020-11-20  Andre Heinecke  <aheinecke@gnupg.org>

	Revert "cpp: Use portable off_t size_t"
	+ commit a5c4b030258714dd72a2e276114183309cad3ec3
	This reverts commit 88294023c196497cfa6737be262c8b0c09d2a3ce.

2020-11-20  NIIBE Yutaka  <gniibe@fsij.org>

	m4: Update with newer autoconf constructs.
	+ commit 4c6fd361593e22092770d120d68a18b4f70e0bb8
	* src/gpgme.m4: Replace AC_HELP_STRING to AS_HELP_STRING.

2020-11-18  Andre Heinecke  <aheinecke@gnupg.org>

	cpp: Use portable off_t size_t.
	+ commit 88294023c196497cfa6737be262c8b0c09d2a3ce
	* configure.ac: Configure cpp data.h.in
	* lang/cpp/src/Makefile.am: Generate data.h
	* lang/cpp/src/data.cpp, lang/cpp/src/data.h: Use portable
	types.
	* lang/qt/src/Makefile.am: Include build dir.
	* lang/qt/tests/makefile.am: Include build dir.

2020-11-18  Ingo Klöcker  <dev@ingo-kloecker.de>
	    Daniel Kahn Gillmor

	qt: Avoid empty "rem@gnupg.org" signature notations.
	+ commit 3c185c2159cdcc23f44773fe1cfb624b27598c80
	* lang/qt/src/qgpgmesignkeyjob.cpp (sign_key): Check remark for being
	an empty string instead of a null QString.

2020-11-18  NIIBE Yutaka  <gniibe@fsij.org>

	build: Update with newer autoconf constructs.
	+ commit 223779dfdeb7808809372587fa135a8cc2616ce8
	* configure.ac: Use AC_USE_SYSTEM_EXTENSIONS instead of AC_GNU_SOURCE.
	Use AS_HELP_STRING instead of AC_HELP_STRING.
	* m4/libtool.m4: Update from libgpg-error.
	* m4/gpg-error.m4: Update from libgpg-error.
	* m4/libassuan.m4: Update from libassuan.

2020-11-12  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Fix export of qDebug GpgME::Error overload.
	+ commit df5a89e6929479dc1bf301974fe7d607d024bc1f
	* lang/qt/src/debug.cpp: Include debug.h to get the export decl.

2020-11-12  Werner Koch  <wk@gnupg.org>

	build: Use ~/.gnupg-autogen.sh for the release targets.
	+ commit 27abdac25dcd4ba57e073a5de2f057830e623282
	* Makefile.am (sign-release): Use global config vars.

	Post release updates.
	+ commit 01a0d8ec1aa8543dca0986c6dcb5cabc535aae2c


	Release 1.15.0.
	+ commit feea38c89d4ceb40334f884da9ab07cc4b73e757
	* configure.ac: Bump LT versions to c=C35/A24/R0, cpp=C18/A13/R0,
	qt=C12/A5/R0.

2020-11-12  NIIBE Yutaka  <gniibe@fsij.org>
	    Louis Dupré Bertoni

	core: Support exporting secret keys.
	+ commit 3382ecb17eb5d2a373cf2eccb301854fff42f6aa
	* src/export.c (export_start): Set command handler for passphrase
	interaction for the case when it's secret keys.
	(export_ext_start): Likewise.

2020-11-12  NIIBE Yutaka  <gniibe@fsij.org>

	python: Fix a test for newer GnuPG (>= 2.3).
	+ commit 7139afc5cdc0d8203dc75d7c91fa94b704b3d64f
	* lang/python/tests/t-quick-subkey-creation.py: Specify RSA.

2020-11-11  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Add export macro for QDebug operator.
	+ commit 81f0dc7293a525af7cfbcb53cce050df718e0f91
	* lang/qt/src/debug.h: Add export macro.

2020-11-11  NIIBE Yutaka  <gniibe@fsij.org>

	qt: Allow build with older GnuPG (< 2.2.18).
	+ commit 276f3390e18b34e6211b4c75876a0ab4c10a5ac9
	* lang/qt/tests/t-remarks.cpp (initTestCase): Check gpg for
	allow-weak-key-signatures option.

2020-11-09  Werner Koch  <wk@gnupg.org>

	Require at least libgpg-error 1.36.
	+ commit eb99e8c483a70764408868602ef322602e9e72ce
	* configure.ac (NEED_GPG_ERROR_VERSION): Require 1.36.
	* src/cJSON.c: Remove code for older version.
	* src/engine.c (gpgme_get_engine_info): Ditto.
	* src/gpgme-json.c: Ditto.
	* src/op-support.c: Ditto.
	* src/util.h: Ditto.

2020-11-04  Ben Kibbey  <bjk@luxsci.net>

	Parse STATUS_CANCELED_BY_USER.
	+ commit 35ca460019ea29ae646d08c954d4d4bf2dc1e8e1
	* src/gpgme.h.in (GPGME_STATUS_CANCELED_BY_USER): New.
	* src/status-table.c (status_table_s): Add "CANCELED_BY_USER".
	* src/passphrase.c (_gpgme_passphrase_status_handler): Return
	GPG_ERR_CANCELED during GPGME_STATUS_CANCELED_BY_USER.

2020-11-03  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Make audit parameters of result signal optional.
	+ commit 0fee135997438c63ab30891ec7e662093ec57491
	lang/qt/src/quickjob.h (QuickJob::result): Make parameters
	auditLogAsHtml and audigLogError optional.

	cpp: Mark helper functions as static.
	+ commit b41f5fec1c42e0113ccbdbb7c258899793631b0a
	lang/cpp/src/key.cpp (find_subkey, verify_subkey, find_uid, verify_uid,
	find_signature, verify_signature): Mark as static.

	cpp: Make signatures belonging to the same user ID sortable.
	+ commit 6a6d2a27648490f08aaf0759a533aef08b32070d
	lang/cpp/src/key.h, lang/cpp/src/key.cpp (UserID::Signature::operator<):
	New.
	lang/cpp/src/key.cpp (signature_index): New.

2020-10-29  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add support for revoke signature quick command.
	+ commit f042739d3a2ed23a90441a81782e4c3ac6ffb1c5
	* lang/qt/src/quickjob.h (QuickJob::startRevokeSignature): New.
	* lang/qt/src/qgpgmequickjob.h, lang/qt/src/qgpgmequickjob.cpp
	(QGpgMEQuickJob::startRevokeSignature): New.
	* lang/qt/src/qgpgmequickjob.cpp (revokeSignatureWorker): New.

	qt: Some minor cleanups.
	+ commit 60328c4690beb8a82f5a3cc0d35b434e151c6365
	* lang/qt/src/qgpgmequickjob.h: (GpgME::Key, QDateTime, QString):
	Remove superfluous forward declarations.
	(QGpgMEQuickJob): Remove superfluous second template argument. It is
	identical to the default.
	(QGpgMEQuickJob::result): Remove. It is already defined in the base
	class.

	cpp: Add support for gpgme_op_revsig.
	+ commit 4166d263e421cb4f98c4ca6bef549613c35e149e
	* lang/cpp/src/context.cpp, lang/cpp/src/context.h
	(Context::revokeSignature, Context::startRevokeSignature): New.
	* lang/cpp/src/context.cpp
	(getLFSeparatedListOfStrings, getLFSeparatedListOfUserIds): New.
	(getLFSeparatedListOfFingerprintsFromSubkeys): Extracted second part
	of function to getLFSeparatedListOfStrings.

	core: New function gpgme_op_revsig.
	+ commit f3407d0ee4e34ed33be18de5f886a4da2affbf9f
	* src/gpgme.h.in (gpgme_op_revsig_start, gpgme_op_revsig): New.
	(GPGME_REVSIG_LFSEP): New.
	* src/context.h (ctx_op_data_id_t): Add OPDATA_REVSIG.
	* src/revsig.c: New.
	* src/Makefile.am (main_sources): Add revsig.
	* src/libgpgme.vers, src/gpgme.def: Add gpgme_op_revsig and
	gpgme_op_revsig_start.
	* src/engine.h, src/engine.c: (_gpgme_engine_op_revsig): New.
	* src/engine-backend.h (engine_ops): Add 'revsig' and adjust all
	engine initializers.
	* src/engine-gpg.c (gpg_revsig): New.
	(_gpgme_engine_ops_gpg): Set revsig to gpg_revsig.
	* doc/gpgme.texi: Document new functions.
	* tests/run-keysign.c: Add option --revoke.

2020-10-28  NIIBE Yutaka  <gniibe@fsij.org>

	python: Handle the when case __doc__ is None.
	+ commit 089164a0c0d6024cbb133327d47a28ca3716cd56
	* lang/python/src/core.py (GpgmeWrapper): Check if None.

2020-10-23  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Add support for gpgme_cancel.
	+ commit 74c8131d809be49d64f482961fee1e6e0dbe4f4f
	* lang/cpp/src/context.cpp, lang/cpp/context.h
	(Context::cancelPendingOperationImmediately): New.
	* NEWS: Mention added API

	Add Assuan transaction that forwards status lines to another object.
	+ commit ff23e24063feb9e1628858fd32df37be557072a6
	* lang/cpp/src/Makefile.am: Add new files.
	* lang/cpp/src/interfaces/statusconsumer.h,
	lang/cpp/src/statusconsumerassuantransaction.cpp,
	lang/cpp/src/statusconsumerassuantransaction.h: New.
	* NEWS: Mention new API.

	qt: Add QDebug stream operator for GpgME::Error.
	+ commit b21cabb311803677104fa98809bc88b21243f358
	* lang/qt/src/Makefile.am: Add new files.
	* lang/qt/src/debug.h, lang/qt/src/debug.cpp: New.
	* NEWS: Mention it.

	cpp, qt: Add missing comparison operators for version info comparison.
	+ commit c3406462d11b4241d4feee9be08e0ebe4f2e0bfa
	* lang/cpp/src/engineinfo.h (EngineInfo::Version::operator<=,
	EngineInfo::Version::operator>=, EngineInfo::Version::operator!=):
	New.
	* lang/qt/tests/t-various.cpp (TestVarious::testVersion): Add tests for
	new comparison operators.
	* NEWS: Mention added API

	cpp, qt: Fix version info comparison.
	+ commit 2f53a2f4be86c0829213e2a9f846b7f8f0b106dc
	* lang/cpp/src/engineinfo.h
	(EngineInfo::Version::operator>(const Version &)): Fix logic.
	(EngineInfo::Version::operator>(const char *)): Use Version-overload of
	operator>.

	* lang/qt/tests/t-various.cpp: Add test.

2020-10-03  Werner Koch  <wk@gnupg.org>

	tests: Fix gcc incompatibility.
	+ commit 25e2d717f44682f83c483ceba6ba81bad7fc3e97
	* tests/json/t-json.c: Remove var definitions inside a for statement.

2020-10-01  NIIBE Yutaka  <gniibe@fsij.org>

	gpgsm: Fix leaked fd.
	+ commit fd904f87f8d43ad477b9d35d834f384e917b26fd
	* src/engine-gpgsm.c (gpgsm_new): Close gpgsm->diag_cb.server_fd.

2020-09-09  Werner Koch  <wk@gnupg.org>

	core: Fully implement the inquire callback for assuan_transact.
	+ commit e4ee706e270c38937afe26ce9f54d17d037cb86f
	* src/engine-assuan.c (inquire_cb): Implement returning data.

	* tests/opassuan/t-command.c (inq_cb): Send some test data.

2020-09-08  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Update the documentation of ListAllKeysJob.
	+ commit 973c8116c840b4f1e0c3c80a7956641550c3388d
	* lang/qt/src/listallkeysjob.h (ListAllKeysJob::start): Document that
	the mergeKeys argument is ignored with gpg >= 2.1.

	cpp: Update key with --with-secret instead of updating it twice.
	+ commit 3dd7377e120f10576b3b4334b6149f027ceec126
	* lang/cpp/src/key.cpp (Key::update): Call Context::key() only once
	with KeyListMode::WithSecret.

2020-09-07  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: List keys once with --with-secret instead of twice.
	+ commit 13bcc6680ac2030d45e4f36a64864bcd6a1d42a9
	* lang/qt/src/qgpgmelistallkeysjob.cpp
	(do_list_keys): Rename to do_list_keys_legacy and put into unnamed
	namespace.
	(merge_keys): Put into unnamed namespace.
	(list_keys): Rename to list_keys_legacy and put into unnamed namespace.
	(do_list_keys, list_keys): New.
	* lang/qt/tests/t-keylist.cpp (testListAllKeysSync): New.

	cpp: Add keylist mode WithSecret.
	+ commit 188cc9e9b553998d2a8ec52bd8282365e22bf400
	* lang/cpp/src/global.h (WithSecret): New.
	* lang/cpp/src/context.cpp (operator<<): Handle WithSecret.
	* lang/cpp/src/util.h (add_to_gpgme_keylist_mode_t,
	convert_from_gpgme_keylist_mode_t): Ditto.

	cpp: Add missing keylist modes.
	+ commit b714a6bbc8038c1b226bc920dd02ce8fbae7da8a
	* lang/cpp/src/util.h
	(add_to_gpgme_keylist_mode_t): Sort modes as in enum definition and
	add missing modes to check.
	(convert_from_gpgme_keylist_mode_t): Add missing handling of
	GPGME_KEYLIST_MODE_WITH_TOFU and GPGME_KEYLIST_MODE_WITH_KEYGRIP.

2020-09-03  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Copy some more subkey properties when merging keys.
	+ commit 4d87ea2851ae1156cfb1d754cf32b5c9073d4252
	* lang/cpp/src/key.cpp (Key::mergeWith): Also merge secret flag and
	keygrip

2020-08-28  Werner Koch  <wk@gnupg.org>

	qt: Fix an rfc2253 parser flaw.
	+ commit b088d81cefe45c16409085f1560ad1d4c235a696
	* lang/qt/src/dn.cpp (parse_dn_part): Fix parser.

2020-08-14  Ingo Klöcker  <dev@ingo-kloecker.de>

	core: Add error handling to setexpire.
	+ commit f66f856c89b7c02e368afe2343de7cce50e6109e
	* src/genkey.c (setexpire, gpgme_op_setexpire_start,
	gpgme_op_setexpire): Move to ...
	* src/setexpire.c: New.
	* src/Makefile.am (main_sources): Add that file.
	* src/context.h (ctx_op_data_id_t): Add OPDATA_SETEXPIRE.

	* lang/qt/tests/t-various.cpp (testSetExpire): Test error handling.

2020-08-11  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Support changing expiry of subkeys.
	+ commit 4f2cd3a0c6a8f3633040ff0e8cca787b2bd61fb2
	* lang/qt/src/changeexpiryjob.h (ChangeExpiryJob::start): New overload
	that accepts subkeys (with empty implementation).
	* lang/qt/src/qgpgmechangeexpiryjob.h,
	lang/qt/src/qgpgmechangeexpiryjob.cpp (QGpgMEChangeExpiryJob::start):
	New overload that accepts subkeys.

2020-08-10  Ingo Klöcker  <dev@ingo-kloecker.de>

	cpp: Make private helper a file static.
	+ commit c813734c9ce0a77f5a9d463a6b16074e522cc2ce
	* lang/cpp/src/context.h, lang/cpp/src/context.cpp
	(Context::getLFSeparatedListOfFingerprintsFromSubkeys): Remove
	from Context; make it a static function instead

2020-08-06  Andre Heinecke  <aheinecke@gnupg.org>

	cpp: Use cstdlib getenv for portability.
	+ commit 0676d41ef57db4da469aa9b733f8965606b667ec
	* lang/cpp/src/editinteractor.cpp (EditInteractor::Private::Private):
	Use std::getenv.

2020-08-05  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Port to new setExpire()
	+ commit 89501509134ab9cff87219fcaee9c1a758efa2fe
	* lang/qt/src/qgpgmechangeexpiryjob.cpp (change_expiry): Use new
	setExpire() instead of edit() with GpgSetExpiryTimeEditInteractor

2020-08-04  Ingo Klöcker  <dev@ingo-kloecker.de>

	qt: Add test for setExpire.
	+ commit 84c6b6e2fea1176991bd89ac421af492d4550d6e
	* lang/qt/tests/t-various.cpp (TestVarious::testSetExpire): New.

	cpp: Add support for gpgme_op_setexpire.
	+ commit aa03205fe5e8a8fa2b0feecb8a142aff2a1b25df
	* lang/cpp/src/context.cpp
	(Context::setExpire, Context::startSetExpire): New.
	(Context::getLFSeparatedListOfFingerprintsFromSubkeys):
	New helper.
	* lang/cpp/src/context.h
	(Context::SetExpireFlags): New enum.
	(Context::setExpire, Context::startSetExpire): Add
	prototypes.
	(Context::getLFSeparatedListOfFingerprintsFromSubkeys):
	Add as private helper.

	cpp: Add ostream operator for subkey.
	+ commit 197ba151e70c0aef35ee713b119d49e4637c1d05
	* lang/cpp/src/key.cpp (Subkey): Add ostream operator.
	* lang/cpp/src/key.h: Update accordingly.

2020-08-04  Ingo Klöcker  <dev@ingo-kloecker.de>
	    Andre Heinecke  <aheinecke@gnupg.org>

	core: New function gpgme_op_setexpire.
	+ commit db82e99a8a40c57a237dad030928d0fcf6b03ad7
	* src/gpgme.h.in (gpgme_op_setexpire_start, gpgme_op_setexpire): New.
	* src/libgpgme.vers, src/gpgme.def: Add new functions.
	* src/genkey.c (setexpire): New.
	(gpgme_op_setexpire_start, gpgme_op_setexpire): New.
	* src/engine.h, src/engine.c: (_gpgme_engine_op_setexpire): New.
	* src/engine-backend.h (engine_ops): Add 'setexpire' and adjust all
	engine initializers.
	* src/engine-gpg.c (gpg_setexpire): New.
	(_gpgme_engine_ops_gpg): Set setexpire to gpg_setexpire.
	* doc/gpgme.texi: Document new functions.
	* tests/run-genkey.c: Add option --setexpire.

2020-07-16  Werner Koch  <wk@gnupg.org>

	Release 1.14.0.
	+ commit 6d7bf78ca5af35b0860aa20b12f799ab03752190
	* configure.ac: Bump LT versions to c=C34/A23/R0 cpp=C17/A11/R0
	qt=C11/A4/R0.

2020-07-16  Andre Heinecke  <aheinecke@gnupg.org>

	qt, cpp: Support export modes.
	+ commit 690d967196d9f888e2b7c12d8c77ad752d7e15bf
	* lang/cpp/context.cpp, lang/cpp/context.h
	(Context::startPublicKeyExport, Context::exportPublicKeys): Extend
	with flags paramenter.
	(Context::ExportMode): New.
	* lang/qt/src/exportjob.h (ExportJob::setExportMode): New.
	* lang/qt/src/qgpgmeexportjob.cpp, lang/qt/src/qgpgmeexportjob.h:
	Update accordingly.

2020-07-16  Werner Koch  <wk@gnupg.org>

	core: Also allow GPGME_EXPORT_MODE_SSH for gpgme_op_export.
	+ commit dfeedcc28d0406f5ad8ff8ad397e1ef930676535
	* src/export.c (export_start): Allow that mode.

	core: New export mode to export as OpenSSH public key.
	+ commit 7f9e0ca57b29cc96bd1ca717d891c11db7435c5a
	* src/gpgme.h.in (GPGME_EXPORT_MODE_SSH): New.
	* src/export.c (export_ext_start): Allow for new mode.
	* src/engine-gpg.c (export_common): Implement.
	* tests/run-export.c (status_cb): New.
	(main): New options --status and --ssh.

2020-07-15  Werner Koch  <wk@gnupg.org>

	core: Deprecate the non-working trustlist functions.
	+ commit 858909168298e8c6fb6f9f9009be2ee2d0d9f0ec
	* src/gpgme.h.in: Clarify that the trustlist function should not be
	used.
	* src/engine.c (_gpgme_engine_op_trustlist): Always return an error.
	* src/engine-backend.h (struct engine_ops): Remove trustlist member.
	* src/engine-gpg.c (gpg_trustlist): Remove.
	(struct engine_ops): Remove that member.  Also in all other engines.
	* tests/gpg/t-trustlist.c: Remove.
	* lang/python/tests/t-trustlist.py: Remove.

	core: New keylist mode GPGME_KEYLIST_MODE_WITH_KEYGRIP.
	+ commit c8048bf8eb988f22b20215197f4739bedafc4264
	* src/gpgme.h.in (GPGME_KEYLIST_MODE_WITH_KEYGRIP): New.
	* src/gpgme-json.c (op_keylist): New flag "keygrip".
	* src/engine-gpg.c (gpg_keylist_build_options): Pass the options.

	* lang/cpp/src/global.h (WithKeygrip): New.
	* lang/cpp/src/context.cpp: Add check.
	* lang/cpp/src/key.cpp (Key::update): Handle WithKeygrip.
	* lang/cpp/src/verificationresult.cpp: Ditto.
	* lang/cpp/src/util.h (add_to_gpgme_keylist_mode_t): Ditto.

2020-07-14  Werner Koch  <wk@gnupg.org>

	python: Workaround for a regression in GnuPG 2.2.21.
	+ commit 32b80cf3c7d278ddf27117617a3e95e4a12c28c8
	* lang/python/tests/support.py (is_gpg_version): New.
	* lang/python/tests/t-encrypt-sym.py: Add workaround.

2020-06-09  Andre Heinecke  <aheinecke@gnupg.org>

	doc: Explain verify_result_t.status == 0 more.
	+ commit 88f3202521d422d94bfd79e61bde00707d6f28c9
	* doc/gpgme.texi (gpgme_verify_result_t): Explain
	GPGME_STATUS_NO_ERROR more clearly.

2020-06-05  Werner Koch  <wk@gnupg.org>

	core: Fix setting of the chain_model signature result.
	+ commit 728ead8ebd426307c6b3f1e3794b3a7ab585eebd
	* src/verify.c (parse_trust): Fix detection of "chain" keyword.

2020-05-11  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Remove/change tests for GnuPG 2.3 with no gpg.keyserver.
	+ commit 0cc040e82f9943792a58e73dbc97e20d312858fb
	* lang/qt/tests/t-config.cpp (testKeyserver): Remove.
	* tests/gpg/t-gpgconf.c (main): Test with dirmngr.keyserver.

2020-05-08  Andre Heinecke  <aheinecke@gnupg.org>

	w32: Explicitly link ws2_32.
	+ commit 52f930c1ed7eee6336a41598c90ef3605b7ed02b
	* src/Makefile.am (gpgme_w32_extra_libs): New.
	(libgpgme_la_LIBADD, libgpgme_glib_la_LIBADD): Use it.

2020-05-08  dupgit  <olivier.delhomme@free.fr>

	GPGME_CREATE_NOEXPIRE is only available since 1.9.0.
	+ commit 49c13854f3bf49bc0bf18c6ae6bbf9d66b6625c2
	 * doc/gpgme.texi: Fixes version number from 1.8.0 to
	   1.9.0 for GPGME_CREATE_NOEXPIRE.

	GnuPG-Bug-Id: T4922

2020-05-08  Werner Koch  <wk@gnupg.org>

	core: Make sure the keygrip is available in WITH_SECRET mode.
	+ commit 004fdf61c8b94f646409f4d5855adf8e43b29627
	* src/engine-gpg.c (gpg_keylist_build_options): Send --with-keygrip
	if --with-secret is used.

2020-05-08  Andre Heinecke  <aheinecke@gnupg.org>

	tests, json: Do not check for keygrip of pubkeys.
	+ commit 5c0d1c7f76c95bad8bce4ad3bafd121ec5101d3c
	* tests/json/t-keylist-secret.out.json: Do not check for keygrip
	of bravo key.

2020-03-27  NIIBE Yutaka  <gniibe@fsij.org>

	tests: Add ECC key generation for tests/gpgsm.
	+ commit 3658e2df65d321e334a8c96b4d252a4be20354bd
	* tests/gpgsm/t-genkey.c (check_result): New.

	build: Fix library dependency.
	+ commit 71ef398bfd72d505290376d82575eb4f3aece035
	* src/Makefile.am (gpgme_tool_LDADD): Add @GPG_ERROR_LIBS@.

2020-03-17  Werner Koch  <wk@gnupg.org>

	core: New context flags "include-key-block" and "auto-key-import".
	+ commit 3afa534645e3826c95e7c70d7ae61ffa2d63acec
	* src/gpgme.c (gpgme_set_ctx_flag): Add flags "include-key-block" and
	"auto-key-import".
	(gpgme_get_ctx_flag): Ditto.
	* src/context.h (struct gpgme_context): Add flags include_key_block
	and auto_key_import.
	* src/engine-gpg.c (struct engine_gpg): Likewise.
	(gpg_set_engine_flags): Set the flags for gpg versions >= 2.2.20.
	(gpg_decrypt): Set option according to the new flags.
	(gpg_encrypt): Ditto.
	(gpg_encrypt_sign): Ditto.
	(gpg_sign): Ditto.
	(gpg_verify): Ditto.

	tests/run-verify: Add option --auto-key-import.
	tests/run-sign: add option --include-key-block.

2020-03-03  Bernhard Reiter  <bernhard@intevation.de>

	python: fix minor typo in howto.
	+ commit 11edc073a3d2bf72e49827e97349cb364612f300


2020-02-19  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Change logging category.
	+ commit ec9690cf5ce85f43997ac2a3abd3e728012aee4a
	* lang/qt/src/*: Change logging category to macro to QGPGME_LOG.

	qt: Log execution args of gpg-card.
	+ commit ba08aadfa7d254f459f51470a7331c6cc2de5199
	* lang/qt/src/qgpgmegpgcardjob.cpp (do_work): Log call.

2020-02-12  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Add dummy context to make mixin happy.
	+ commit 9ca679c15054fbc1cc20e428a6ddf6a67dd0491e
	* lang/qt/qgpgmegpgcardjob.cpp (QGpgMEGpgCardJob): Add context.

	qt: Add GpgCardJob following the job pattern.
	+ commit 77feaa451074741c2d07051915bc23d8b8377242
	* lang/qt/src/Makefile.am: Add new files.
	* lang/qt/src/job.cpp (GpgCardJob): Add impl stuff.
	* lang/qt/src/protocol.h (gpgCardJob): Get one.
	* lang/qt/src/qgpgmebackend.cpp,
	lang/qt/src/qgpgmebackend.h: Add helpers to get the job.
	* lang/qt/src/qgpgmegpgcardjob.cpp,
	lang/qt/src/gpgcardjob.h,
	lang/qt/src/qgpgmegpgcardjob.h: New.

2020-01-29  Andre Heinecke  <aheinecke@gnupg.org>

	Do not test for a bug in older GnuPG versions.
	+ commit cff600f1f65a2164ab25ff2b039cba008776ce62
	* tests/json/t-keylist-secret.out.json

2020-01-24  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	m4/python: Scan for python 3.8 as well.
	+ commit 414938cfedbdb97b83d00e8619dec9502096be22
	* m4/python.m4: Scan for python 3.8 as well.

2020-01-17  Andre Heinecke  <aheinecke@gnupg.org>

	core: Add MacOS fallbacks to look for binaries.
	+ commit 39052913f2154fa8e9575727e27d4101ef8b6460
	* src/posix-util.c (find_executable): New.
	(walk_path_str): Factored out from walk_path.
	(walk_path): Replaced by find_executable.
	(_gpgme_get_gpg_path, _gpgme_get_gpgconf_path): Use find_executable.

2019-12-13  Andre Heinecke  <aheinecke@gnupg.org>

	cpp, qt: Use uidhash to select uids for signing.
	+ commit 194272dbc3e326cc32c1464bc6fda0c0d10b5559
	* lang/cpp/src/gpgsignkeyeditinteractor.cpp (action):
	Use uidhash instead of number.
	(GpgSignKeyEditInteractor::setKey): New.
	* lang/cpp/src/gpgsignkeyeditinteractor.h: Update accordingly.
	* lang/cpp/src/key.h, lang/cpp/src/key.cpp: Wrap uidhash.
	* lang/qt/src/qgpgmesignkeyjob.cpp: Set the key.

2019-12-13  Werner Koch  <wk@gnupg.org>

	core: Extend gpgme_user_id_t with uidhash member.
	+ commit 5eeae535ee0df981d8ae8b758b5bb0d190c7fd89
	* src/gpgme.h.in (struct _gpgme_user_id): Add field 'uidhash'.
	* src/key.c (gpgme_key_unref): Free it.
	* src/keylist.c (keylist_colon_handler): Set it.
	* tests/run-keylist.c (main): Print it.

2019-12-11  Andre Heinecke  <aheinecke@gnupg.org>

	Revert "doc: Remove UI Server documentation"
	+ commit 7e7eaf43424556c3c25edc7b67e760ab60de55ce
	This reverts commit 1b2ad3b73c37d0583b8e438b4707dca60e26ae7e.

2019-12-06  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	gpg: Avoid error diagnostics with --override-session-key when verifying.
	+ commit ae4d7761a15b82eb98b0bcc72af2ae2e8973e1f9
	* src/engine-gpg.c (gpg_decrypt): only send --no-keyring when we are
	not verifying.

2019-12-04  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	gpgme-tool: Fix help text for INCLUDE_CERTS.
	+ commit c0c97dbbe6e08d338ba56abec023bd57287e3239
	* src/gpgme-tool.c (hlp_include_certs): added missing newline.

2019-11-27  Werner Koch  <wk@gnupg.org>

	core,w32: Silence compiler warnings.
	+ commit d480a3c8f3a3fff867b84fd8feca9f111ae4adc7
	* src/w32-util.c (_gpgme_w32_cancel_synchronous_io): Add some casts.

2019-11-12  Andre Heinecke  <aheinecke@gnupg.org>

	doc: Remove UI Server documentation.
	+ commit 1b2ad3b73c37d0583b8e438b4707dca60e26ae7e
	* doc/Makefile.am: Remove uiserver.texi
	* doc/gpgme.texi: Remove UI-Server mentions.
	* doc/uiserver.texi: Removed.

2019-11-08  NIIBE Yutaka  <gniibe@fsij.org>

	qt,tests: Take care for old DSA key using deprecated digest algo.
	+ commit c49324200734e8ee8524bc096195e24e8aae87cb
	* lang/qt/tests/t-remarks.cpp (initTestCase): Supply
	allow-weak-key-signatures flag for GnuPG 2.3, which
	normally rejects use of SHA1 digest.

2019-11-06  Andre Heinecke  <aheinecke@gnupg.org>

	qt, tests: Add check for supported versions.
	+ commit e7b5c6405da515101f62acce2837e6c0cc115b76
	* lang/qt/tests/t-encrypt.cpp (decryptSupported): Moved to
	t-support as loopbackSupported.
	* lang/qt/tests/t-remarks.cpp: Check for loopbackSupported.
	* lang/qt/tests/t-support.cpp, lang/qt/tests/t-support.h
	(loopbackSupported): New.

	qt, tests: Replace accidentally commited assert.
	+ commit 024edbbd3c0059654e13c1c6acf78456450469ab
	* lang/qt/test/t-remarks.cpp (testRemarkReplaceSingleUIDExportable):
	Use QVERIFY instead of assert.

	qt,tests: Add test to add an exportable certify.
	+ commit a56f6015e9518180237a70b8abc5ab9804212986
	* lang/qt/test/t-remarks.cpp (testRemarkReplaceSingleUIDExportable):
	New.

2019-11-06  NIIBE Yutaka  <gniibe@fsij.org>

	python: Fix how to generate documentation.
	+ commit 1b840a151ad7f9680ec5144da5efb0ee6c1dcf1f
	* lang/python/doc/Makefile.am: Explicitly write rules to generate rst
	and texinfo files.

2019-11-04  Andre Heinecke  <aheinecke@gnupg.org>

	qt, tests: Add testcase for multiple remarsk.
	+ commit 9cf4db1e5271ae1dd6f7ecb11513203cec368bc6
	* lang/qt/tests/t-remarks.cpp (testMultipleRemarks): New.

	cpp: Add API to obtain mutliple remarks.
	+ commit cb7668caeb71429afce1aded9128334182b233e1
	* lang/cpp/src/key.cpp, lang/cpp/src/key.h (UserID::remarks): New.
	* NEWS: Mention this.

	qt,tests: Move remarks test out and extend it.
	+ commit db888b1cc05723423a3154fe89e6191812c9c869
	* lang/qt/tests/t-various.cpp (testRemarks): Move out.
	* lang/qt/tests/t-remarks.cpp: New.
	* lang/qt/tests/Makefile.am: Update accordingly.

	cpp: Fix dupe_ok state for single uid.
	+ commit 08933c183a4c299eb4696092d6d229f607fce985
	* lang/cpp/src/gpgsignkeyeditinteractor.cpp (makeTable):
	Add transition from command to dupe_ok

2019-11-01  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Allow adding empty remarks.
	+ commit d61491dd25d86a2bee54e4be29b715d97840be67
	* lang/qt/src/qgpgmesignkeyjob.cpp (sign_key): Allow empty
	remarks.

	cpp: Minor optimization in remark lookup.
	+ commit 174caaa6f53e1125724a47dad3a5c991298aee6d
	* lang/cpp/src/key.cpp (UserID::remark): Use C-API.

	cpp: Fix adding duplicated sigs on multiple uids.
	+ commit 266e05eee859b83d97079c2fbbd2f1da010fa412
	* lang/cpp/src/gpgsignkeyeditinteractor.cpp: Add another
	state DUPE_OK2 to allow gpg looping over all uids.

	cpp: Add env var to control editinteractor debug.
	+ commit a4d5394b4607382d846e8c156439ac182f9945d7
	* lang/cpp/src/editinteractor.cpp (EditInteractor::Private::Private):
	Read "GPGMEPP_INTERACTOR_DEBUG" env var.
	(EditInteractor::Private::~Private): Close debug file.

2019-10-29  Andre Heinecke  <aheinecke@gnupg.org>

	core: Fix parsing of userid sigs after a subpkg.
	+ commit 1242c6c93ac63383f648dd84cff847b86f4925f9
	* src/keylist.c (keylist_colon_handler): Do not clear
	out the tmp_uid when a subpacket line is encountered.

	qt,tests: Add test for remarks.
	+ commit 1f3ca698f16465761649d402b999f0e2c9184344
	* lang/qt/tests/t-various.cpp (testRemark): New.

	qt: Extend signkeyjob to handle remarks and dups.
	+ commit 373acd6923f2fc968fb870d2a8a9b49398cb652f
	* lang/qt/src/qgpgmesignkeyjob.cpp: Handle remarks and
	dupeOK.
	* lang/qt/src/signkeyjob.h (SignKeyJob::setDupeOk),
	(SignKeyJob::setRemark): New.

	cpp: Add support for multiple keysigs in edit.
	+ commit 36f7f7a478228a64d3d51a4901a264c8f55f90bb
	* lang/cpp/src/gpgsignkeyeditinteractor.cpp
	(GpgSignKeyEditInteractor::setDupeOk): New.
	(makeTable): Add new tansitions.
	(SignKeyState): Add DUPE_OK Status.
	(GpgSignKeyEditInteractor::action): Handle DUPE_OK.
	(GpgSignKeyEditInteractor::Private::Private): Carry flag.

	cpp: Add convenience API to obtain remarks.
	+ commit 83ecf1686a9a4e7de3a7b176cf272d9f9f640445
	* lang/cpp/src/key.h, lang/cpp/src/key.cpp (UserID::remark): New.

	core: Add cert-notation support and extended-edit.
	+ commit 0224408c6332648461bdbba562f1a61c947c8ed3
	* src/context.h (gpgme_context): Add new flag for extended-edit.
	* src/engine-gpg.c (append_args_from_sig_notations): Add flags to
	control the kind of notations.
	(gpg_edit): Respect extended-edit and notations.
	(gpg_encrypt_sign, gpg_sign): Update call to
	append_args_from_sig_notations.
	* src/gpgme.c (gpgme_set_ctx_flag, gpgme_get_ctx_flag): Support
	extended-edit.
	* NEWS, doc/gpgme.texi: Mention extended-edit.

2019-10-28  Andre Heinecke  <aheinecke@gnupg.org>

	core,w32: Initialize dbg_help for socket debugging.
	+ commit fe2892618c20cd40c342cce26ffb6ac4644fd3c3
	* src/w32-io.c (_gpgme_io_select): Initialize dbg_help.

2019-08-06  NIIBE Yutaka  <gniibe@fsij.org>

	json: Fix t-decrypt-verify.out for GnuPG >= 2.3.
	+ commit b97434fbf087f3176daf39699ff579d38d265317
	* tests/json/t-decrypt-verify.out.json: Remove check with key of
	04071FB807287134.

2019-07-16  Andre Heinecke  <aheinecke@gnupg.org>

	core: Fix arg counting in enginge-gpg.
	+ commit 6f4a886b30caaac3a30fcf30a7525d656d7e25ce
	* src/engine-gpg.c (build_argv): Properly check for all
	arguments and allocate memory for them.

2019-07-12  NIIBE Yutaka  <gniibe@fsij.org>

	python: doc: Remove generated files, put rules in Makefile.
	+ commit 36428d8cf153a33faac6a951752cdc76e23f9737
	* lang/python/doc/Makefile.am (EXTRA_DIST): Remove files not
	distributed like files under meta.
	* Add rules to generate .rst and .texi files.
	* lang/python/doc/rst: Remove .rst files to be generated.
	* lang/python/doc/texinfo: Remove .texi files to be generated.

	python: doc: Add suffix for org files.
	+ commit d9387650ffb159bbd04db74c4a1dba6f94e83116


2019-06-13  Werner Koch  <wk@gnupg.org>

	Release 1.13.1.
	+ commit ea11c2a13cd44caf0bab395bd5132bf232318ad8
	* configure.ac: Bump LT versions to c=C33/A22/R1 cpp=C16/A10/R0
	qt=C10/A3/R4.

	python: Fix regression in t-decrypt-verify test.
	+ commit 7d0a979c07d2a32c1e39a9403f009cbe026f77ff
	* lang/python/tests/t-decrypt-verify.py: Comment recent changes.

	python: Set a default-key into gpg.conf for the tests.
	+ commit ad1395f210f3a3d5839f482f1933eac80a94d174
	* lang/python/tests/Makefile.am (gpg.conf): Set a default key.

	core: At debug levels up to 9 print only an ascii dump.
	+ commit 4f11210b21a1914a1daf67474e9b82084b2cac01
	* src/debug.c (_gpgme_debug_buffer): Switch between two output
	formats.

2019-06-06  Werner Koch  <wk@gnupg.org>

	tests: Minor fix to run-threaded.c.
	+ commit f6fd90c99aea8b604d76ae49d29bc5269c236a98
	* tests/run-threaded.c (random_data_close): Correct FD test.

	core: Add commented debug helper to posix-io.c.
	+ commit f84abcad253ace782708c05760e52793814896f4
	* src/posix-io.c (_gpgme_is_fd_valid): New out-commented function.

	core: Fix error return value of _gpgme_run_io_cb.
	+ commit 6b9ff1ba391a4364b37cb116748194f3f33b4f12
	* src/wait.c (_gpgme_run_io_cb): Fix return code.

2019-06-06  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Add option "allow-del" to run-threaded.
	+ commit e6f28273062ff26344163e219c1b784ae99de980
	* tests/run-threaded.c (main): Handle allow-del.
	(allow-del): New. Variable to allow deletion of keys.
	(import): Delete key after import if allow-del is set.
	(delete_impres): Delete keys from an import result.
	(delete_fpr): Delete a key by fingerprint.

2019-06-05  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Implement import in run-threaded.
	+ commit 024a7f75d4b8e017b92a13552b23e7fb1d22a5ce
	* tests/run-threaded.c (import): New.
	(do_data_op): Call it.

2019-06-05  Werner Koch  <wk@gnupg.org>

	core: Prettify _gpgme_io_select debug output again and fix TRACE_SYSRES.
	+ commit 0f68c9f16bdae7295cac4cbf3c9a197840989a85
	* src/debug.c (_gpgme_debug): Take better care of NULL userinfo.
	(_gpgme_debug_end): Rework.
	(_trace_sysres): Print ERRNO and not the supplied RES.

2019-06-05  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Use synced output for error in run-threaded.
	+ commit 3a3648e3a56712261bda4fa866bd2419a740cec8
	* tests/run-threaded.c (do_data_op): Use synced out macro.

	tests: Avoid variable named the same as a macro.
	+ commit 3a11421d0f63b8cb5afa407cd65f763b11033241
	* tests/run-threaded.c (decrypt, verify): Don't use a variable name
	that is also a macro.

	tests,w32: Fix thread creation in run-threaded.
	+ commit 9bbe15ebbc41533fa219d5b3017a26a75bc72731
	* tests/run-threaded.c (create_thread): Check proper return
	value and not return value of CloseHandle.

2019-06-05  Werner Koch  <wk@gnupg.org>

	core: Improve the debug messages even more.
	+ commit 8f9f3224aac78ce9d54e19e73acf7ab659787168
	* src/debug.c (_gpgme_debug): Add arg LINE.  Chnage all callers.
	(_gpgme_debug_begin): Remove.
	* src/debug.h (TRACE_SEQ): Use the LINE arg of _gpgme_debug.

	core: Avoid explicit locks in the debug code.
	+ commit 856d2e8d64f668855b1c22d3d38fe783904c6c48
	* src/debug.c (debug_lock): Remove.  Also remove all users.
	(_gpgme_debug): Use gpgrt_bsprintf to prepare the output and finally
	print using standard fprintf.  Reformat to prefix to be narrower.

2019-06-04  Werner Koch  <wk@gnupg.org>

	json: Print "nan", "-inf", "inf" if needed.
	+ commit f56c996318dfa1c9f0d10582b18c2fce10d24668
	* src/cJSON.c (print_number): Print NaN and INF.

	json: Improve handling of large exponents in the JSON parsor.
	+ commit fabe96126b4ed9c5e07b713813d7db26a02e5e5f
	* src/cJSON.c: Include stdint.h.
	(parse_number): Avoid overflob in SUBSCALE and cap integer values.

	core: Implement recpstring option parsing for gpgsm.
	+ commit 1024884e07f750ce781fa74dffa62e126bdda622
	* src/engine-gpg.c (append_args_from_recipients_string): Detect bad
	options.
	* src/engine-gpgsm.c (set_recipients_from_string): Implement option
	parsing.

	core: Make gpgme_op_encrypt_ext work for CMS.
	+ commit e9ca36f876e1066227668981f5a9e1a7f1031d9e
	* src/engine-gpgsm.c (gpgsm_encrypt): Fix argument check.

2019-06-04  NIIBE Yutaka  <gniibe@fsij.org>

	python: Fix typo in DecryptionError exception.
	+ commit 47135ffdb923de66bc275a37e31811ad22c73dd7
	* lang/python/src/errors.py (DecryptionError): Rename from
	DeryptionError.
	(UnsupportedAlgorithm): Use DecryptionError.

2019-06-03  Andre Heinecke  <aheinecke@gnupg.org>

	Add NEWS for 1.13.1.
	+ commit 49883023f661a18d73f9f2c7a3a98902af62ef6b
	* NEWS: Add news for 1.13.1

2019-05-06  Andre Heinecke  <aheinecke@gnupg.org>

	python: Make EXTRA_DIST files explicit.
	+ commit f9c923bb2d87711235312e8085964372d7480ce4
	* configure.ac: Configure new Makefiles.
	* lang/python/Makefile.am: Remove dirs from extra dist and use
	subdirs.
	* lang/python/examples/Makefile.am, lang/python/src/Makefile.am,
	lang/python/doc/Makefile.am: New. Files that list EXTRA_DIST files.

	Python, doc: Minor style improvement.
	+ commit 63055f13407760c877e5a3a94e564dfb3077dd47
	* lang/python/src/core.py (Context): Retab and shorten
	max line length.

	Merge remote-tracking branch 'origin/dkg/fix-T4276'
	+ commit f303806a110a9813023a5fd9468a55ab0f7fb39d


2019-05-03  Andre Heinecke  <aheinecke@gnupg.org>

	Always use maintainer mode -Wno cflags.
	+ commit 33b13d1c290d7ce35c636cce4265b512fb8e64c3
	* configure.ac (CFLAGS): Move -Wno flags out of the maintainer mode.

	cpp: Fix initialization warning.
	+ commit 0ed81498147723f0e9282df5ae08b8b8e40edd2f
	* lanc/cpp/src/gpggencardkeyinteractor.cpp
	(GpgGenCardKeyInteractor::Private): Fix initialization warning.

2019-05-03  Daniel Kahn Gillmor  <dkg@fifthhorseman.net>

	python: stop raising BadSignatures from decrypt(verify=True)
	+ commit 4100794e305ba22241ea5a4f7b42bb5189fbd948
	* src/core.py (decrypt): filter out signatures with errors from the
	returned verify_result, but avoid raising BadSignatures
	* tests/t-decrypt-verify.py: ensure that only a single signature is
	returned when evaluating cipher-3.asc, since the other signature is
	unknown.

	python/tests: try to decrypt and verify new test data.
	+ commit bd2d282e572b5d02669238c9e087259b85638477
	* lang/python/tests/t-decrypt.py: test decryption of cipher-3.asc and
	cipher-no-sig.asc
	* lang/python/tests/t-decrypt-verify.py: test decryption and
	verification of cipher-3.asc and cipher-no-sig.asc

	tests: add two new types of encrypted data.
	+ commit c5c3a9d10be415ea7bc0cd9730ad6085f16ee7a0
	* tests/gpg/cipher-3.asc: add an encrypted file containing signatures
	(one from a known key, and one from an unknown key)
	* tests/gpg/cipher-no-sig.asc: add an encrypted file containing no
	signatures at all

	python: make it easier to run a limited number of tests.
	+ commit 30bd1c097544376f257d426d5feb4706fb5d3afd
	* lang/python/tests/Makefile.am: prefer py_tests from the environment
	if present.

2019-05-02  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Add cms mode to run-import.
	+ commit 4746c5c9e2dd9a3ee471a429c19bc1f7fd1d07db
	* tests/run-import.c (show_usage): Add doc for cms / openpgp.
	(main): Handle protocol.

2019-04-24  Andre Heinecke  <aheinecke@gnupg.org>

	cpp: Add wrapper for gpgme_set_global_flag.
	+ commit 7981ec4147f3058d5b56905903456247993dc6f7
	* lang/cpp/src/context.cpp (setGlobalFlag): New.
	* lang/cpp/src/global.h (setGlobalFlag): Export it.

2019-04-19  NIIBE Yutaka  <gniibe@fsij.org>

	core: Fix duplication of close_notify_handler for gpgsm.
	+ commit 7673ef7953482f42cab50dca1810e5c9d10f461e
	* src/engine-gpgsm.c [!USE_DESCRIPTOR_PASSING] (gpgsm_new): Remove
	last call to _gpgme_io_set_close_notify.

	core: Fix error return.
	+ commit 814f6c8de8006830f19a029a879bd92f9e584789
	* src/engine.c (_gpgme_set_engine_info): Add error return.

2019-04-09  Andre Heinecke  <aheinecke@gnupg.org>

	core,w32: Fix minor potential memleak.
	+ commit 140d694e1fddf16fa3fd2371b9a852ebb14622c8
	* src/w32-util.c (_gpgme_create_process_utf8): Free converted
	startup info strings.

	core,w32: Fix new w32-util functions.
	+ commit ecbba12b869106ba03e10b7b7dd80f74d086831b
	* src/w32-util.c (_gpgme_access): Respect mode parameter.
	(_gpgme_create_process_utf8): Convert startupinfo, too.

	core,w32: Improve handling of Unicode paths.
	+ commit a82e3a0ae57a48ba173e282a050680751006c074
	* src/dirinfo.c (get_gpgconf_item): Use _gpgme_access.
	* src/posix-util.c (_gpgme_access): Add forward to normal access.
	* src/sys-util.h (_gpgme_access): New for posix and w32.
	* src/w32-io.c (_gpgme_io_spawn): Use _gpgme_crate_process_utf8.
	* src/w32-util.c (utf8_to_wchar, utf8_to_wchar0): The usual w32 conv.
	(find_program_in_dir): Use _gpgme_access.
	(find_program_at_standard_place): Use wchar API and convert to UTF-8.
	(_gpgme_access): Convert UTF-8 to wchar and use wchar API.
	(_gpgme_create_process_utf8): Convert UTF-8 to wchar and use wchar API.

	core,w32: Show w32-spawn warning only once.
	+ commit 937adfdcbb22f715c5a331e5e2d4546ac15a1b7e
	* src/w32-io.c (_gpgme_io_spawn): Show MessageBox only once.

2019-03-27  Andre Heinecke  <aheinecke@gnupg.org>

	core, w32: Fix format string errors on windows.
	+ commit 4a4680f8901ecdcb7e8d5ed55f48226ccfccd7c8
	* src/debug.c (_gpgme_debug): Use gpgrt_vasprintf instead of
	vfprintf to have a more portable format.

	core: Fix assuan logger-fd hack for windows.
	+ commit 19a4c4daa2cfd075b181d5131a4b8b4d54714b8c
	* src/assuan-support.c (my_spawn): Zero is a perfectly fine fd.

2019-03-26  Andre Heinecke  <aheinecke@gnupg.org>

	core,w32,glib: Fix build of w32-glib-io.c.
	+ commit 213c4bc1eb1f45695cc3955cc722ebb363dcbdd0
	* src/w32-glib-io.c (_gpgme_io_pipe, _gpgme_io_connect): Do not
	use TRACE_SUC in a return statement.

2019-03-26  Werner Koch  <wk@gnupg.org>

	Release GPGME 1.13.0.
	+ commit 1b5a6bf27ac9b2e5a1fc4d5e879bd4901fcad5bb
	* configure.ac: Bump LT versions.
	                For C to C33/A22/R0.
	                For C++ to C15/A9/R0.
	                For Qt to C10/A3/R3.

2019-03-26  Andre Heinecke  <aheinecke@gnupg.org>

	core: Fix a strtoul to strtol.
	+ commit 10576dc427b3746e2c3b9bc40efe618a3bd40519
	* src/assuan-support.c (my_spawn): Fix using strtoul for
	a long.

	cpp: Fix GenCardKeyInteractor and extend it.
	+ commit ffdb75217bc09561cf651dab15cd26e0024d89a7
	* NEWS: Mention interface change.
	* lang/cpp/src/gpggencardkeyinteractor.cpp
	(GpgGenCardKeyInteractor::setAlgo): New.
	(GpgGenCardKeyInteractor::action),
	(GpgGenCardKeyInteractor::nextState: Handle new interface.

2019-03-25  Andre Heinecke  <aheinecke@gnupg.org>

	core, w32: Add hack to translate diag logger-fd.
	+ commit 129def87b262241483ba3a8b6771ad6d07c2e3be
	* src/assuan-support.c (my_spawn): Add hack to
	mark the logger fd for w32spawn translation.

2019-03-20  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Handle diagnostic audit log for CMS.
	+ commit 47369569e23482bdd24a136b071192352b1d1347
	* lang/qt/src/threadedjobmixin.cpp(_detail::audit_log_as_html):
	Handle CMS audit log.

2019-03-19  Werner Koch  <wk@gnupg.org>
	    Andre Heinecke  <aheinecke@gnupg.org>

	core: Support GPGME_AUDITLOG_DIAG for gpgsm.
	+ commit dd21ec997cf4b6ba18538c63c728478110ad1f60
	* src/engine-gpgsm.c (struct engine_gpgsm): Add fields diag_cb and
	diagnostics.
	(close_notify_handler): Close the diag fd on status fd close.
	Handle diag close.
	(gpgsm_cancel): Handle diag.
	(gpgsm_release): Free DIAGNOSTICS.
	(gpgsm_new): Support the diag feature.
	(start): Set a handler for the diag fd.
	(gpgsm_getauditlog): Support GPGME_AUDITLOG_DIAG.

2019-03-13  Andre Heinecke  <aheinecke@gnupg.org>

	cpp: Fix Error::hasSystemError.
	+ commit c4cc47ee8f0bedc58e58ab416689d7014b0df2e7
	* lang/cpp/src/context.cpp (Error::hasSystemError): Invert logic to
	do what it says.

2019-02-28  Werner Koch  <wk@gnupg.org>

	json: Fix cosmetic error in the repl.
	+ commit 1bdab961c51fc038c33ae8116595aa0213ab1dd5
	* src/gpgme-json.c (native_messaging_repl): Use correct var with sizeof.

	tests: Let run-verify print the de-vs flag.
	+ commit b159b2eddd9df5df6cc8f29bd999cf1603c56991
	* tests/run-verify.c (print_result): Chack is_de_vs.
	* tests/run-import.c (main): Fix bad parameter for format string.

2019-02-27  Andre Heinecke  <aheinecke@gnupg.org>

	json: Limit recursion depth.
	+ commit 4a117859e7a512458ab78cfedfae0372805196b1
	* src/cJSON.c (MAX_DEPTH): New. Maximum recursion depth.
	(parse_value, parse_array, parse_object): Carry and check
	depth argument.
	(cJSON_ParseWithOpts): Initialize depth.

2019-02-21  Andre Heinecke  <aheinecke@gnupg.org>

	cpp: Add ostream operators for import result.
	+ commit 73b2f40ae5e6881991dea609b0781373b28d7d30
	* lang/cpp/src/importresult.cpp: Add ostream operators.
	* lang/cpp/src/importresult.h: Update accordingly.

	cpp: Make GpgME::Data::toKeys really const.
	+ commit 6175025c822678102c3f089e37952aa84b19a3ec
	* lang/cpp/src/data.cpp (GpgME::Data::toKeys): Rewind afterards.

2019-02-19  Werner Koch  <wk@gnupg.org>

	core,w32: Fix missing sentinel in dir name builder.
	+ commit 4c49417cc0dbd7f34269aff00fccafba150af744
	* src/w32-util.c (_gpgme_get_gpgconf_path): Add NULL top strconcat.

2019-02-11  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Fix memleak in run-threaded.
	+ commit f8312d7c333193582dcb5816198219b9564023f0
	* tests/run-threaded.c (verify): Free msg.

2019-02-10  Ben McGinnes  <ben@adversary.org>

	python: examples.
	+ commit 302d5ef52e095378231efd54677b5c315354ad78
	* A rather obvious variant of the existing key import examples, except
	  directed at Mailvelope's keyserver.
	* Yeah, Werner, I know ... but it exists because I used it and there's
	  no harm in sharing.

2019-01-30  Ben McGinnes  <ben@adversary.org>

	python: docs.
	+ commit e005052f4d5b29beda2252f8042dbf5728f5e2aa
	* Version bump in preparation for whenever GPGME 1.13.0 happens.
	* Ran the post_installer.py for docs preparation again.

2019-01-27  Ben McGinnes  <ben@adversary.org>

	python: post installer script.
	+ commit 2de1e599770cdb129b84302d963f65fdd3ddd2a4
	* Removed auto-generated .texi files from doc/src/ so only the
	  corrected versions are left.
	* Which means now it is complete, but with the initial work to expand
	  it with info file generation later.

	python: post installer docs fix script.
	+ commit 1e265723653042bc1010b457537b69a2011b43b7
	* Moved post_installer.py into the examples/howto/ directory.
	* Added instructions for its use to the Python Bindings HOWTO.
	* Ran it as intended from the lang/python/ directory in order to both
	  prove it works and quickly and easily get the updated howto
	  replicated.  Also to fix all those .texi files.

2019-01-25  Werner Koch  <wk@gnupg.org>

	json: Better use gpgme_free.
	+ commit ed81892917f47dddc23aa99d88733e3f8f344256
	* src/gpgme-json.c (subkey_to_json): here

	json: Fix minor memory leaks.
	+ commit 7f2423371964263784252cf839269023b6573bd2
	* src/gpgme-json.c (interactive_repl): Fix memleak.
	(subkey_to_json): Ditto
	(op_config): Delay init of j_comps to avoid a leak on error.

2019-01-16  NIIBE Yutaka  <gniibe@fsij.org>

	build: With LD_LIBRARY_PATH defined, use --disable-new-dtags.
	+ commit 66bcb8acb2452cf19318023ed0ff1ea7d7bb8439
	* configure.ac (LDADD_FOR_TESTS_KLUDGE): New for --disable-new-dtags.
	* tests/Makefile.am (LDADD): Use LDADD_FOR_TESTS_KLUDGE.
	* lang/cpp/tests/Makefile.am, lang/qt/tests/Makefile.am: Likewise.
	* tests/gpg/Makefile.am, tests/gpgsm/Makefile.am: Likewise.
	* tests/json/Makefile.am, tests/opassuan/Makefile.am: Likewise.

2019-01-15  Andre Heinecke  <aheinecke@gnupg.org>

	tests: Add diagnostic example to run-import.c.
	+ commit ce327f994a2888b807b63cf202ddcecc3fb9c685
	* tests/run-import.c (main): Show diagnostics in verbose mode.

2019-01-09  Andre Heinecke  <aheinecke@gnupg.org>

	qt: Use tofu conflict test keys without expiry.
	+ commit 66376f3e206a1aa791d712fb8577bb3490268f60
	* lang/qt/tests/t-tofuinfo.cpp: Use new test keys without
	expiry.

2019-01-02  Ben McGinnes  <ben@adversary.org>

	python docs: post installer.
	+ commit a0dbdfebbb60f0d34dd16894803e95221d8be668
	* Merging post installer script.
	* Included ammended Sphinx config file to try to reduce the
	  auto-generated EPUB validation failures it produces.

	python: post installer doc fix script.
	+ commit a2e7c863c821ca035f1e3f8077bdae3b0f81f5eb
	* Got rid of the bash bit in the comments.
	* Made the final printed instructions far more obvious.

	python: examples.
	+ commit 207d4289d84971d11ec1824fbe7d4a2be63b56e4
	* Fixed inter-edit.py so it will actually work now.
	* made 3 others executable.
	* Fixed the semantics of assuan.py's instructions.

2018-12-26  Ben McGinnes  <ben@adversary.org>

	python: examples.
	+ commit d406471d4bf9c79140e4bc91de7d316ec7465892
	* Fixed inter-edit.py so it will actually work now.
	* made 3 others executable.
	* Fixed the semantics of assuan.py's instructions.

2018-12-24  Ben McGinnes  <ben@adversary.org>

	python: docs processing.
	+ commit ef9355c2fe8f81ccd73e0ed45ce33e925928f8e1
	* Added some EPUB specific config options to the Sphinx config file
	  which might help reduce some of Sphinx's more stupid default errors
	  with EPUB validation.
	* Added lang/python/post_installer.py script for automating the
	  generation of .texi and .rst "source" files from the real source
	  files written in Org mode.  Includes recreating the Sphinx Makefile
	  which is excluded due to the m4 toolchain in parent directories, it
	  also handles the rewriting of the reST index file properly and
	  rewrites the .texi files so they don't impale themselves on Unicode.

2018-12-21  Ben McGinnes  <ben@adversary.org>

	python: docs.
	+ commit 06bca0eaa8de8405fafc892ab7864990f8853bcf
	* Found a bug in org-mode's export to texinfo function which will
	  require either manual modification of each file or a customs sed run
	  over the generated files for all updates.
	* Manually updated the current files for now, but will need to add
	  some post-install processing scripts for future use (I already have
	  some of these for my specific setup, they just need to be made a
	  little more generic and platform independent for here).

	python: groups example.
	+ commit dc5f416351e47bfafb46a53f8fd8435dd6c231ba
	* Tightened code a little more.

2018-12-17  Ben McGinnes  <ben@adversary.org>

	python docs: house keeping.
	+ commit daded4925489d306f6a65271c2f55101b331187c
	* Dropped the ASCII copyright line, since even MS have conceded their
	  battle against Unicode enough to load UTF-8.
	* Fixed the drafts section since there will be less need of multiple
	  output format testing from next year.

2018-12-17  Werner Koch  <wk@gnupg.org>

	core: Silence newer compiler warnings.
	+ commit 8b41fb08f00f01fe0dd8b2b5455d3422d97ddc60
	* configure.ac: Add -Wno-format-truncation and
	  -Wno-sizeof-pointer-div.
	* src/b64dec.c (_gpgme_b64dec_proc): Add fallthrough annotation.
	* src/cJSON.c (parse_string): Ditto.
	* src/gpgme-json.c (main): Ditto.

2018-12-16  Ben McGinnes  <ben@adversary.org>

	python: howto and examples.
	+ commit fbc298dc1b0fbb51ebc92a9d56c45b78c5e9989d
	* Tightening up both the documentation and some of the example code.

2018-12-13  Ben McGinnes  <ben@adversary.org>

	python: examples bugfix.
	+ commit 4308d172816f3172454fac1dc0771014056764a1
	* Fixed a bug in the ProtonMail importers (pmkey-*.py) where multiple
	  keys found for a username would always result in the last email
	  address checked being returned in the printed output for all located
	  keys.

2018-12-12  Ben McGinnes  <ben@adversary.org>

	python: new example script.
	+ commit 3849b60e22432ef33f0d1d39b88e07922ad7779e
	* Though Keybase really should not be encouraged due to
	  disengenuosness and FUD emanating from that souce, this new script
	  will obtain a key hosted on that site and import it when supplied
	  with the keybase username.

	python: what's new summary.
	+ commit 3ca7cf07f5d3ec4af89e69ed13ea7ab701e33c03
	* Added a little more detail to the what's new section.

	python: advanced howto example.
	+ commit 64758a0dac4c7c3b312dccbc1661813e2c3e2888
	* Added Cython requirement to this advanced use case.

	python: howto examples equirements.
